/* Device.c generated by valac 0.44.3, the Vala compiler
 * generated from Device.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/* This is a read-only class, set the properties via PulseAudioManager.*/

#include <glib-object.h>
#include <gee.h>
#include <pulse/pulseaudio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define SOUND_TYPE_DEVICE (sound_device_get_type ())
#define SOUND_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE, SoundDevice))
#define SOUND_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE, SoundDeviceClass))
#define SOUND_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE))
#define SOUND_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE))
#define SOUND_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE, SoundDeviceClass))

typedef struct _SoundDevice SoundDevice;
typedef struct _SoundDeviceClass SoundDeviceClass;
typedef struct _SoundDevicePrivate SoundDevicePrivate;
enum  {
	SOUND_DEVICE_0_PROPERTY,
	SOUND_DEVICE_INPUT_PROPERTY,
	SOUND_DEVICE_ID_PROPERTY,
	SOUND_DEVICE_CARD_NAME_PROPERTY,
	SOUND_DEVICE_CARD_INDEX_PROPERTY,
	SOUND_DEVICE_PORT_NAME_PROPERTY,
	SOUND_DEVICE_DISPLAY_NAME_PROPERTY,
	SOUND_DEVICE_FORM_FACTOR_PROPERTY,
	SOUND_DEVICE_PROFILES_PROPERTY,
	SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY,
	SOUND_DEVICE_SINK_NAME_PROPERTY,
	SOUND_DEVICE_SINK_INDEX_PROPERTY,
	SOUND_DEVICE_CARD_SINK_NAME_PROPERTY,
	SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY,
	SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY,
	SOUND_DEVICE_SOURCE_NAME_PROPERTY,
	SOUND_DEVICE_SOURCE_INDEX_PROPERTY,
	SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY,
	SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY,
	SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY,
	SOUND_DEVICE_IS_DEFAULT_PROPERTY,
	SOUND_DEVICE_IS_MUTED_PROPERTY,
	SOUND_DEVICE_VOLUME_PROPERTY,
	SOUND_DEVICE_BALANCE_PROPERTY,
	SOUND_DEVICE_NUM_PROPERTIES
};
static GParamSpec* sound_device_properties[SOUND_DEVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define SOUND_DEVICE_TYPE_PORT (sound_device_port_get_type ())
#define SOUND_DEVICE_PORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_DEVICE_TYPE_PORT, SoundDevicePort))
#define SOUND_DEVICE_PORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_DEVICE_TYPE_PORT, SoundDevicePortClass))
#define SOUND_DEVICE_IS_PORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_DEVICE_TYPE_PORT))
#define SOUND_DEVICE_IS_PORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_DEVICE_TYPE_PORT))
#define SOUND_DEVICE_PORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_DEVICE_TYPE_PORT, SoundDevicePortClass))

typedef struct _SoundDevicePort SoundDevicePort;
typedef struct _SoundDevicePortClass SoundDevicePortClass;
typedef struct _SoundDevicePortPrivate SoundDevicePortPrivate;
typedef struct _SoundDeviceParamSpecPort SoundDeviceParamSpecPort;
enum  {
	SOUND_DEVICE_REMOVED_SIGNAL,
	SOUND_DEVICE_NUM_SIGNALS
};
static guint sound_device_signals[SOUND_DEVICE_NUM_SIGNALS] = {0};

struct _SoundDevice {
	GObject parent_instance;
	SoundDevicePrivate * priv;
	GeeLinkedList* volume_operations;
};

struct _SoundDeviceClass {
	GObjectClass parent_class;
};

struct _SoundDevicePrivate {
	gboolean _input;
	gchar* _id;
	gchar* _card_name;
	guint32 _card_index;
	gchar* _port_name;
	gchar* _display_name;
	gchar* _form_factor;
	GeeArrayList* _profiles;
	gchar* _card_active_profile_name;
	gchar* _sink_name;
	gint _sink_index;
	gchar* _card_sink_name;
	gchar* _card_sink_port_name;
	gint _card_sink_index;
	gchar* _source_name;
	gint _source_index;
	gchar* _card_source_name;
	gchar* _card_source_port_name;
	gint _card_source_index;
	gboolean _is_default;
	gboolean _is_muted;
	pa_cvolume _cvolume;
	gdouble _volume;
	gfloat _balance;
	pa_channel_map _channel_map;
};

struct _SoundDevicePort {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SoundDevicePortPrivate * priv;
	gchar* name;
	gchar* description;
	guint32 priority;
};

struct _SoundDevicePortClass {
	GTypeClass parent_class;
	void (*finalize) (SoundDevicePort *self);
};

struct _SoundDeviceParamSpecPort {
	GParamSpec parent_instance;
};

static gint SoundDevice_private_offset;
static gpointer sound_device_parent_class = NULL;
static gpointer sound_device_port_parent_class = NULL;

GType sound_device_get_type (void) G_GNUC_CONST;
SoundDevice* sound_device_new (const gchar* id,
                               guint32 card_index,
                               const gchar* port_name);
SoundDevice* sound_device_construct (GType object_type,
                                     const gchar* id,
                                     guint32 card_index,
                                     const gchar* port_name);
gchar* sound_device_get_nice_form_factor (SoundDevice* self);
const gchar* sound_device_get_form_factor (SoundDevice* self);
gboolean sound_device_get_input (SoundDevice* self);
gchar* sound_device_get_matching_profile (SoundDevice* self,
                                          SoundDevice* other_device);
GeeArrayList* sound_device_get_profiles (SoundDevice* self);
void sound_device_set_input (SoundDevice* self,
                             gboolean value);
const gchar* sound_device_get_id (SoundDevice* self);
static void sound_device_set_id (SoundDevice* self,
                          const gchar* value);
const gchar* sound_device_get_card_name (SoundDevice* self);
void sound_device_set_card_name (SoundDevice* self,
                                 const gchar* value);
guint32 sound_device_get_card_index (SoundDevice* self);
static void sound_device_set_card_index (SoundDevice* self,
                                  guint32 value);
const gchar* sound_device_get_port_name (SoundDevice* self);
static void sound_device_set_port_name (SoundDevice* self,
                                 const gchar* value);
const gchar* sound_device_get_display_name (SoundDevice* self);
void sound_device_set_display_name (SoundDevice* self,
                                    const gchar* value);
void sound_device_set_form_factor (SoundDevice* self,
                                   const gchar* value);
void sound_device_set_profiles (SoundDevice* self,
                                GeeArrayList* value);
const gchar* sound_device_get_card_active_profile_name (SoundDevice* self);
void sound_device_set_card_active_profile_name (SoundDevice* self,
                                                const gchar* value);
const gchar* sound_device_get_sink_name (SoundDevice* self);
void sound_device_set_sink_name (SoundDevice* self,
                                 const gchar* value);
gint sound_device_get_sink_index (SoundDevice* self);
void sound_device_set_sink_index (SoundDevice* self,
                                  gint value);
const gchar* sound_device_get_card_sink_name (SoundDevice* self);
void sound_device_set_card_sink_name (SoundDevice* self,
                                      const gchar* value);
const gchar* sound_device_get_card_sink_port_name (SoundDevice* self);
void sound_device_set_card_sink_port_name (SoundDevice* self,
                                           const gchar* value);
gint sound_device_get_card_sink_index (SoundDevice* self);
void sound_device_set_card_sink_index (SoundDevice* self,
                                       gint value);
const gchar* sound_device_get_source_name (SoundDevice* self);
void sound_device_set_source_name (SoundDevice* self,
                                   const gchar* value);
gint sound_device_get_source_index (SoundDevice* self);
void sound_device_set_source_index (SoundDevice* self,
                                    gint value);
const gchar* sound_device_get_card_source_name (SoundDevice* self);
void sound_device_set_card_source_name (SoundDevice* self,
                                        const gchar* value);
const gchar* sound_device_get_card_source_port_name (SoundDevice* self);
void sound_device_set_card_source_port_name (SoundDevice* self,
                                             const gchar* value);
gint sound_device_get_card_source_index (SoundDevice* self);
void sound_device_set_card_source_index (SoundDevice* self,
                                         gint value);
gboolean sound_device_get_is_default (SoundDevice* self);
void sound_device_set_is_default (SoundDevice* self,
                                  gboolean value);
gboolean sound_device_get_is_muted (SoundDevice* self);
void sound_device_set_is_muted (SoundDevice* self,
                                gboolean value);
void sound_device_get_cvolume (SoundDevice* self,
                               pa_cvolume * result);
void sound_device_set_cvolume (SoundDevice* self,
                               pa_cvolume * value);
gdouble sound_device_get_volume (SoundDevice* self);
void sound_device_set_volume (SoundDevice* self,
                              gdouble value);
gfloat sound_device_get_balance (SoundDevice* self);
void sound_device_set_balance (SoundDevice* self,
                               gfloat value);
void sound_device_get_channel_map (SoundDevice* self,
                                   pa_channel_map * result);
void sound_device_set_channel_map (SoundDevice* self,
                                   pa_channel_map * value);
static GObject * sound_device_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
gpointer sound_device_port_ref (gpointer instance);
void sound_device_port_unref (gpointer instance);
GParamSpec* sound_device_param_spec_port (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void sound_device_value_set_port (GValue* value,
                                  gpointer v_object);
void sound_device_value_take_port (GValue* value,
                                   gpointer v_object);
gpointer sound_device_value_get_port (const GValue* value);
GType sound_device_port_get_type (void) G_GNUC_CONST;
SoundDevicePort* sound_device_port_new (void);
SoundDevicePort* sound_device_port_construct (GType object_type);
static void sound_device_port_finalize (SoundDevicePort * obj);
static void sound_device_finalize (GObject * obj);
static void _vala_sound_device_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_sound_device_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
sound_device_get_instance_private (SoundDevice* self)
{
	return G_STRUCT_MEMBER_P (self, SoundDevice_private_offset);
}

SoundDevice*
sound_device_construct (GType object_type,
                        const gchar* id,
                        guint32 card_index,
                        const gchar* port_name)
{
	SoundDevice * self = NULL;
#line 67 "../src/Device.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 67 "../src/Device.vala"
	g_return_val_if_fail (port_name != NULL, NULL);
#line 68 "../src/Device.vala"
	self = (SoundDevice*) g_object_new (object_type, "id", id, "card-index", card_index, "port-name", port_name, NULL);
#line 67 "../src/Device.vala"
	return self;
#line 295 "Device.c"
}

SoundDevice*
sound_device_new (const gchar* id,
                  guint32 card_index,
                  const gchar* port_name)
{
#line 67 "../src/Device.vala"
	return sound_device_construct (SOUND_TYPE_DEVICE, id, card_index, port_name);
#line 305 "Device.c"
}

gchar*
sound_device_get_nice_form_factor (SoundDevice* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label0 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label1 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label2 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label3 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label4 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label5 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label6 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label7 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label8 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label9 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label10 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label11 = 0;
#line 77 "../src/Device.vala"
	static GQuark _tmp2_label12 = 0;
#line 76 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 77 "../src/Device.vala"
	_tmp0_ = self->priv->_form_factor;
#line 77 "../src/Device.vala"
	_tmp1_ = _tmp0_;
#line 77 "../src/Device.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 77 "../src/Device.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("internal")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 353 "Device.c"
			default:
			{
				gchar* _tmp4_;
#line 79 "../src/Device.vala"
				_tmp4_ = g_strdup (_ ("Built-in"));
#line 79 "../src/Device.vala"
				result = _tmp4_;
#line 79 "../src/Device.vala"
				return result;
#line 363 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("speaker")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 369 "Device.c"
			default:
			{
				gchar* _tmp5_;
#line 81 "../src/Device.vala"
				_tmp5_ = g_strdup (_ ("Speaker"));
#line 81 "../src/Device.vala"
				result = _tmp5_;
#line 81 "../src/Device.vala"
				return result;
#line 379 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("handset")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 385 "Device.c"
			default:
			{
				gchar* _tmp6_;
#line 83 "../src/Device.vala"
				_tmp6_ = g_strdup (_ ("Handset"));
#line 83 "../src/Device.vala"
				result = _tmp6_;
#line 83 "../src/Device.vala"
				return result;
#line 395 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("tv")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 401 "Device.c"
			default:
			{
				gchar* _tmp7_;
#line 85 "../src/Device.vala"
				_tmp7_ = g_strdup (_ ("TV"));
#line 85 "../src/Device.vala"
				result = _tmp7_;
#line 85 "../src/Device.vala"
				return result;
#line 411 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("webcam")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 417 "Device.c"
			default:
			{
				gchar* _tmp8_;
#line 87 "../src/Device.vala"
				_tmp8_ = g_strdup (_ ("Webcam"));
#line 87 "../src/Device.vala"
				result = _tmp8_;
#line 87 "../src/Device.vala"
				return result;
#line 427 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("microphone")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 433 "Device.c"
			default:
			{
				gchar* _tmp9_;
#line 89 "../src/Device.vala"
				_tmp9_ = g_strdup (_ ("Microphone"));
#line 89 "../src/Device.vala"
				result = _tmp9_;
#line 89 "../src/Device.vala"
				return result;
#line 443 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("headset")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 449 "Device.c"
			default:
			{
				gchar* _tmp10_;
#line 91 "../src/Device.vala"
				_tmp10_ = g_strdup (_ ("Headset"));
#line 91 "../src/Device.vala"
				result = _tmp10_;
#line 91 "../src/Device.vala"
				return result;
#line 459 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("headphone")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 465 "Device.c"
			default:
			{
				gchar* _tmp11_;
#line 93 "../src/Device.vala"
				_tmp11_ = g_strdup (_ ("Headphone"));
#line 93 "../src/Device.vala"
				result = _tmp11_;
#line 93 "../src/Device.vala"
				return result;
#line 475 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("hands-free")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 481 "Device.c"
			default:
			{
				gchar* _tmp12_;
#line 95 "../src/Device.vala"
				_tmp12_ = g_strdup (_ ("Hands-Free"));
#line 95 "../src/Device.vala"
				result = _tmp12_;
#line 95 "../src/Device.vala"
				return result;
#line 491 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("car")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 497 "Device.c"
			default:
			{
				gchar* _tmp13_;
#line 97 "../src/Device.vala"
				_tmp13_ = g_strdup (_ ("Car"));
#line 97 "../src/Device.vala"
				result = _tmp13_;
#line 97 "../src/Device.vala"
				return result;
#line 507 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("hifi")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 513 "Device.c"
			default:
			{
				gchar* _tmp14_;
#line 99 "../src/Device.vala"
				_tmp14_ = g_strdup (_ ("HiFi"));
#line 99 "../src/Device.vala"
				result = _tmp14_;
#line 99 "../src/Device.vala"
				return result;
#line 523 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("computer")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 529 "Device.c"
			default:
			{
				gchar* _tmp15_;
#line 101 "../src/Device.vala"
				_tmp15_ = g_strdup (_ ("Computer"));
#line 101 "../src/Device.vala"
				result = _tmp15_;
#line 101 "../src/Device.vala"
				return result;
#line 539 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("portable")))) {
#line 77 "../src/Device.vala"
		switch (0) {
#line 545 "Device.c"
			default:
			{
				gchar* _tmp16_;
#line 103 "../src/Device.vala"
				_tmp16_ = g_strdup (_ ("Portable"));
#line 103 "../src/Device.vala"
				result = _tmp16_;
#line 103 "../src/Device.vala"
				return result;
#line 555 "Device.c"
			}
		}
	} else {
#line 77 "../src/Device.vala"
		switch (0) {
#line 561 "Device.c"
			default:
			{
				const gchar* _tmp17_ = NULL;
				gboolean _tmp18_;
				gchar* _tmp19_;
#line 105 "../src/Device.vala"
				_tmp18_ = self->priv->_input;
#line 105 "../src/Device.vala"
				if (_tmp18_) {
#line 105 "../src/Device.vala"
					_tmp17_ = _ ("Input");
#line 573 "Device.c"
				} else {
#line 105 "../src/Device.vala"
					_tmp17_ = _ ("Output");
#line 577 "Device.c"
				}
#line 105 "../src/Device.vala"
				_tmp19_ = g_strdup (_tmp17_);
#line 105 "../src/Device.vala"
				result = _tmp19_;
#line 105 "../src/Device.vala"
				return result;
#line 585 "Device.c"
			}
		}
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 110 "../src/Device.vala"
	return self ? g_object_ref (self) : NULL;
#line 596 "Device.c"
}

gchar*
sound_device_get_matching_profile (SoundDevice* self,
                                   SoundDevice* other_device)
{
	gchar* result = NULL;
#line 109 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 109 "../src/Device.vala"
	g_return_val_if_fail (other_device != NULL, NULL);
#line 608 "Device.c"
	{
		GeeArrayList* _profile_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _profile_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _profile_index = 0;
#line 110 "../src/Device.vala"
		_tmp0_ = self->priv->_profiles;
#line 110 "../src/Device.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 110 "../src/Device.vala"
		_profile_list = _tmp1_;
#line 110 "../src/Device.vala"
		_tmp2_ = _profile_list;
#line 110 "../src/Device.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 110 "../src/Device.vala"
		_tmp4_ = _tmp3_;
#line 110 "../src/Device.vala"
		_profile_size = _tmp4_;
#line 110 "../src/Device.vala"
		_profile_index = -1;
#line 110 "../src/Device.vala"
		while (TRUE) {
#line 636 "Device.c"
			gchar* profile = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			GeeArrayList* _tmp7_;
			const gchar* _tmp8_;
#line 110 "../src/Device.vala"
			_profile_index = _profile_index + 1;
#line 110 "../src/Device.vala"
			if (!(_profile_index < _profile_size)) {
#line 110 "../src/Device.vala"
				break;
#line 648 "Device.c"
			}
#line 110 "../src/Device.vala"
			_tmp5_ = _profile_list;
#line 110 "../src/Device.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _profile_index);
#line 110 "../src/Device.vala"
			profile = (gchar*) _tmp6_;
#line 111 "../src/Device.vala"
			_tmp7_ = other_device->priv->_profiles;
#line 111 "../src/Device.vala"
			_tmp8_ = profile;
#line 111 "../src/Device.vala"
			if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp7_, _tmp8_)) {
#line 112 "../src/Device.vala"
				result = profile;
#line 112 "../src/Device.vala"
				_g_object_unref0 (_profile_list);
#line 112 "../src/Device.vala"
				return result;
#line 668 "Device.c"
			}
#line 110 "../src/Device.vala"
			_g_free0 (profile);
#line 672 "Device.c"
		}
#line 110 "../src/Device.vala"
		_g_object_unref0 (_profile_list);
#line 676 "Device.c"
	}
#line 116 "../src/Device.vala"
	result = NULL;
#line 116 "../src/Device.vala"
	return result;
#line 682 "Device.c"
}

gboolean
sound_device_get_input (SoundDevice* self)
{
	gboolean result;
#line 34 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../src/Device.vala"
	result = self->priv->_input;
#line 34 "../src/Device.vala"
	return result;
#line 695 "Device.c"
}

void
sound_device_set_input (SoundDevice* self,
                        gboolean value)
{
#line 34 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Device.vala"
	if (sound_device_get_input (self) != value) {
#line 34 "../src/Device.vala"
		self->priv->_input = value;
#line 34 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_INPUT_PROPERTY]);
#line 710 "Device.c"
	}
}

const gchar*
sound_device_get_id (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Device.vala"
	_tmp0_ = self->priv->_id;
#line 35 "../src/Device.vala"
	result = _tmp0_;
#line 35 "../src/Device.vala"
	return result;
#line 727 "Device.c"
}

static void
sound_device_set_id (SoundDevice* self,
                     const gchar* value)
{
#line 35 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_id (self)) != 0) {
#line 738 "Device.c"
		gchar* _tmp0_;
#line 35 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../src/Device.vala"
		_g_free0 (self->priv->_id);
#line 35 "../src/Device.vala"
		self->priv->_id = _tmp0_;
#line 35 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_ID_PROPERTY]);
#line 748 "Device.c"
	}
}

const gchar*
sound_device_get_card_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/Device.vala"
	_tmp0_ = self->priv->_card_name;
#line 36 "../src/Device.vala"
	result = _tmp0_;
#line 36 "../src/Device.vala"
	return result;
#line 765 "Device.c"
}

void
sound_device_set_card_name (SoundDevice* self,
                            const gchar* value)
{
#line 36 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_card_name (self)) != 0) {
#line 776 "Device.c"
		gchar* _tmp0_;
#line 36 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 36 "../src/Device.vala"
		_g_free0 (self->priv->_card_name);
#line 36 "../src/Device.vala"
		self->priv->_card_name = _tmp0_;
#line 36 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_NAME_PROPERTY]);
#line 786 "Device.c"
	}
}

guint32
sound_device_get_card_index (SoundDevice* self)
{
	guint32 result;
#line 37 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 37 "../src/Device.vala"
	result = self->priv->_card_index;
#line 37 "../src/Device.vala"
	return result;
#line 800 "Device.c"
}

static void
sound_device_set_card_index (SoundDevice* self,
                             guint32 value)
{
#line 37 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Device.vala"
	if (sound_device_get_card_index (self) != value) {
#line 37 "../src/Device.vala"
		self->priv->_card_index = value;
#line 37 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_INDEX_PROPERTY]);
#line 815 "Device.c"
	}
}

const gchar*
sound_device_get_port_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 38 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Device.vala"
	_tmp0_ = self->priv->_port_name;
#line 38 "../src/Device.vala"
	result = _tmp0_;
#line 38 "../src/Device.vala"
	return result;
#line 832 "Device.c"
}

static void
sound_device_set_port_name (SoundDevice* self,
                            const gchar* value)
{
#line 38 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_port_name (self)) != 0) {
#line 843 "Device.c"
		gchar* _tmp0_;
#line 38 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 38 "../src/Device.vala"
		_g_free0 (self->priv->_port_name);
#line 38 "../src/Device.vala"
		self->priv->_port_name = _tmp0_;
#line 38 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_PORT_NAME_PROPERTY]);
#line 853 "Device.c"
	}
}

const gchar*
sound_device_get_display_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 39 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Device.vala"
	_tmp0_ = self->priv->_display_name;
#line 39 "../src/Device.vala"
	result = _tmp0_;
#line 39 "../src/Device.vala"
	return result;
#line 870 "Device.c"
}

void
sound_device_set_display_name (SoundDevice* self,
                               const gchar* value)
{
#line 39 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_display_name (self)) != 0) {
#line 881 "Device.c"
		gchar* _tmp0_;
#line 39 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 39 "../src/Device.vala"
		_g_free0 (self->priv->_display_name);
#line 39 "../src/Device.vala"
		self->priv->_display_name = _tmp0_;
#line 39 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_DISPLAY_NAME_PROPERTY]);
#line 891 "Device.c"
	}
}

const gchar*
sound_device_get_form_factor (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 40 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/Device.vala"
	_tmp0_ = self->priv->_form_factor;
#line 40 "../src/Device.vala"
	result = _tmp0_;
#line 40 "../src/Device.vala"
	return result;
#line 908 "Device.c"
}

void
sound_device_set_form_factor (SoundDevice* self,
                              const gchar* value)
{
#line 40 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_form_factor (self)) != 0) {
#line 919 "Device.c"
		gchar* _tmp0_;
#line 40 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 40 "../src/Device.vala"
		_g_free0 (self->priv->_form_factor);
#line 40 "../src/Device.vala"
		self->priv->_form_factor = _tmp0_;
#line 40 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_FORM_FACTOR_PROPERTY]);
#line 929 "Device.c"
	}
}

GeeArrayList*
sound_device_get_profiles (SoundDevice* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 41 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Device.vala"
	_tmp0_ = self->priv->_profiles;
#line 41 "../src/Device.vala"
	result = _tmp0_;
#line 41 "../src/Device.vala"
	return result;
#line 946 "Device.c"
}

void
sound_device_set_profiles (SoundDevice* self,
                           GeeArrayList* value)
{
#line 41 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Device.vala"
	if (sound_device_get_profiles (self) != value) {
#line 957 "Device.c"
		GeeArrayList* _tmp0_;
#line 41 "../src/Device.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 41 "../src/Device.vala"
		_g_object_unref0 (self->priv->_profiles);
#line 41 "../src/Device.vala"
		self->priv->_profiles = _tmp0_;
#line 41 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_PROFILES_PROPERTY]);
#line 967 "Device.c"
	}
}

const gchar*
sound_device_get_card_active_profile_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 42 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/Device.vala"
	_tmp0_ = self->priv->_card_active_profile_name;
#line 42 "../src/Device.vala"
	result = _tmp0_;
#line 42 "../src/Device.vala"
	return result;
#line 984 "Device.c"
}

void
sound_device_set_card_active_profile_name (SoundDevice* self,
                                           const gchar* value)
{
#line 42 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_card_active_profile_name (self)) != 0) {
#line 995 "Device.c"
		gchar* _tmp0_;
#line 42 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 42 "../src/Device.vala"
		_g_free0 (self->priv->_card_active_profile_name);
#line 42 "../src/Device.vala"
		self->priv->_card_active_profile_name = _tmp0_;
#line 42 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY]);
#line 1005 "Device.c"
	}
}

const gchar*
sound_device_get_sink_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 45 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/Device.vala"
	_tmp0_ = self->priv->_sink_name;
#line 45 "../src/Device.vala"
	result = _tmp0_;
#line 45 "../src/Device.vala"
	return result;
#line 1022 "Device.c"
}

void
sound_device_set_sink_name (SoundDevice* self,
                            const gchar* value)
{
#line 45 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_sink_name (self)) != 0) {
#line 1033 "Device.c"
		gchar* _tmp0_;
#line 45 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 45 "../src/Device.vala"
		_g_free0 (self->priv->_sink_name);
#line 45 "../src/Device.vala"
		self->priv->_sink_name = _tmp0_;
#line 45 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_SINK_NAME_PROPERTY]);
#line 1043 "Device.c"
	}
}

gint
sound_device_get_sink_index (SoundDevice* self)
{
	gint result;
#line 46 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "../src/Device.vala"
	result = self->priv->_sink_index;
#line 46 "../src/Device.vala"
	return result;
#line 1057 "Device.c"
}

void
sound_device_set_sink_index (SoundDevice* self,
                             gint value)
{
#line 46 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Device.vala"
	if (sound_device_get_sink_index (self) != value) {
#line 46 "../src/Device.vala"
		self->priv->_sink_index = value;
#line 46 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_SINK_INDEX_PROPERTY]);
#line 1072 "Device.c"
	}
}

const gchar*
sound_device_get_card_sink_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 47 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../src/Device.vala"
	_tmp0_ = self->priv->_card_sink_name;
#line 47 "../src/Device.vala"
	result = _tmp0_;
#line 47 "../src/Device.vala"
	return result;
#line 1089 "Device.c"
}

void
sound_device_set_card_sink_name (SoundDevice* self,
                                 const gchar* value)
{
#line 47 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_card_sink_name (self)) != 0) {
#line 1100 "Device.c"
		gchar* _tmp0_;
#line 47 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 47 "../src/Device.vala"
		_g_free0 (self->priv->_card_sink_name);
#line 47 "../src/Device.vala"
		self->priv->_card_sink_name = _tmp0_;
#line 47 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SINK_NAME_PROPERTY]);
#line 1110 "Device.c"
	}
}

const gchar*
sound_device_get_card_sink_port_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 48 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/Device.vala"
	_tmp0_ = self->priv->_card_sink_port_name;
#line 48 "../src/Device.vala"
	result = _tmp0_;
#line 48 "../src/Device.vala"
	return result;
#line 1127 "Device.c"
}

void
sound_device_set_card_sink_port_name (SoundDevice* self,
                                      const gchar* value)
{
#line 48 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_card_sink_port_name (self)) != 0) {
#line 1138 "Device.c"
		gchar* _tmp0_;
#line 48 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 48 "../src/Device.vala"
		_g_free0 (self->priv->_card_sink_port_name);
#line 48 "../src/Device.vala"
		self->priv->_card_sink_port_name = _tmp0_;
#line 48 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY]);
#line 1148 "Device.c"
	}
}

gint
sound_device_get_card_sink_index (SoundDevice* self)
{
	gint result;
#line 49 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 49 "../src/Device.vala"
	result = self->priv->_card_sink_index;
#line 49 "../src/Device.vala"
	return result;
#line 1162 "Device.c"
}

void
sound_device_set_card_sink_index (SoundDevice* self,
                                  gint value)
{
#line 49 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Device.vala"
	if (sound_device_get_card_sink_index (self) != value) {
#line 49 "../src/Device.vala"
		self->priv->_card_sink_index = value;
#line 49 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY]);
#line 1177 "Device.c"
	}
}

const gchar*
sound_device_get_source_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 52 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/Device.vala"
	_tmp0_ = self->priv->_source_name;
#line 52 "../src/Device.vala"
	result = _tmp0_;
#line 52 "../src/Device.vala"
	return result;
#line 1194 "Device.c"
}

void
sound_device_set_source_name (SoundDevice* self,
                              const gchar* value)
{
#line 52 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_source_name (self)) != 0) {
#line 1205 "Device.c"
		gchar* _tmp0_;
#line 52 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 52 "../src/Device.vala"
		_g_free0 (self->priv->_source_name);
#line 52 "../src/Device.vala"
		self->priv->_source_name = _tmp0_;
#line 52 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_SOURCE_NAME_PROPERTY]);
#line 1215 "Device.c"
	}
}

gint
sound_device_get_source_index (SoundDevice* self)
{
	gint result;
#line 53 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 53 "../src/Device.vala"
	result = self->priv->_source_index;
#line 53 "../src/Device.vala"
	return result;
#line 1229 "Device.c"
}

void
sound_device_set_source_index (SoundDevice* self,
                               gint value)
{
#line 53 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/Device.vala"
	if (sound_device_get_source_index (self) != value) {
#line 53 "../src/Device.vala"
		self->priv->_source_index = value;
#line 53 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_SOURCE_INDEX_PROPERTY]);
#line 1244 "Device.c"
	}
}

const gchar*
sound_device_get_card_source_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../src/Device.vala"
	_tmp0_ = self->priv->_card_source_name;
#line 54 "../src/Device.vala"
	result = _tmp0_;
#line 54 "../src/Device.vala"
	return result;
#line 1261 "Device.c"
}

void
sound_device_set_card_source_name (SoundDevice* self,
                                   const gchar* value)
{
#line 54 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_card_source_name (self)) != 0) {
#line 1272 "Device.c"
		gchar* _tmp0_;
#line 54 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 54 "../src/Device.vala"
		_g_free0 (self->priv->_card_source_name);
#line 54 "../src/Device.vala"
		self->priv->_card_source_name = _tmp0_;
#line 54 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY]);
#line 1282 "Device.c"
	}
}

const gchar*
sound_device_get_card_source_port_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 55 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../src/Device.vala"
	_tmp0_ = self->priv->_card_source_port_name;
#line 55 "../src/Device.vala"
	result = _tmp0_;
#line 55 "../src/Device.vala"
	return result;
#line 1299 "Device.c"
}

void
sound_device_set_card_source_port_name (SoundDevice* self,
                                        const gchar* value)
{
#line 55 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_card_source_port_name (self)) != 0) {
#line 1310 "Device.c"
		gchar* _tmp0_;
#line 55 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 55 "../src/Device.vala"
		_g_free0 (self->priv->_card_source_port_name);
#line 55 "../src/Device.vala"
		self->priv->_card_source_port_name = _tmp0_;
#line 55 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY]);
#line 1320 "Device.c"
	}
}

gint
sound_device_get_card_source_index (SoundDevice* self)
{
	gint result;
#line 56 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 56 "../src/Device.vala"
	result = self->priv->_card_source_index;
#line 56 "../src/Device.vala"
	return result;
#line 1334 "Device.c"
}

void
sound_device_set_card_source_index (SoundDevice* self,
                                    gint value)
{
#line 56 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Device.vala"
	if (sound_device_get_card_source_index (self) != value) {
#line 56 "../src/Device.vala"
		self->priv->_card_source_index = value;
#line 56 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY]);
#line 1349 "Device.c"
	}
}

gboolean
sound_device_get_is_default (SoundDevice* self)
{
	gboolean result;
#line 59 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../src/Device.vala"
	result = self->priv->_is_default;
#line 59 "../src/Device.vala"
	return result;
#line 1363 "Device.c"
}

void
sound_device_set_is_default (SoundDevice* self,
                             gboolean value)
{
#line 59 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/Device.vala"
	if (sound_device_get_is_default (self) != value) {
#line 59 "../src/Device.vala"
		self->priv->_is_default = value;
#line 59 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_IS_DEFAULT_PROPERTY]);
#line 1378 "Device.c"
	}
}

gboolean
sound_device_get_is_muted (SoundDevice* self)
{
	gboolean result;
#line 60 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../src/Device.vala"
	result = self->priv->_is_muted;
#line 60 "../src/Device.vala"
	return result;
#line 1392 "Device.c"
}

void
sound_device_set_is_muted (SoundDevice* self,
                           gboolean value)
{
#line 60 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/Device.vala"
	if (sound_device_get_is_muted (self) != value) {
#line 60 "../src/Device.vala"
		self->priv->_is_muted = value;
#line 60 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_IS_MUTED_PROPERTY]);
#line 1407 "Device.c"
	}
}

void
sound_device_get_cvolume (SoundDevice* self,
                          pa_cvolume * result)
{
	pa_cvolume _tmp0_;
#line 61 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/Device.vala"
	_tmp0_ = self->priv->_cvolume;
#line 61 "../src/Device.vala"
	*result = _tmp0_;
#line 61 "../src/Device.vala"
	return;
#line 1424 "Device.c"
}

void
sound_device_set_cvolume (SoundDevice* self,
                          pa_cvolume * value)
{
	pa_cvolume _tmp0_;
#line 61 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/Device.vala"
	_tmp0_ = *value;
#line 61 "../src/Device.vala"
	self->priv->_cvolume = _tmp0_;
#line 1438 "Device.c"
}

gdouble
sound_device_get_volume (SoundDevice* self)
{
	gdouble result;
#line 62 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 62 "../src/Device.vala"
	result = self->priv->_volume;
#line 62 "../src/Device.vala"
	return result;
#line 1451 "Device.c"
}

void
sound_device_set_volume (SoundDevice* self,
                         gdouble value)
{
#line 62 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/Device.vala"
	if (sound_device_get_volume (self) != value) {
#line 62 "../src/Device.vala"
		self->priv->_volume = value;
#line 62 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_VOLUME_PROPERTY]);
#line 1466 "Device.c"
	}
}

gfloat
sound_device_get_balance (SoundDevice* self)
{
	gfloat result;
#line 63 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 63 "../src/Device.vala"
	result = self->priv->_balance;
#line 63 "../src/Device.vala"
	return result;
#line 1480 "Device.c"
}

void
sound_device_set_balance (SoundDevice* self,
                          gfloat value)
{
#line 63 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 63 "../src/Device.vala"
	if (sound_device_get_balance (self) != value) {
#line 63 "../src/Device.vala"
		self->priv->_balance = value;
#line 63 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_BALANCE_PROPERTY]);
#line 1495 "Device.c"
	}
}

void
sound_device_get_channel_map (SoundDevice* self,
                              pa_channel_map * result)
{
	pa_channel_map _tmp0_;
#line 64 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Device.vala"
	_tmp0_ = self->priv->_channel_map;
#line 64 "../src/Device.vala"
	*result = _tmp0_;
#line 64 "../src/Device.vala"
	return;
#line 1512 "Device.c"
}

void
sound_device_set_channel_map (SoundDevice* self,
                              pa_channel_map * value)
{
	pa_channel_map _tmp0_;
#line 64 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Device.vala"
	_tmp0_ = *value;
#line 64 "../src/Device.vala"
	self->priv->_channel_map = _tmp0_;
#line 1526 "Device.c"
}

static GObject *
sound_device_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundDevice * self;
	GeeLinkedList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
#line 71 "../src/Device.vala"
	parent_class = G_OBJECT_CLASS (sound_device_parent_class);
#line 71 "../src/Device.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 71 "../src/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_DEVICE, SoundDevice);
#line 72 "../src/Device.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_POINTER, (GBoxedCopyFunc) pa_operation_ref, (GDestroyNotify) pa_operation_unref, NULL, NULL, NULL);
#line 72 "../src/Device.vala"
	_g_object_unref0 (self->volume_operations);
#line 72 "../src/Device.vala"
	self->volume_operations = _tmp0_;
#line 73 "../src/Device.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 73 "../src/Device.vala"
	_tmp2_ = _tmp1_;
#line 73 "../src/Device.vala"
	sound_device_set_profiles (self, _tmp2_);
#line 73 "../src/Device.vala"
	_g_object_unref0 (_tmp2_);
#line 71 "../src/Device.vala"
	return obj;
#line 1562 "Device.c"
}

SoundDevicePort*
sound_device_port_construct (GType object_type)
{
	SoundDevicePort* self = NULL;
#line 25 "../src/Device.vala"
	self = (SoundDevicePort*) g_type_create_instance (object_type);
#line 25 "../src/Device.vala"
	return self;
#line 1573 "Device.c"
}

SoundDevicePort*
sound_device_port_new (void)
{
#line 25 "../src/Device.vala"
	return sound_device_port_construct (SOUND_DEVICE_TYPE_PORT);
#line 1581 "Device.c"
}

static void
sound_device_value_port_init (GValue* value)
{
#line 25 "../src/Device.vala"
	value->data[0].v_pointer = NULL;
#line 1589 "Device.c"
}

static void
sound_device_value_port_free_value (GValue* value)
{
#line 25 "../src/Device.vala"
	if (value->data[0].v_pointer) {
#line 25 "../src/Device.vala"
		sound_device_port_unref (value->data[0].v_pointer);
#line 1599 "Device.c"
	}
}

static void
sound_device_value_port_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 25 "../src/Device.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "../src/Device.vala"
		dest_value->data[0].v_pointer = sound_device_port_ref (src_value->data[0].v_pointer);
#line 1611 "Device.c"
	} else {
#line 25 "../src/Device.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1615 "Device.c"
	}
}

static gpointer
sound_device_value_port_peek_pointer (const GValue* value)
{
#line 25 "../src/Device.vala"
	return value->data[0].v_pointer;
#line 1624 "Device.c"
}

static gchar*
sound_device_value_port_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 25 "../src/Device.vala"
	if (collect_values[0].v_pointer) {
#line 1635 "Device.c"
		SoundDevicePort * object;
		object = collect_values[0].v_pointer;
#line 25 "../src/Device.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "../src/Device.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1642 "Device.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "../src/Device.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1646 "Device.c"
		}
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = sound_device_port_ref (object);
#line 1650 "Device.c"
	} else {
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = NULL;
#line 1654 "Device.c"
	}
#line 25 "../src/Device.vala"
	return NULL;
#line 1658 "Device.c"
}

static gchar*
sound_device_value_port_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	SoundDevicePort ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "../src/Device.vala"
	if (!object_p) {
#line 25 "../src/Device.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1673 "Device.c"
	}
#line 25 "../src/Device.vala"
	if (!value->data[0].v_pointer) {
#line 25 "../src/Device.vala"
		*object_p = NULL;
#line 1679 "Device.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "../src/Device.vala"
		*object_p = value->data[0].v_pointer;
#line 1683 "Device.c"
	} else {
#line 25 "../src/Device.vala"
		*object_p = sound_device_port_ref (value->data[0].v_pointer);
#line 1687 "Device.c"
	}
#line 25 "../src/Device.vala"
	return NULL;
#line 1691 "Device.c"
}

GParamSpec*
sound_device_param_spec_port (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	SoundDeviceParamSpecPort* spec;
#line 25 "../src/Device.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SOUND_DEVICE_TYPE_PORT), NULL);
#line 25 "../src/Device.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "../src/Device.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "../src/Device.vala"
	return G_PARAM_SPEC (spec);
#line 1710 "Device.c"
}

gpointer
sound_device_value_get_port (const GValue* value)
{
#line 25 "../src/Device.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SOUND_DEVICE_TYPE_PORT), NULL);
#line 25 "../src/Device.vala"
	return value->data[0].v_pointer;
#line 1720 "Device.c"
}

void
sound_device_value_set_port (GValue* value,
                             gpointer v_object)
{
	SoundDevicePort * old;
#line 25 "../src/Device.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SOUND_DEVICE_TYPE_PORT));
#line 25 "../src/Device.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/Device.vala"
	if (v_object) {
#line 25 "../src/Device.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SOUND_DEVICE_TYPE_PORT));
#line 25 "../src/Device.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = v_object;
#line 25 "../src/Device.vala"
		sound_device_port_ref (value->data[0].v_pointer);
#line 1742 "Device.c"
	} else {
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = NULL;
#line 1746 "Device.c"
	}
#line 25 "../src/Device.vala"
	if (old) {
#line 25 "../src/Device.vala"
		sound_device_port_unref (old);
#line 1752 "Device.c"
	}
}

void
sound_device_value_take_port (GValue* value,
                              gpointer v_object)
{
	SoundDevicePort * old;
#line 25 "../src/Device.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SOUND_DEVICE_TYPE_PORT));
#line 25 "../src/Device.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/Device.vala"
	if (v_object) {
#line 25 "../src/Device.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SOUND_DEVICE_TYPE_PORT));
#line 25 "../src/Device.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = v_object;
#line 1773 "Device.c"
	} else {
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = NULL;
#line 1777 "Device.c"
	}
#line 25 "../src/Device.vala"
	if (old) {
#line 25 "../src/Device.vala"
		sound_device_port_unref (old);
#line 1783 "Device.c"
	}
}

static void
sound_device_port_class_init (SoundDevicePortClass * klass,
                              gpointer klass_data)
{
#line 25 "../src/Device.vala"
	sound_device_port_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/Device.vala"
	((SoundDevicePortClass *) klass)->finalize = sound_device_port_finalize;
#line 1795 "Device.c"
}

static void
sound_device_port_instance_init (SoundDevicePort * self,
                                 gpointer klass)
{
#line 25 "../src/Device.vala"
	self->ref_count = 1;
#line 1804 "Device.c"
}

static void
sound_device_port_finalize (SoundDevicePort * obj)
{
	SoundDevicePort * self;
#line 25 "../src/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_DEVICE_TYPE_PORT, SoundDevicePort);
#line 25 "../src/Device.vala"
	g_signal_handlers_destroy (self);
#line 26 "../src/Device.vala"
	_g_free0 (self->name);
#line 27 "../src/Device.vala"
	_g_free0 (self->description);
#line 1819 "Device.c"
}

GType
sound_device_port_get_type (void)
{
	static volatile gsize sound_device_port_type_id__volatile = 0;
	if (g_once_init_enter (&sound_device_port_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { sound_device_value_port_init, sound_device_value_port_free_value, sound_device_value_port_copy_value, sound_device_value_port_peek_pointer, "p", sound_device_value_port_collect_value, "p", sound_device_value_port_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SoundDevicePortClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_device_port_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundDevicePort), 0, (GInstanceInitFunc) sound_device_port_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType sound_device_port_type_id;
		sound_device_port_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SoundDevicePort", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&sound_device_port_type_id__volatile, sound_device_port_type_id);
	}
	return sound_device_port_type_id__volatile;
}

gpointer
sound_device_port_ref (gpointer instance)
{
	SoundDevicePort * self;
	self = instance;
#line 25 "../src/Device.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "../src/Device.vala"
	return instance;
#line 1846 "Device.c"
}

void
sound_device_port_unref (gpointer instance)
{
	SoundDevicePort * self;
	self = instance;
#line 25 "../src/Device.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "../src/Device.vala"
		SOUND_DEVICE_PORT_GET_CLASS (self)->finalize (self);
#line 25 "../src/Device.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1860 "Device.c"
	}
}

static void
sound_device_class_init (SoundDeviceClass * klass,
                         gpointer klass_data)
{
#line 24 "../src/Device.vala"
	sound_device_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Device.vala"
	g_type_class_adjust_private_offset (klass, &SoundDevice_private_offset);
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_device_get_property;
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_device_set_property;
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_device_constructor;
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_device_finalize;
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_INPUT_PROPERTY, sound_device_properties[SOUND_DEVICE_INPUT_PROPERTY] = g_param_spec_boolean ("input", "input", "input", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_ID_PROPERTY, sound_device_properties[SOUND_DEVICE_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_NAME_PROPERTY] = g_param_spec_string ("card-name", "card-name", "card-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_INDEX_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_INDEX_PROPERTY] = g_param_spec_uint ("card-index", "card-index", "card-index", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_PORT_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_PORT_NAME_PROPERTY] = g_param_spec_string ("port-name", "port-name", "port-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_DISPLAY_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_FORM_FACTOR_PROPERTY, sound_device_properties[SOUND_DEVICE_FORM_FACTOR_PROPERTY] = g_param_spec_string ("form-factor", "form-factor", "form-factor", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_PROFILES_PROPERTY, sound_device_properties[SOUND_DEVICE_PROFILES_PROPERTY] = g_param_spec_object ("profiles", "profiles", "profiles", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY] = g_param_spec_string ("card-active-profile-name", "card-active-profile-name", "card-active-profile-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_SINK_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_SINK_NAME_PROPERTY] = g_param_spec_string ("sink-name", "sink-name", "sink-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_SINK_INDEX_PROPERTY, sound_device_properties[SOUND_DEVICE_SINK_INDEX_PROPERTY] = g_param_spec_int ("sink-index", "sink-index", "sink-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SINK_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SINK_NAME_PROPERTY] = g_param_spec_string ("card-sink-name", "card-sink-name", "card-sink-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY] = g_param_spec_string ("card-sink-port-name", "card-sink-port-name", "card-sink-port-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY] = g_param_spec_int ("card-sink-index", "card-sink-index", "card-sink-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_SOURCE_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_SOURCE_NAME_PROPERTY] = g_param_spec_string ("source-name", "source-name", "source-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_SOURCE_INDEX_PROPERTY, sound_device_properties[SOUND_DEVICE_SOURCE_INDEX_PROPERTY] = g_param_spec_int ("source-index", "source-index", "source-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY] = g_param_spec_string ("card-source-name", "card-source-name", "card-source-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY] = g_param_spec_string ("card-source-port-name", "card-source-port-name", "card-source-port-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY] = g_param_spec_int ("card-source-index", "card-source-index", "card-source-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_IS_DEFAULT_PROPERTY, sound_device_properties[SOUND_DEVICE_IS_DEFAULT_PROPERTY] = g_param_spec_boolean ("is-default", "is-default", "is-default", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_IS_MUTED_PROPERTY, sound_device_properties[SOUND_DEVICE_IS_MUTED_PROPERTY] = g_param_spec_boolean ("is-muted", "is-muted", "is-muted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_VOLUME_PROPERTY, sound_device_properties[SOUND_DEVICE_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_BALANCE_PROPERTY, sound_device_properties[SOUND_DEVICE_BALANCE_PROPERTY] = g_param_spec_float ("balance", "balance", "balance", -G_MAXFLOAT, G_MAXFLOAT, (gfloat) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	sound_device_signals[SOUND_DEVICE_REMOVED_SIGNAL] = g_signal_new ("removed", SOUND_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1928 "Device.c"
}

static void
sound_device_instance_init (SoundDevice * self,
                            gpointer klass)
{
#line 24 "../src/Device.vala"
	self->priv = sound_device_get_instance_private (self);
#line 34 "../src/Device.vala"
	self->priv->_input = TRUE;
#line 59 "../src/Device.vala"
	self->priv->_is_default = FALSE;
#line 60 "../src/Device.vala"
	self->priv->_is_muted = FALSE;
#line 62 "../src/Device.vala"
	self->priv->_volume = (gdouble) 0;
#line 63 "../src/Device.vala"
	self->priv->_balance = (gfloat) 0;
#line 1947 "Device.c"
}

static void
sound_device_finalize (GObject * obj)
{
	SoundDevice * self;
#line 24 "../src/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_DEVICE, SoundDevice);
#line 35 "../src/Device.vala"
	_g_free0 (self->priv->_id);
#line 36 "../src/Device.vala"
	_g_free0 (self->priv->_card_name);
#line 38 "../src/Device.vala"
	_g_free0 (self->priv->_port_name);
#line 39 "../src/Device.vala"
	_g_free0 (self->priv->_display_name);
#line 40 "../src/Device.vala"
	_g_free0 (self->priv->_form_factor);
#line 41 "../src/Device.vala"
	_g_object_unref0 (self->priv->_profiles);
#line 42 "../src/Device.vala"
	_g_free0 (self->priv->_card_active_profile_name);
#line 45 "../src/Device.vala"
	_g_free0 (self->priv->_sink_name);
#line 47 "../src/Device.vala"
	_g_free0 (self->priv->_card_sink_name);
#line 48 "../src/Device.vala"
	_g_free0 (self->priv->_card_sink_port_name);
#line 52 "../src/Device.vala"
	_g_free0 (self->priv->_source_name);
#line 54 "../src/Device.vala"
	_g_free0 (self->priv->_card_source_name);
#line 55 "../src/Device.vala"
	_g_free0 (self->priv->_card_source_port_name);
#line 65 "../src/Device.vala"
	_g_object_unref0 (self->volume_operations);
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (sound_device_parent_class)->finalize (obj);
#line 1986 "Device.c"
}

GType
sound_device_get_type (void)
{
	static volatile gsize sound_device_type_id__volatile = 0;
	if (g_once_init_enter (&sound_device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SoundDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundDevice), 0, (GInstanceInitFunc) sound_device_instance_init, NULL };
		GType sound_device_type_id;
		sound_device_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundDevice", &g_define_type_info, 0);
		SoundDevice_private_offset = g_type_add_instance_private (sound_device_type_id, sizeof (SoundDevicePrivate));
		g_once_init_leave (&sound_device_type_id__volatile, sound_device_type_id);
	}
	return sound_device_type_id__volatile;
}

static void
_vala_sound_device_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SoundDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_DEVICE, SoundDevice);
#line 24 "../src/Device.vala"
	switch (property_id) {
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_INPUT_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_boolean (value, sound_device_get_input (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_ID_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_id (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_uint (value, sound_device_get_card_index (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_port_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_DISPLAY_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_display_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_FORM_FACTOR_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_form_factor (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_PROFILES_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_object (value, sound_device_get_profiles (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_active_profile_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SINK_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_sink_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SINK_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_int (value, sound_device_get_sink_index (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_sink_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_sink_port_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_int (value, sound_device_get_card_sink_index (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SOURCE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_source_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SOURCE_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_int (value, sound_device_get_source_index (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_source_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_source_port_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_int (value, sound_device_get_card_source_index (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_DEFAULT_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_boolean (value, sound_device_get_is_default (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_MUTED_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_boolean (value, sound_device_get_is_muted (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_VOLUME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_double (value, sound_device_get_volume (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_BALANCE_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_float (value, sound_device_get_balance (self));
#line 24 "../src/Device.vala"
		break;
#line 2151 "Device.c"
		default:
#line 24 "../src/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Device.vala"
		break;
#line 2157 "Device.c"
	}
}

static void
_vala_sound_device_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	SoundDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_DEVICE, SoundDevice);
#line 24 "../src/Device.vala"
	switch (property_id) {
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_INPUT_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_input (self, g_value_get_boolean (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_ID_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_id (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_index (self, g_value_get_uint (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_port_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_DISPLAY_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_display_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_FORM_FACTOR_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_form_factor (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_PROFILES_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_profiles (self, g_value_get_object (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_active_profile_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SINK_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_sink_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SINK_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_sink_index (self, g_value_get_int (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_sink_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_sink_port_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_sink_index (self, g_value_get_int (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SOURCE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_source_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SOURCE_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_source_index (self, g_value_get_int (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_source_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_source_port_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_source_index (self, g_value_get_int (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_DEFAULT_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_is_default (self, g_value_get_boolean (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_MUTED_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_is_muted (self, g_value_get_boolean (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_VOLUME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_volume (self, g_value_get_double (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_BALANCE_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_balance (self, g_value_get_float (value));
#line 24 "../src/Device.vala"
		break;
#line 2309 "Device.c"
		default:
#line 24 "../src/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Device.vala"
		break;
#line 2315 "Device.c"
	}
}

