/* InputDeviceMonitor.c generated by valac 0.44.3, the Vala compiler
 * generated from InputDeviceMonitor.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <pulse/pulseaudio.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>

#define SOUND_TYPE_INPUT_DEVICE_MONITOR (sound_input_device_monitor_get_type ())
#define SOUND_INPUT_DEVICE_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_INPUT_DEVICE_MONITOR, SoundInputDeviceMonitor))
#define SOUND_INPUT_DEVICE_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_INPUT_DEVICE_MONITOR, SoundInputDeviceMonitorClass))
#define SOUND_IS_INPUT_DEVICE_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_INPUT_DEVICE_MONITOR))
#define SOUND_IS_INPUT_DEVICE_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_INPUT_DEVICE_MONITOR))
#define SOUND_INPUT_DEVICE_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_INPUT_DEVICE_MONITOR, SoundInputDeviceMonitorClass))

typedef struct _SoundInputDeviceMonitor SoundInputDeviceMonitor;
typedef struct _SoundInputDeviceMonitorClass SoundInputDeviceMonitorClass;
typedef struct _SoundInputDeviceMonitorPrivate SoundInputDeviceMonitorPrivate;

#define SOUND_TYPE_DEVICE (sound_device_get_type ())
#define SOUND_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE, SoundDevice))
#define SOUND_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE, SoundDeviceClass))
#define SOUND_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE))
#define SOUND_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE))
#define SOUND_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE, SoundDeviceClass))

typedef struct _SoundDevice SoundDevice;
typedef struct _SoundDeviceClass SoundDeviceClass;
enum  {
	SOUND_INPUT_DEVICE_MONITOR_0_PROPERTY,
	SOUND_INPUT_DEVICE_MONITOR_NUM_PROPERTIES
};
static GParamSpec* sound_input_device_monitor_properties[SOUND_INPUT_DEVICE_MONITOR_NUM_PROPERTIES];
#define _pa_stream_unref0(var) ((var == NULL) ? NULL : (var = (pa_stream_unref (var), NULL)))

#define SOUND_TYPE_PULSE_AUDIO_MANAGER (sound_pulse_audio_manager_get_type ())
#define SOUND_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager))
#define SOUND_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))
#define SOUND_IS_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_IS_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_PULSE_AUDIO_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))

typedef struct _SoundPulseAudioManager SoundPulseAudioManager;
typedef struct _SoundPulseAudioManagerClass SoundPulseAudioManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
enum  {
	SOUND_INPUT_DEVICE_MONITOR_UPDATE_FRACTION_SIGNAL,
	SOUND_INPUT_DEVICE_MONITOR_NUM_SIGNALS
};
static guint sound_input_device_monitor_signals[SOUND_INPUT_DEVICE_MONITOR_NUM_SIGNALS] = {0};

struct _SoundInputDeviceMonitor {
	GObject parent_instance;
	SoundInputDeviceMonitorPrivate * priv;
};

struct _SoundInputDeviceMonitorClass {
	GObjectClass parent_class;
};

struct _SoundInputDeviceMonitorPrivate {
	pa_stream* steam;
	SoundDevice* device;
	gboolean allow_record;
};

static gint SoundInputDeviceMonitor_private_offset;
static gpointer sound_input_device_monitor_parent_class = NULL;

GType sound_input_device_monitor_get_type (void) G_GNUC_CONST;
GType sound_device_get_type (void) G_GNUC_CONST;
SoundInputDeviceMonitor* sound_input_device_monitor_new (void);
SoundInputDeviceMonitor* sound_input_device_monitor_construct (GType object_type);
void sound_input_device_monitor_stop_record (SoundInputDeviceMonitor* self);
void sound_input_device_monitor_start_record (SoundInputDeviceMonitor* self);
GType sound_pulse_audio_manager_get_type (void) G_GNUC_CONST;
SoundPulseAudioManager* sound_pulse_audio_manager_get_default (void);
pa_context* sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self);
static void sound_input_device_monitor_steam_read_callback (SoundInputDeviceMonitor* self,
                                                     pa_stream* s,
                                                     gsize nbytes);
static void _sound_input_device_monitor_steam_read_callback_pa_stream_requestcb (pa_stream* s,
                                                                          gsize nbytes,
                                                                          gpointer self);
static void sound_input_device_monitor_steam_suspended_callback (SoundInputDeviceMonitor* self,
                                                          pa_stream* s);
static void _sound_input_device_monitor_steam_suspended_callback_pa_stream_notifycb (pa_stream* s,
                                                                              gpointer self);
gint sound_device_get_source_index (SoundDevice* self);
void sound_input_device_monitor_set_device (SoundInputDeviceMonitor* self,
                                            SoundDevice* device);
static void sound_input_device_monitor_finalize (GObject * obj);

static inline gpointer
sound_input_device_monitor_get_instance_private (SoundInputDeviceMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, SoundInputDeviceMonitor_private_offset);
}

SoundInputDeviceMonitor*
sound_input_device_monitor_construct (GType object_type)
{
	SoundInputDeviceMonitor * self = NULL;
#line 29 "../src/InputDeviceMonitor.vala"
	self = (SoundInputDeviceMonitor*) g_object_new (object_type, NULL);
#line 29 "../src/InputDeviceMonitor.vala"
	return self;
#line 136 "InputDeviceMonitor.c"
}

SoundInputDeviceMonitor*
sound_input_device_monitor_new (void)
{
#line 29 "../src/InputDeviceMonitor.vala"
	return sound_input_device_monitor_construct (SOUND_TYPE_INPUT_DEVICE_MONITOR);
#line 144 "InputDeviceMonitor.c"
}

void
sound_input_device_monitor_stop_record (SoundInputDeviceMonitor* self)
{
	pa_stream* _tmp0_;
#line 41 "../src/InputDeviceMonitor.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/InputDeviceMonitor.vala"
	if (self->priv->allow_record == FALSE) {
#line 43 "../src/InputDeviceMonitor.vala"
		return;
#line 157 "InputDeviceMonitor.c"
	}
#line 46 "../src/InputDeviceMonitor.vala"
	self->priv->allow_record = FALSE;
#line 48 "../src/InputDeviceMonitor.vala"
	_tmp0_ = self->priv->steam;
#line 48 "../src/InputDeviceMonitor.vala"
	if (_tmp0_ != NULL) {
#line 165 "InputDeviceMonitor.c"
		pa_stream* _tmp1_;
#line 49 "../src/InputDeviceMonitor.vala"
		_tmp1_ = self->priv->steam;
#line 49 "../src/InputDeviceMonitor.vala"
		pa_stream_disconnect (_tmp1_);
#line 50 "../src/InputDeviceMonitor.vala"
		_pa_stream_unref0 (self->priv->steam);
#line 50 "../src/InputDeviceMonitor.vala"
		self->priv->steam = NULL;
#line 175 "InputDeviceMonitor.c"
	}
}

static void
_sound_input_device_monitor_steam_read_callback_pa_stream_requestcb (pa_stream* s,
                                                                     gsize nbytes,
                                                                     gpointer self)
{
#line 79 "../src/InputDeviceMonitor.vala"
	sound_input_device_monitor_steam_read_callback ((SoundInputDeviceMonitor*) self, s, nbytes);
#line 186 "InputDeviceMonitor.c"
}

static void
_sound_input_device_monitor_steam_suspended_callback_pa_stream_notifycb (pa_stream* s,
                                                                         gpointer self)
{
#line 80 "../src/InputDeviceMonitor.vala"
	sound_input_device_monitor_steam_suspended_callback ((SoundInputDeviceMonitor*) self, s);
#line 195 "InputDeviceMonitor.c"
}

void
sound_input_device_monitor_start_record (SoundInputDeviceMonitor* self)
{
	SoundDevice* _tmp0_;
	pa_stream* _tmp1_;
	pa_context* c = NULL;
	SoundPulseAudioManager* _tmp3_;
	pa_context* _tmp4_;
	pa_context* _tmp5_;
	pa_sample_spec ss = {0};
	pa_proplist* props = NULL;
	pa_proplist* _tmp6_;
	pa_proplist* _tmp7_;
	pa_proplist* _tmp8_;
	pa_proplist* _tmp9_;
	pa_proplist* _tmp10_;
	pa_context* _tmp11_;
	pa_sample_spec _tmp12_;
	pa_proplist* _tmp13_;
	pa_stream* _tmp14_;
	pa_stream* _tmp15_;
	pa_stream* _tmp16_;
	pa_buffer_attr a = {0};
	pa_stream* _tmp17_;
	SoundDevice* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	pa_buffer_attr _tmp23_;
#line 54 "../src/InputDeviceMonitor.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/InputDeviceMonitor.vala"
	self->priv->allow_record = TRUE;
#line 57 "../src/InputDeviceMonitor.vala"
	_tmp0_ = self->priv->device;
#line 57 "../src/InputDeviceMonitor.vala"
	if (_tmp0_ == NULL) {
#line 58 "../src/InputDeviceMonitor.vala"
		return;
#line 238 "InputDeviceMonitor.c"
	}
#line 61 "../src/InputDeviceMonitor.vala"
	_tmp1_ = self->priv->steam;
#line 61 "../src/InputDeviceMonitor.vala"
	if (_tmp1_ != NULL) {
#line 244 "InputDeviceMonitor.c"
		pa_stream* _tmp2_;
#line 62 "../src/InputDeviceMonitor.vala"
		_tmp2_ = self->priv->steam;
#line 62 "../src/InputDeviceMonitor.vala"
		pa_stream_disconnect (_tmp2_);
#line 63 "../src/InputDeviceMonitor.vala"
		_pa_stream_unref0 (self->priv->steam);
#line 63 "../src/InputDeviceMonitor.vala"
		self->priv->steam = NULL;
#line 254 "InputDeviceMonitor.c"
	}
#line 66 "../src/InputDeviceMonitor.vala"
	_tmp3_ = sound_pulse_audio_manager_get_default ();
#line 66 "../src/InputDeviceMonitor.vala"
	_tmp4_ = sound_pulse_audio_manager_get_context (_tmp3_);
#line 66 "../src/InputDeviceMonitor.vala"
	_tmp5_ = _tmp4_;
#line 66 "../src/InputDeviceMonitor.vala"
	c = _tmp5_;
#line 67 "../src/InputDeviceMonitor.vala"
	pa_sample_spec_init (&ss);
#line 68 "../src/InputDeviceMonitor.vala"
	ss.format = PA_SAMPLE_FLOAT32NE;
#line 69 "../src/InputDeviceMonitor.vala"
	ss.rate = (guint32) 25;
#line 70 "../src/InputDeviceMonitor.vala"
	ss.channels = (guint8) 1;
#line 72 "../src/InputDeviceMonitor.vala"
	_tmp6_ = pa_proplist_new ();
#line 72 "../src/InputDeviceMonitor.vala"
	props = _tmp6_;
#line 73 "../src/InputDeviceMonitor.vala"
	_tmp7_ = props;
#line 73 "../src/InputDeviceMonitor.vala"
	pa_proplist_sets (_tmp7_, PA_PROP_APPLICATION_NAME, "Switchboard sound");
#line 74 "../src/InputDeviceMonitor.vala"
	_tmp8_ = props;
#line 74 "../src/InputDeviceMonitor.vala"
	pa_proplist_sets (_tmp8_, PA_PROP_APPLICATION_ID, "org.pantheon.switchboard.plug.sound");
#line 75 "../src/InputDeviceMonitor.vala"
	_tmp9_ = props;
#line 75 "../src/InputDeviceMonitor.vala"
	pa_proplist_sets (_tmp9_, PA_PROP_APPLICATION_ICON_NAME, "multimedia-volume-control");
#line 76 "../src/InputDeviceMonitor.vala"
	_tmp10_ = props;
#line 76 "../src/InputDeviceMonitor.vala"
	pa_proplist_sets (_tmp10_, PA_PROP_APPLICATION_VERSION, "0.1");
#line 78 "../src/InputDeviceMonitor.vala"
	_tmp11_ = c;
#line 78 "../src/InputDeviceMonitor.vala"
	_tmp12_ = ss;
#line 78 "../src/InputDeviceMonitor.vala"
	_tmp13_ = props;
#line 78 "../src/InputDeviceMonitor.vala"
	_tmp14_ = pa_stream_new_with_proplist (_tmp11_, _ ("Peak detect"), &_tmp12_, NULL, _tmp13_);
#line 78 "../src/InputDeviceMonitor.vala"
	_pa_stream_unref0 (self->priv->steam);
#line 78 "../src/InputDeviceMonitor.vala"
	self->priv->steam = _tmp14_;
#line 79 "../src/InputDeviceMonitor.vala"
	_tmp15_ = self->priv->steam;
#line 79 "../src/InputDeviceMonitor.vala"
	pa_stream_set_read_callback (_tmp15_, _sound_input_device_monitor_steam_read_callback_pa_stream_requestcb, self);
#line 80 "../src/InputDeviceMonitor.vala"
	_tmp16_ = self->priv->steam;
#line 80 "../src/InputDeviceMonitor.vala"
	pa_stream_set_suspended_callback (_tmp16_, _sound_input_device_monitor_steam_suspended_callback_pa_stream_notifycb, self);
#line 82 "../src/InputDeviceMonitor.vala"
	memset (&a, 0, sizeof (pa_buffer_attr));
#line 83 "../src/InputDeviceMonitor.vala"
	a.maxlength = G_MAXUINT32;
#line 84 "../src/InputDeviceMonitor.vala"
	a.fragsize = (guint32) sizeof (gfloat);
#line 85 "../src/InputDeviceMonitor.vala"
	_tmp17_ = self->priv->steam;
#line 85 "../src/InputDeviceMonitor.vala"
	_tmp18_ = self->priv->device;
#line 85 "../src/InputDeviceMonitor.vala"
	_tmp19_ = sound_device_get_source_index (_tmp18_);
#line 85 "../src/InputDeviceMonitor.vala"
	_tmp20_ = _tmp19_;
#line 85 "../src/InputDeviceMonitor.vala"
	_tmp21_ = g_strdup_printf ("%u", (guint) _tmp20_);
#line 85 "../src/InputDeviceMonitor.vala"
	_tmp22_ = _tmp21_;
#line 85 "../src/InputDeviceMonitor.vala"
	_tmp23_ = a;
#line 85 "../src/InputDeviceMonitor.vala"
	pa_stream_connect_record (_tmp17_, _tmp22_, &_tmp23_, (PA_STREAM_DONT_MOVE | PA_STREAM_PEAK_DETECT) | PA_STREAM_ADJUST_LATENCY);
#line 85 "../src/InputDeviceMonitor.vala"
	_g_free0 (_tmp22_);
#line 54 "../src/InputDeviceMonitor.vala"
	_pa_proplist_free0 (props);
#line 338 "InputDeviceMonitor.c"
}

void
sound_input_device_monitor_set_device (SoundInputDeviceMonitor* self,
                                       SoundDevice* device)
{
#line 88 "../src/InputDeviceMonitor.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/InputDeviceMonitor.vala"
	g_return_if_fail (device != NULL);
#line 89 "../src/InputDeviceMonitor.vala"
	self->priv->device = device;
#line 90 "../src/InputDeviceMonitor.vala"
	if (self->priv->allow_record) {
#line 91 "../src/InputDeviceMonitor.vala"
		sound_input_device_monitor_start_record (self);
#line 355 "InputDeviceMonitor.c"
	} else {
#line 93 "../src/InputDeviceMonitor.vala"
		sound_input_device_monitor_stop_record (self);
#line 359 "InputDeviceMonitor.c"
	}
}

static void
sound_input_device_monitor_steam_read_callback (SoundInputDeviceMonitor* self,
                                                pa_stream* s,
                                                gsize nbytes)
{
	void* data = NULL;
	void* _tmp0_ = NULL;
	gsize _tmp1_ = 0UL;
	gint _tmp2_;
	void* _tmp3_;
	gfloat v = 0.0F;
	void* _tmp4_;
	gfloat _tmp5_;
#line 97 "../src/InputDeviceMonitor.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/InputDeviceMonitor.vala"
	g_return_if_fail (s != NULL);
#line 99 "../src/InputDeviceMonitor.vala"
	_tmp2_ = pa_stream_peek (s, &_tmp0_, &_tmp1_);
#line 99 "../src/InputDeviceMonitor.vala"
	data = _tmp0_;
#line 99 "../src/InputDeviceMonitor.vala"
	nbytes = _tmp1_;
#line 99 "../src/InputDeviceMonitor.vala"
	if (_tmp2_ < 0) {
#line 100 "../src/InputDeviceMonitor.vala"
		g_warning ("InputDeviceMonitor.vala:100: Failed to read data from stream");
#line 101 "../src/InputDeviceMonitor.vala"
		return;
#line 392 "InputDeviceMonitor.c"
	}
#line 104 "../src/InputDeviceMonitor.vala"
	_tmp3_ = data;
#line 104 "../src/InputDeviceMonitor.vala"
	if (_tmp3_ == NULL) {
#line 105 "../src/InputDeviceMonitor.vala"
		pa_stream_drop (s);
#line 106 "../src/InputDeviceMonitor.vala"
		return;
#line 402 "InputDeviceMonitor.c"
	}
#line 109 "../src/InputDeviceMonitor.vala"
	_tmp4_ = data;
#line 109 "../src/InputDeviceMonitor.vala"
	_tmp5_ = ((gfloat*) _tmp4_)[(nbytes / sizeof (gfloat)) - 1];
#line 109 "../src/InputDeviceMonitor.vala"
	v = _tmp5_;
#line 110 "../src/InputDeviceMonitor.vala"
	pa_stream_drop (s);
#line 112 "../src/InputDeviceMonitor.vala"
	if (v < ((gfloat) 0)) {
#line 113 "../src/InputDeviceMonitor.vala"
		v = (gfloat) 0;
#line 416 "InputDeviceMonitor.c"
	}
#line 116 "../src/InputDeviceMonitor.vala"
	if (v > ((gfloat) 1)) {
#line 117 "../src/InputDeviceMonitor.vala"
		v = (gfloat) 1;
#line 422 "InputDeviceMonitor.c"
	}
#line 120 "../src/InputDeviceMonitor.vala"
	g_signal_emit (self, sound_input_device_monitor_signals[SOUND_INPUT_DEVICE_MONITOR_UPDATE_FRACTION_SIGNAL], 0, v);
#line 426 "InputDeviceMonitor.c"
}

static void
sound_input_device_monitor_steam_suspended_callback (SoundInputDeviceMonitor* self,
                                                     pa_stream* s)
{
#line 123 "../src/InputDeviceMonitor.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/InputDeviceMonitor.vala"
	g_return_if_fail (s != NULL);
#line 124 "../src/InputDeviceMonitor.vala"
	g_signal_emit (self, sound_input_device_monitor_signals[SOUND_INPUT_DEVICE_MONITOR_UPDATE_FRACTION_SIGNAL], 0, (gfloat) 0);
#line 439 "InputDeviceMonitor.c"
}

static void
sound_input_device_monitor_class_init (SoundInputDeviceMonitorClass * klass,
                                       gpointer klass_data)
{
#line 23 "../src/InputDeviceMonitor.vala"
	sound_input_device_monitor_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/InputDeviceMonitor.vala"
	g_type_class_adjust_private_offset (klass, &SoundInputDeviceMonitor_private_offset);
#line 23 "../src/InputDeviceMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_input_device_monitor_finalize;
#line 23 "../src/InputDeviceMonitor.vala"
	sound_input_device_monitor_signals[SOUND_INPUT_DEVICE_MONITOR_UPDATE_FRACTION_SIGNAL] = g_signal_new ("update-fraction", SOUND_TYPE_INPUT_DEVICE_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__FLOAT, G_TYPE_NONE, 1, G_TYPE_FLOAT);
#line 454 "InputDeviceMonitor.c"
}

static void
sound_input_device_monitor_instance_init (SoundInputDeviceMonitor * self,
                                          gpointer klass)
{
#line 23 "../src/InputDeviceMonitor.vala"
	self->priv = sound_input_device_monitor_get_instance_private (self);
#line 27 "../src/InputDeviceMonitor.vala"
	self->priv->allow_record = FALSE;
#line 465 "InputDeviceMonitor.c"
}

static void
sound_input_device_monitor_finalize (GObject * obj)
{
	SoundInputDeviceMonitor * self;
	pa_stream* _tmp0_;
#line 23 "../src/InputDeviceMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_INPUT_DEVICE_MONITOR, SoundInputDeviceMonitor);
#line 34 "../src/InputDeviceMonitor.vala"
	_tmp0_ = self->priv->steam;
#line 34 "../src/InputDeviceMonitor.vala"
	if (_tmp0_ != NULL) {
#line 479 "InputDeviceMonitor.c"
		pa_stream* _tmp1_;
		pa_stream* _tmp2_;
		pa_stream* _tmp3_;
#line 35 "../src/InputDeviceMonitor.vala"
		_tmp1_ = self->priv->steam;
#line 35 "../src/InputDeviceMonitor.vala"
		pa_stream_set_read_callback (_tmp1_, NULL, NULL);
#line 36 "../src/InputDeviceMonitor.vala"
		_tmp2_ = self->priv->steam;
#line 36 "../src/InputDeviceMonitor.vala"
		pa_stream_set_suspended_callback (_tmp2_, NULL, NULL);
#line 37 "../src/InputDeviceMonitor.vala"
		_tmp3_ = self->priv->steam;
#line 37 "../src/InputDeviceMonitor.vala"
		pa_stream_disconnect (_tmp3_);
#line 495 "InputDeviceMonitor.c"
	}
#line 25 "../src/InputDeviceMonitor.vala"
	_pa_stream_unref0 (self->priv->steam);
#line 23 "../src/InputDeviceMonitor.vala"
	G_OBJECT_CLASS (sound_input_device_monitor_parent_class)->finalize (obj);
#line 501 "InputDeviceMonitor.c"
}

GType
sound_input_device_monitor_get_type (void)
{
	static volatile gsize sound_input_device_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&sound_input_device_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SoundInputDeviceMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_input_device_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundInputDeviceMonitor), 0, (GInstanceInitFunc) sound_input_device_monitor_instance_init, NULL };
		GType sound_input_device_monitor_type_id;
		sound_input_device_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundInputDeviceMonitor", &g_define_type_info, 0);
		SoundInputDeviceMonitor_private_offset = g_type_add_instance_private (sound_input_device_monitor_type_id, sizeof (SoundInputDeviceMonitorPrivate));
		g_once_init_leave (&sound_input_device_monitor_type_id__volatile, sound_input_device_monitor_type_id);
	}
	return sound_input_device_monitor_type_id__volatile;
}

