/* PulseAudioManager.c generated by valac 0.44.3, the Vala compiler
 * generated from PulseAudioManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/*
 * Vocabulary of PulseAudio:
 *  - Source: Input (microphone)
 *  - Sink: Output (speaker)
 */

#include <glib-object.h>
#include <pulse/pulseaudio.h>
#include <pulse/glib-mainloop.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include "pulse/ext-stream-restore.h"

#define SOUND_TYPE_PULSE_AUDIO_MANAGER (sound_pulse_audio_manager_get_type ())
#define SOUND_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager))
#define SOUND_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))
#define SOUND_IS_PULSE_AUDIO_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_IS_PULSE_AUDIO_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_PULSE_AUDIO_MANAGER))
#define SOUND_PULSE_AUDIO_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManagerClass))

typedef struct _SoundPulseAudioManager SoundPulseAudioManager;
typedef struct _SoundPulseAudioManagerClass SoundPulseAudioManagerClass;
typedef struct _SoundPulseAudioManagerPrivate SoundPulseAudioManagerPrivate;

#define SOUND_TYPE_DEVICE (sound_device_get_type ())
#define SOUND_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE, SoundDevice))
#define SOUND_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE, SoundDeviceClass))
#define SOUND_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE))
#define SOUND_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE))
#define SOUND_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE, SoundDeviceClass))

typedef struct _SoundDevice SoundDevice;
typedef struct _SoundDeviceClass SoundDeviceClass;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_0_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES
};
static GParamSpec* sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES];
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _pa_glib_mainloop_free0(var) ((var == NULL) ? NULL : (var = (pa_glib_mainloop_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SoundPulseAudioManagerSetDefaultDeviceData SoundPulseAudioManagerSetDefaultDeviceData;
typedef struct _Block1Data Block1Data;
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))
typedef struct _SoundPulseAudioManagerSetCardProfileByIndexData SoundPulseAudioManagerSetCardProfileByIndexData;
typedef struct _Block2Data Block2Data;
typedef struct _SoundPulseAudioManagerWaitForUpdateData SoundPulseAudioManagerWaitForUpdateData;
typedef struct _Block3Data Block3Data;
typedef struct _SoundPulseAudioManagerSetSinkPortByNameData SoundPulseAudioManagerSetSinkPortByNameData;
typedef struct _Block4Data Block4Data;
typedef struct _SoundPulseAudioManagerSetSourcePortByNameData SoundPulseAudioManagerSetSourcePortByNameData;
typedef struct _Block5Data Block5Data;
typedef struct _SoundPulseAudioManagerSetDefaultSinkData SoundPulseAudioManagerSetDefaultSinkData;
typedef struct _Block6Data Block6Data;
typedef struct _SoundPulseAudioManagerSetDefaultSourceData SoundPulseAudioManagerSetDefaultSourceData;
typedef struct _Block7Data Block7Data;
typedef struct _SoundDevicePrivate SoundDevicePrivate;
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
typedef struct _SoundPulseAudioManagerReconnectToPulseData SoundPulseAudioManagerReconnectToPulseData;
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL,
	SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS
};
static guint sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS] = {0};

struct _SoundPulseAudioManager {
	GObject parent_instance;
	SoundPulseAudioManagerPrivate * priv;
};

struct _SoundPulseAudioManagerClass {
	GObjectClass parent_class;
};

struct _SoundPulseAudioManagerPrivate {
	pa_context* _context;
	pa_glib_mainloop* loop;
	gboolean is_ready;
	guint reconnect_timer_id;
	GeeHashMap* input_devices;
	GeeHashMap* output_devices;
	SoundDevice* _default_output;
	SoundDevice* _default_input;
	gchar* default_source_name;
	gchar* default_sink_name;
	GeeHashMap* volume_operations;
};

struct _SoundPulseAudioManagerSetDefaultDeviceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	SoundDevice* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	SoundDevice* _tmp8_;
	SoundDevice* _tmp9_;
	SoundDevice* other_device;
	SoundDevice* _tmp10_;
	gchar* profile_name;
	SoundDevice* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	GeeArrayList* _tmp14_;
	GeeArrayList* _tmp15_;
	gpointer _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	guint32 _tmp23_;
	guint32 _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gboolean _tmp44_;
	gboolean _tmp45_;
	gboolean _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	gboolean _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	gboolean _tmp71_;
	gboolean _tmp72_;
	gboolean _tmp73_;
	gboolean _tmp74_;
	gboolean _tmp75_;
	const gchar* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	gboolean _tmp84_;
	gboolean _tmp85_;
	gboolean _tmp86_;
	const gchar* _tmp87_;
	const gchar* _tmp88_;
	const gchar* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp91_;
	const gchar* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
};

struct _Block1Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	guint32 card_index;
	gchar* profile_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetCardProfileByIndexData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SoundPulseAudioManager* self;
	guint32 card_index;
	gchar* profile_name;
	Block1Data* _data1_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block2Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gulong handler_id;
	SoundDevice* device;
	gchar* prop_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerWaitForUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
	gchar* prop_name;
	Block2Data* _data2_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gulong _tmp3_;
};

struct _Block3Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gchar* port_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetSinkPortByNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gchar* port_name;
	Block3Data* _data3_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block4Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gchar* port_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetSourcePortByNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gchar* port_name;
	Block4Data* _data4_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block5Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetDefaultSinkData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	Block5Data* _data5_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block6Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetDefaultSourceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	Block6Data* _data6_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block7Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _SoundDevice {
	GObject parent_instance;
	SoundDevicePrivate * priv;
	GeeLinkedList* volume_operations;
};

struct _SoundDeviceClass {
	GObjectClass parent_class;
};

struct _SoundPulseAudioManagerReconnectToPulseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	SoundPulseAudioManager* self;
	pa_context* _tmp0_;
	pa_proplist* props;
	pa_proplist* _tmp1_;
	pa_proplist* _tmp2_;
	pa_glib_mainloop* _tmp3_;
	pa_mainloop_api* _tmp4_;
	pa_proplist* _tmp5_;
	pa_context* _tmp6_;
	pa_context* _tmp7_;
	pa_context* _tmp8_;
	pa_context* _tmp9_;
	pa_context* _tmp10_;
	const gchar* _tmp11_;
};

struct _Block8Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _Block9Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

static gint SoundPulseAudioManager_private_offset;
static gpointer sound_pulse_audio_manager_parent_class = NULL;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam = NULL;
static gboolean sound_pulse_audio_manager_DEBUG_ENABLED;
static gboolean sound_pulse_audio_manager_DEBUG_ENABLED = FALSE;

GType sound_pulse_audio_manager_get_type (void) G_GNUC_CONST;
GType sound_device_get_type (void) G_GNUC_CONST;
SoundPulseAudioManager* sound_pulse_audio_manager_get_default (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_new (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_construct (GType object_type);
void sound_pulse_audio_manager_start (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_device_data_free (gpointer _data);
static void sound_pulse_audio_manager_set_default_device_async_ready_wrapper (GObject *source_object,
                                                                       GAsyncResult *res,
                                                                       void *user_data);
void sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                                   SoundDevice* device,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
void sound_pulse_audio_manager_set_default_device_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static gboolean sound_pulse_audio_manager_set_default_device_co (SoundPulseAudioManagerSetDefaultDeviceData* _data_);
const gchar* sound_device_get_id (SoundDevice* self);
gboolean sound_device_get_input (SoundDevice* self);
SoundDevice* sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self);
SoundDevice* sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self);
gchar* sound_device_get_matching_profile (SoundDevice* self,
                                          SoundDevice* other_device);
GeeArrayList* sound_device_get_profiles (SoundDevice* self);
const gchar* sound_device_get_card_active_profile_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_card_profile_by_index (SoundPulseAudioManager* self,
                                                          guint32 card_index,
                                                          const gchar* profile_name,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static void sound_pulse_audio_manager_set_card_profile_by_index_finish (SoundPulseAudioManager* self,
                                                                 GAsyncResult* _res_);
guint32 sound_device_get_card_index (SoundDevice* self);
static void sound_pulse_audio_manager_set_default_device_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void sound_pulse_audio_manager_wait_for_update (SoundPulseAudioManager* self,
                                                SoundDevice* device,
                                                const gchar* prop_name,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void sound_pulse_audio_manager_wait_for_update_finish (SoundPulseAudioManager* self,
                                                       GAsyncResult* _res_);
const gchar* sound_device_get_port_name (SoundDevice* self);
const gchar* sound_device_get_card_sink_port_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_sink_port_by_name (SoundPulseAudioManager* self,
                                                      const gchar* sink_name,
                                                      const gchar* port_name,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static void sound_pulse_audio_manager_set_sink_port_by_name_finish (SoundPulseAudioManager* self,
                                                             GAsyncResult* _res_);
const gchar* sound_device_get_card_sink_name (SoundDevice* self);
const gchar* sound_device_get_card_source_port_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_source_port_by_name (SoundPulseAudioManager* self,
                                                        const gchar* source_name,
                                                        const gchar* port_name,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static void sound_pulse_audio_manager_set_source_port_by_name_finish (SoundPulseAudioManager* self,
                                                               GAsyncResult* _res_);
const gchar* sound_device_get_card_source_name (SoundDevice* self);
const gchar* sound_device_get_sink_name (SoundDevice* self);
const gchar* sound_device_get_source_name (SoundDevice* self);
static void sound_pulse_audio_manager_set_default_sink (SoundPulseAudioManager* self,
                                                 const gchar* sink_name,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void sound_pulse_audio_manager_set_default_sink_finish (SoundPulseAudioManager* self,
                                                        GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_source (SoundPulseAudioManager* self,
                                                   const gchar* source_name,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_set_default_source_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_card_profile_by_index_data_free (gpointer _data);
static void sound_pulse_audio_manager_set_card_profile_by_index_async_ready_wrapper (GObject *source_object,
                                                                              GAsyncResult *res,
                                                                              void *user_data);
static gboolean sound_pulse_audio_manager_set_card_profile_by_index_co (SoundPulseAudioManagerSetCardProfileByIndexData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
pa_context* sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self);
static void __lambda9_ (Block1Data* _data1_,
                 pa_context* c,
                 gint success);
static void ___lambda9__pa_context_success_cb_t (pa_context* c,
                                          gint success,
                                          gpointer self);
static void sound_pulse_audio_manager_wait_for_update_data_free (gpointer _data);
static void sound_pulse_audio_manager_wait_for_update_async_ready_wrapper (GObject *source_object,
                                                                    GAsyncResult *res,
                                                                    void *user_data);
static gboolean sound_pulse_audio_manager_wait_for_update_co (SoundPulseAudioManagerWaitForUpdateData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda10_ (Block2Data* _data2_,
                  GObject* s,
                  GParamSpec* p);
static void ___lambda10__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void sound_pulse_audio_manager_set_sink_port_by_name_data_free (gpointer _data);
static void sound_pulse_audio_manager_set_sink_port_by_name_async_ready_wrapper (GObject *source_object,
                                                                          GAsyncResult *res,
                                                                          void *user_data);
static gboolean sound_pulse_audio_manager_set_sink_port_by_name_co (SoundPulseAudioManagerSetSinkPortByNameData* _data_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda11_ (Block3Data* _data3_,
                  pa_context* c,
                  gint success);
static void ___lambda11__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_source_port_by_name_data_free (gpointer _data);
static void sound_pulse_audio_manager_set_source_port_by_name_async_ready_wrapper (GObject *source_object,
                                                                            GAsyncResult *res,
                                                                            void *user_data);
static gboolean sound_pulse_audio_manager_set_source_port_by_name_co (SoundPulseAudioManagerSetSourcePortByNameData* _data_);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda12_ (Block4Data* _data4_,
                  pa_context* c,
                  gint success);
static void ___lambda12__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_default_sink_data_free (gpointer _data);
static void sound_pulse_audio_manager_set_default_sink_async_ready_wrapper (GObject *source_object,
                                                                     GAsyncResult *res,
                                                                     void *user_data);
static gboolean sound_pulse_audio_manager_set_default_sink_co (SoundPulseAudioManagerSetDefaultSinkData* _data_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda13_ (Block5Data* _data5_,
                  pa_context* c,
                  gint success);
static void ___lambda13__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_default_source_data_free (gpointer _data);
static void sound_pulse_audio_manager_set_default_source_async_ready_wrapper (GObject *source_object,
                                                                       GAsyncResult *res,
                                                                       void *user_data);
static gboolean sound_pulse_audio_manager_set_default_source_co (SoundPulseAudioManagerSetDefaultSourceData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda14_ (Block6Data* _data6_,
                  pa_context* c,
                  gint success);
static void ___lambda14__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
void sound_pulse_audio_manager_change_device_mute (SoundPulseAudioManager* self,
                                                   SoundDevice* device,
                                                   gboolean mute);
void sound_pulse_audio_manager_change_device_volume (SoundPulseAudioManager* self,
                                                     SoundDevice* device,
                                                     gdouble volume);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean __lambda15_ (Block7Data* _data7_,
                      pa_operation* operation);
static gboolean ___lambda15__gee_forall_func (gpointer g,
                                       gpointer self);
void sound_device_get_cvolume (SoundDevice* self,
                               pa_cvolume * result);
static pa_volume_t sound_pulse_audio_manager_double_to_volume (gdouble vol);
void sound_pulse_audio_manager_change_device_balance (SoundPulseAudioManager* self,
                                                      SoundDevice* device,
                                                      gfloat balance);
void sound_device_get_channel_map (SoundDevice* self,
                                   pa_channel_map * result);
static gboolean sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data);
static void sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper (GObject *source_object,
                                                                       GAsyncResult *res,
                                                                       void *user_data);
static gboolean sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_);
static void sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self,
                                            pa_context* value);
static void sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                       pa_context* c);
static void _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                               gpointer self);
static void sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_subscription_event_type_t t,
                                                   guint32 index);
static void _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                              pa_subscription_event_type_t t,
                                                                              guint32 idx,
                                                                              gpointer self);
static void sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* context,
                                                     pa_server_info* server);
static void _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                          pa_server_info* i,
                                                                          gpointer self);
static gboolean _sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self);
static void sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_sink_info* sink,
                                                   gint eol);
static void _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                      pa_sink_info* i,
                                                                      gint eol,
                                                                      gpointer self);
gint sound_device_get_sink_index (SoundDevice* self);
void sound_device_set_sink_name (SoundDevice* self,
                                 const gchar* value);
void sound_device_set_sink_index (SoundDevice* self,
                                  gint value);
void sound_device_set_is_default (SoundDevice* self,
                                  gboolean value);
gint sound_device_get_card_sink_index (SoundDevice* self);
void sound_device_set_card_sink_name (SoundDevice* self,
                                      const gchar* value);
void sound_device_set_card_sink_index (SoundDevice* self,
                                       gint value);
void sound_device_set_card_sink_port_name (SoundDevice* self,
                                           const gchar* value);
static void sound_pulse_audio_manager_card_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_card_info* card,
                                                   gint eol);
static void _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t (pa_context* c,
                                                                      pa_card_info* i,
                                                                      gint eol,
                                                                      gpointer self);
static void sound_pulse_audio_manager_remove_devices_by_card (SoundPulseAudioManager* self,
                                                       GeeHashMap* devices,
                                                       guint32 card_index);
static void sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* c,
                                                     pa_source_info* source,
                                                     gint eol);
static void _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                          pa_source_info* i,
                                                                          gint eol,
                                                                          gpointer self);
gint sound_device_get_source_index (SoundDevice* self);
void sound_device_set_source_name (SoundDevice* self,
                                   const gchar* value);
void sound_device_set_source_index (SoundDevice* self,
                                    gint value);
gint sound_device_get_card_source_index (SoundDevice* self);
void sound_device_set_card_source_name (SoundDevice* self,
                                        const gchar* value);
void sound_device_set_card_source_index (SoundDevice* self,
                                         gint value);
void sound_device_set_card_source_port_name (SoundDevice* self,
                                             const gchar* value);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
gboolean sound_device_get_is_default (SoundDevice* self);
void sound_device_set_is_muted (SoundDevice* self,
                                gboolean value);
void sound_device_set_cvolume (SoundDevice* self,
                               pa_cvolume * value);
void sound_device_set_channel_map (SoundDevice* self,
                                   pa_channel_map * value);
void sound_device_set_balance (SoundDevice* self,
                               gfloat value);
static gboolean ______lambda8_ (Block8Data* _data8_,
                         pa_operation* operation);
static gboolean _______lambda8__gee_forall_func (gpointer g,
                                          gpointer self);
static gdouble sound_pulse_audio_manager_volume_to_double (pa_volume_t vol);
void sound_device_set_volume (SoundDevice* self,
                              gdouble value);
static void sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                                  SoundDevice* value);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static gboolean ______lambda5_ (Block9Data* _data9_,
                         pa_operation* operation);
static gboolean _______lambda5__gee_forall_func (gpointer g,
                                          gpointer self);
static void sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                                   SoundDevice* value);
static void _vala_array_add1 (pa_card_port_info** * array,
                       int* length,
                       int* size,
                       pa_card_port_info* value);
static gchar* sound_pulse_audio_manager_get_device_id (pa_card_info* card,
                                                pa_card_port_info* port);
SoundDevice* sound_device_new (const gchar* id,
                               guint32 card_index,
                               const gchar* port_name);
SoundDevice* sound_device_construct (GType object_type,
                                     const gchar* id,
                                     guint32 card_index,
                                     const gchar* port_name);
void sound_device_set_card_active_profile_name (SoundDevice* self,
                                                const gchar* value);
void sound_device_set_input (SoundDevice* self,
                             gboolean value);
void sound_device_set_card_name (SoundDevice* self,
                                 const gchar* value);
void sound_device_set_display_name (SoundDevice* self,
                                    const gchar* value);
void sound_device_set_form_factor (SoundDevice* self,
                                   const gchar* value);
static GeeArrayList* sound_pulse_audio_manager_get_relevant_card_port_profiles (SoundPulseAudioManager* self,
                                                                         pa_card_port_info* port);
void sound_device_set_profiles (SoundDevice* self,
                                GeeArrayList* value);
static void sound_pulse_audio_manager_cleanup_devices (SoundPulseAudioManager* self,
                                                GeeHashMap* devices,
                                                pa_card_info* card,
                                                pa_card_port_info** relevant_ports,
                                                gint relevant_ports_length1);
static pa_card_profile_info2** _vala_array_dup1 (pa_card_profile_info2** self,
                                          int length);
static gint __lambda7_ (SoundPulseAudioManager* self,
                 pa_card_profile_info2* a,
                 pa_card_profile_info2* b);
static gint ___lambda7__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                      pa_context* c,
                                                                      pa_ext_stream_restore_info* info,
                                                                      gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                              pa_ext_stream_restore_info* info,
                                                                                                              gint eol,
                                                                                                              gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                        pa_context* c,
                                                                        pa_ext_stream_restore_info* info,
                                                                        gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                                pa_ext_stream_restore_info* info,
                                                                                                                gint eol,
                                                                                                                gpointer self);
static void __lambda6_ (SoundPulseAudioManager* self,
                 pa_context* c,
                 gint success);
static void ___lambda6__pa_context_success_cb_t (pa_context* c,
                                          gint success,
                                          gpointer self);
static GObject * sound_pulse_audio_manager_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      int stack_length,
                                      const gchar* needle);
static void sound_pulse_audio_manager_finalize (GObject * obj);
static void _vala_sound_pulse_audio_manager_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_sound_pulse_audio_manager_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
sound_pulse_audio_manager_get_instance_private (SoundPulseAudioManager* self)
{
	return G_STRUCT_MEMBER_P (self, SoundPulseAudioManager_private_offset);
}

SoundPulseAudioManager*
sound_pulse_audio_manager_get_default (void)
{
	SoundPulseAudioManager* result = NULL;
	SoundPulseAudioManager* _tmp0_;
	SoundPulseAudioManager* _tmp2_;
#line 34 "../src/PulseAudioManager.vala"
	_tmp0_ = sound_pulse_audio_manager_pam;
#line 34 "../src/PulseAudioManager.vala"
	if (_tmp0_ == NULL) {
#line 822 "PulseAudioManager.c"
		SoundPulseAudioManager* _tmp1_;
#line 35 "../src/PulseAudioManager.vala"
		_tmp1_ = sound_pulse_audio_manager_new ();
#line 35 "../src/PulseAudioManager.vala"
		_g_object_unref0 (sound_pulse_audio_manager_pam);
#line 35 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_pam = _tmp1_;
#line 830 "PulseAudioManager.c"
	}
#line 38 "../src/PulseAudioManager.vala"
	_tmp2_ = sound_pulse_audio_manager_pam;
#line 38 "../src/PulseAudioManager.vala"
	result = _tmp2_;
#line 38 "../src/PulseAudioManager.vala"
	return result;
#line 838 "PulseAudioManager.c"
}

static SoundPulseAudioManager*
sound_pulse_audio_manager_construct (GType object_type)
{
	SoundPulseAudioManager * self = NULL;
#line 55 "../src/PulseAudioManager.vala"
	self = (SoundPulseAudioManager*) g_object_new (object_type, NULL);
#line 55 "../src/PulseAudioManager.vala"
	return self;
#line 849 "PulseAudioManager.c"
}

static SoundPulseAudioManager*
sound_pulse_audio_manager_new (void)
{
#line 55 "../src/PulseAudioManager.vala"
	return sound_pulse_audio_manager_construct (SOUND_TYPE_PULSE_AUDIO_MANAGER);
#line 857 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_start (SoundPulseAudioManager* self)
{
#line 72 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
#line 867 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_device_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->device);
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetDefaultDeviceData, _data_);
#line 881 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_device_async_ready_wrapper (GObject *source_object,
                                                                  GAsyncResult *res,
                                                                  void *user_data)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _task_data_;
#line 29 "../src/PulseAudioManager.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "../src/PulseAudioManager.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 896 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	_task_data_->_task_complete_ = TRUE;
#line 900 "PulseAudioManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/PulseAudioManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 908 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                              SoundDevice* device,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultDeviceData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_callback_ = _callback_;
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sound_pulse_audio_manager_set_default_device_async_ready_wrapper, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	if (_callback_ == NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_data_->_task_complete_ = TRUE;
#line 930 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_device_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = _g_object_ref0 (device);
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->device);
#line 29 "../src/PulseAudioManager.vala"
	_data_->device = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_device_co (_data_);
#line 946 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_set_default_device_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 956 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_device_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
#line 95 "../src/PulseAudioManager.vala"
	_data_ = _user_data_;
#line 95 "../src/PulseAudioManager.vala"
	_data_->_source_object_ = source_object;
#line 95 "../src/PulseAudioManager.vala"
	_data_->_res_ = _res_;
#line 95 "../src/PulseAudioManager.vala"
	_data_->_task_complete_ = TRUE;
#line 95 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_device_co (_data_);
#line 975 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_default_device_co (SoundPulseAudioManagerSetDefaultDeviceData* _data_)
{
#line 76 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 76 "../src/PulseAudioManager.vala"
		case 0:
#line 985 "PulseAudioManager.c"
		goto _state_0;
#line 76 "../src/PulseAudioManager.vala"
		case 1:
#line 989 "PulseAudioManager.c"
		goto _state_1;
#line 76 "../src/PulseAudioManager.vala"
		case 2:
#line 993 "PulseAudioManager.c"
		goto _state_2;
#line 76 "../src/PulseAudioManager.vala"
		case 3:
#line 997 "PulseAudioManager.c"
		goto _state_3;
#line 76 "../src/PulseAudioManager.vala"
		case 4:
#line 1001 "PulseAudioManager.c"
		goto _state_4;
#line 76 "../src/PulseAudioManager.vala"
		case 5:
#line 1005 "PulseAudioManager.c"
		goto _state_5;
#line 76 "../src/PulseAudioManager.vala"
		case 6:
#line 1009 "PulseAudioManager.c"
		goto _state_6;
#line 76 "../src/PulseAudioManager.vala"
		case 7:
#line 1013 "PulseAudioManager.c"
		goto _state_7;
		default:
#line 76 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 1018 "PulseAudioManager.c"
	}
	_state_0:
#line 77 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:77: \n");
#line 78 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = sound_device_get_id (_data_->device);
#line 78 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 78 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:78: set_default_device: %s", _data_->_tmp1_);
#line 79 "../src/PulseAudioManager.vala"
	_data_->_tmp3_ = sound_device_get_input (_data_->device);
#line 79 "../src/PulseAudioManager.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 79 "../src/PulseAudioManager.vala"
	if (_data_->_tmp4_) {
#line 79 "../src/PulseAudioManager.vala"
		_data_->_tmp2_ = "input";
#line 1037 "PulseAudioManager.c"
	} else {
#line 79 "../src/PulseAudioManager.vala"
		_data_->_tmp2_ = "output";
#line 1041 "PulseAudioManager.c"
	}
#line 79 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:79: \t%s", _data_->_tmp2_);
#line 85 "../src/PulseAudioManager.vala"
	_data_->_tmp6_ = sound_device_get_input (_data_->device);
#line 85 "../src/PulseAudioManager.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 85 "../src/PulseAudioManager.vala"
	if (_data_->_tmp7_) {
#line 85 "../src/PulseAudioManager.vala"
		_data_->_tmp8_ = _data_->self->priv->_default_output;
#line 85 "../src/PulseAudioManager.vala"
		_data_->_tmp5_ = _data_->_tmp8_;
#line 1055 "PulseAudioManager.c"
	} else {
#line 85 "../src/PulseAudioManager.vala"
		_data_->_tmp9_ = _data_->self->priv->_default_input;
#line 85 "../src/PulseAudioManager.vala"
		_data_->_tmp5_ = _data_->_tmp9_;
#line 1061 "PulseAudioManager.c"
	}
#line 85 "../src/PulseAudioManager.vala"
	_data_->_tmp10_ = _g_object_ref0 (_data_->_tmp5_);
#line 85 "../src/PulseAudioManager.vala"
	_data_->other_device = _data_->_tmp10_;
#line 86 "../src/PulseAudioManager.vala"
	_data_->_tmp11_ = _data_->other_device;
#line 86 "../src/PulseAudioManager.vala"
	_data_->_tmp12_ = sound_device_get_matching_profile (_data_->device, _data_->_tmp11_);
#line 86 "../src/PulseAudioManager.vala"
	_data_->profile_name = _data_->_tmp12_;
#line 88 "../src/PulseAudioManager.vala"
	_data_->_tmp13_ = _data_->profile_name;
#line 88 "../src/PulseAudioManager.vala"
	if (_data_->_tmp13_ == NULL) {
#line 89 "../src/PulseAudioManager.vala"
		_data_->_tmp14_ = sound_device_get_profiles (_data_->device);
#line 89 "../src/PulseAudioManager.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 89 "../src/PulseAudioManager.vala"
		_data_->_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp15_, 0);
#line 89 "../src/PulseAudioManager.vala"
		_g_free0 (_data_->profile_name);
#line 89 "../src/PulseAudioManager.vala"
		_data_->profile_name = (gchar*) _data_->_tmp16_;
#line 1087 "PulseAudioManager.c"
	}
#line 92 "../src/PulseAudioManager.vala"
	_data_->_tmp17_ = _data_->profile_name;
#line 92 "../src/PulseAudioManager.vala"
	_data_->_tmp18_ = sound_device_get_card_active_profile_name (_data_->device);
#line 92 "../src/PulseAudioManager.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 92 "../src/PulseAudioManager.vala"
	if (g_strcmp0 (_data_->_tmp17_, _data_->_tmp19_) != 0) {
#line 93 "../src/PulseAudioManager.vala"
		_data_->_tmp20_ = sound_device_get_card_active_profile_name (_data_->device);
#line 93 "../src/PulseAudioManager.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 93 "../src/PulseAudioManager.vala"
		_data_->_tmp22_ = _data_->profile_name;
#line 93 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:93: set card profile: %s > %s", _data_->_tmp21_, _data_->_tmp22_);
#line 95 "../src/PulseAudioManager.vala"
		_data_->_tmp23_ = sound_device_get_card_index (_data_->device);
#line 95 "../src/PulseAudioManager.vala"
		_data_->_tmp24_ = _data_->_tmp23_;
#line 95 "../src/PulseAudioManager.vala"
		_data_->_tmp25_ = _data_->profile_name;
#line 95 "../src/PulseAudioManager.vala"
		_data_->_state_ = 1;
#line 95 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_card_profile_by_index (_data_->self, _data_->_tmp24_, _data_->_tmp25_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 95 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1117 "PulseAudioManager.c"
		_state_1:
#line 95 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_card_profile_by_index_finish (_data_->self, _data_->_res_);
#line 97 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:97: wait for card sink / source");
#line 98 "../src/PulseAudioManager.vala"
		_data_->_tmp27_ = sound_device_get_input (_data_->device);
#line 98 "../src/PulseAudioManager.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 98 "../src/PulseAudioManager.vala"
		if (_data_->_tmp28_) {
#line 98 "../src/PulseAudioManager.vala"
			_data_->_tmp26_ = "card-source-name";
#line 1131 "PulseAudioManager.c"
		} else {
#line 98 "../src/PulseAudioManager.vala"
			_data_->_tmp26_ = "card-sink-name";
#line 1135 "PulseAudioManager.c"
		}
#line 98 "../src/PulseAudioManager.vala"
		_data_->_state_ = 2;
#line 98 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update (_data_->self, _data_->device, _data_->_tmp26_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 98 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1143 "PulseAudioManager.c"
		_state_2:
#line 98 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update_finish (_data_->self, _data_->_res_);
#line 1147 "PulseAudioManager.c"
	}
#line 103 "../src/PulseAudioManager.vala"
	_data_->_tmp30_ = sound_device_get_input (_data_->device);
#line 103 "../src/PulseAudioManager.vala"
	_data_->_tmp31_ = _data_->_tmp30_;
#line 103 "../src/PulseAudioManager.vala"
	if (!_data_->_tmp31_) {
#line 103 "../src/PulseAudioManager.vala"
		_data_->_tmp32_ = sound_device_get_port_name (_data_->device);
#line 103 "../src/PulseAudioManager.vala"
		_data_->_tmp33_ = _data_->_tmp32_;
#line 103 "../src/PulseAudioManager.vala"
		_data_->_tmp34_ = sound_device_get_card_sink_port_name (_data_->device);
#line 103 "../src/PulseAudioManager.vala"
		_data_->_tmp35_ = _data_->_tmp34_;
#line 103 "../src/PulseAudioManager.vala"
		_data_->_tmp29_ = g_strcmp0 (_data_->_tmp33_, _data_->_tmp35_) != 0;
#line 1165 "PulseAudioManager.c"
	} else {
#line 103 "../src/PulseAudioManager.vala"
		_data_->_tmp29_ = FALSE;
#line 1169 "PulseAudioManager.c"
	}
#line 103 "../src/PulseAudioManager.vala"
	if (_data_->_tmp29_) {
#line 104 "../src/PulseAudioManager.vala"
		_data_->_tmp36_ = sound_device_get_card_sink_port_name (_data_->device);
#line 104 "../src/PulseAudioManager.vala"
		_data_->_tmp37_ = _data_->_tmp36_;
#line 104 "../src/PulseAudioManager.vala"
		_data_->_tmp38_ = sound_device_get_port_name (_data_->device);
#line 104 "../src/PulseAudioManager.vala"
		_data_->_tmp39_ = _data_->_tmp38_;
#line 104 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:104: set sink port: %s > %s", _data_->_tmp37_, _data_->_tmp39_);
#line 106 "../src/PulseAudioManager.vala"
		_data_->_tmp40_ = sound_device_get_card_sink_name (_data_->device);
#line 106 "../src/PulseAudioManager.vala"
		_data_->_tmp41_ = _data_->_tmp40_;
#line 106 "../src/PulseAudioManager.vala"
		_data_->_tmp42_ = sound_device_get_port_name (_data_->device);
#line 106 "../src/PulseAudioManager.vala"
		_data_->_tmp43_ = _data_->_tmp42_;
#line 106 "../src/PulseAudioManager.vala"
		_data_->_state_ = 3;
#line 106 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_sink_port_by_name (_data_->self, _data_->_tmp41_, _data_->_tmp43_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 106 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1197 "PulseAudioManager.c"
		_state_3:
#line 106 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_sink_port_by_name_finish (_data_->self, _data_->_res_);
#line 1201 "PulseAudioManager.c"
	}
#line 109 "../src/PulseAudioManager.vala"
	_data_->_tmp45_ = sound_device_get_input (_data_->device);
#line 109 "../src/PulseAudioManager.vala"
	_data_->_tmp46_ = _data_->_tmp45_;
#line 109 "../src/PulseAudioManager.vala"
	if (_data_->_tmp46_) {
#line 109 "../src/PulseAudioManager.vala"
		_data_->_tmp47_ = sound_device_get_port_name (_data_->device);
#line 109 "../src/PulseAudioManager.vala"
		_data_->_tmp48_ = _data_->_tmp47_;
#line 109 "../src/PulseAudioManager.vala"
		_data_->_tmp49_ = sound_device_get_card_source_port_name (_data_->device);
#line 109 "../src/PulseAudioManager.vala"
		_data_->_tmp50_ = _data_->_tmp49_;
#line 109 "../src/PulseAudioManager.vala"
		_data_->_tmp44_ = g_strcmp0 (_data_->_tmp48_, _data_->_tmp50_) != 0;
#line 1219 "PulseAudioManager.c"
	} else {
#line 109 "../src/PulseAudioManager.vala"
		_data_->_tmp44_ = FALSE;
#line 1223 "PulseAudioManager.c"
	}
#line 109 "../src/PulseAudioManager.vala"
	if (_data_->_tmp44_) {
#line 110 "../src/PulseAudioManager.vala"
		_data_->_tmp51_ = sound_device_get_card_source_port_name (_data_->device);
#line 110 "../src/PulseAudioManager.vala"
		_data_->_tmp52_ = _data_->_tmp51_;
#line 110 "../src/PulseAudioManager.vala"
		_data_->_tmp53_ = sound_device_get_port_name (_data_->device);
#line 110 "../src/PulseAudioManager.vala"
		_data_->_tmp54_ = _data_->_tmp53_;
#line 110 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:110: set source port: %s > %s", _data_->_tmp52_, _data_->_tmp54_);
#line 111 "../src/PulseAudioManager.vala"
		_data_->_tmp55_ = sound_device_get_card_source_name (_data_->device);
#line 111 "../src/PulseAudioManager.vala"
		_data_->_tmp56_ = _data_->_tmp55_;
#line 111 "../src/PulseAudioManager.vala"
		_data_->_tmp57_ = sound_device_get_port_name (_data_->device);
#line 111 "../src/PulseAudioManager.vala"
		_data_->_tmp58_ = _data_->_tmp57_;
#line 111 "../src/PulseAudioManager.vala"
		_data_->_state_ = 4;
#line 111 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_source_port_by_name (_data_->self, _data_->_tmp56_, _data_->_tmp58_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 111 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1251 "PulseAudioManager.c"
		_state_4:
#line 111 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_source_port_by_name_finish (_data_->self, _data_->_res_);
#line 1255 "PulseAudioManager.c"
	}
#line 115 "../src/PulseAudioManager.vala"
	_data_->_tmp61_ = sound_device_get_input (_data_->device);
#line 115 "../src/PulseAudioManager.vala"
	_data_->_tmp62_ = _data_->_tmp61_;
#line 115 "../src/PulseAudioManager.vala"
	if (!_data_->_tmp62_) {
#line 115 "../src/PulseAudioManager.vala"
		_data_->_tmp63_ = sound_device_get_sink_name (_data_->device);
#line 115 "../src/PulseAudioManager.vala"
		_data_->_tmp64_ = _data_->_tmp63_;
#line 115 "../src/PulseAudioManager.vala"
		_data_->_tmp60_ = _data_->_tmp64_ == NULL;
#line 1269 "PulseAudioManager.c"
	} else {
#line 115 "../src/PulseAudioManager.vala"
		_data_->_tmp60_ = FALSE;
#line 1273 "PulseAudioManager.c"
	}
#line 115 "../src/PulseAudioManager.vala"
	if (_data_->_tmp60_) {
#line 115 "../src/PulseAudioManager.vala"
		_data_->_tmp59_ = TRUE;
#line 1279 "PulseAudioManager.c"
	} else {
#line 116 "../src/PulseAudioManager.vala"
		_data_->_tmp66_ = sound_device_get_input (_data_->device);
#line 116 "../src/PulseAudioManager.vala"
		_data_->_tmp67_ = _data_->_tmp66_;
#line 116 "../src/PulseAudioManager.vala"
		if (_data_->_tmp67_) {
#line 116 "../src/PulseAudioManager.vala"
			_data_->_tmp68_ = sound_device_get_source_name (_data_->device);
#line 116 "../src/PulseAudioManager.vala"
			_data_->_tmp69_ = _data_->_tmp68_;
#line 116 "../src/PulseAudioManager.vala"
			_data_->_tmp65_ = _data_->_tmp69_ == NULL;
#line 1293 "PulseAudioManager.c"
		} else {
#line 116 "../src/PulseAudioManager.vala"
			_data_->_tmp65_ = FALSE;
#line 1297 "PulseAudioManager.c"
		}
#line 116 "../src/PulseAudioManager.vala"
		_data_->_tmp59_ = _data_->_tmp65_;
#line 1301 "PulseAudioManager.c"
	}
#line 115 "../src/PulseAudioManager.vala"
	if (_data_->_tmp59_) {
#line 117 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:117: wait for sink / source");
#line 118 "../src/PulseAudioManager.vala"
		_data_->_tmp71_ = sound_device_get_input (_data_->device);
#line 118 "../src/PulseAudioManager.vala"
		_data_->_tmp72_ = _data_->_tmp71_;
#line 118 "../src/PulseAudioManager.vala"
		if (_data_->_tmp72_) {
#line 118 "../src/PulseAudioManager.vala"
			_data_->_tmp70_ = "source-name";
#line 1315 "PulseAudioManager.c"
		} else {
#line 118 "../src/PulseAudioManager.vala"
			_data_->_tmp70_ = "sink-name";
#line 1319 "PulseAudioManager.c"
		}
#line 118 "../src/PulseAudioManager.vala"
		_data_->_state_ = 5;
#line 118 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update (_data_->self, _data_->device, _data_->_tmp70_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 118 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1327 "PulseAudioManager.c"
		_state_5:
#line 118 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update_finish (_data_->self, _data_->_res_);
#line 1331 "PulseAudioManager.c"
	}
#line 123 "../src/PulseAudioManager.vala"
	_data_->_tmp74_ = sound_device_get_input (_data_->device);
#line 123 "../src/PulseAudioManager.vala"
	_data_->_tmp75_ = _data_->_tmp74_;
#line 123 "../src/PulseAudioManager.vala"
	if (!_data_->_tmp75_) {
#line 123 "../src/PulseAudioManager.vala"
		_data_->_tmp76_ = sound_device_get_sink_name (_data_->device);
#line 123 "../src/PulseAudioManager.vala"
		_data_->_tmp77_ = _data_->_tmp76_;
#line 123 "../src/PulseAudioManager.vala"
		_data_->_tmp78_ = _data_->self->priv->default_sink_name;
#line 123 "../src/PulseAudioManager.vala"
		_data_->_tmp73_ = g_strcmp0 (_data_->_tmp77_, _data_->_tmp78_) != 0;
#line 1347 "PulseAudioManager.c"
	} else {
#line 123 "../src/PulseAudioManager.vala"
		_data_->_tmp73_ = FALSE;
#line 1351 "PulseAudioManager.c"
	}
#line 123 "../src/PulseAudioManager.vala"
	if (_data_->_tmp73_) {
#line 124 "../src/PulseAudioManager.vala"
		_data_->_tmp79_ = _data_->self->priv->default_sink_name;
#line 124 "../src/PulseAudioManager.vala"
		_data_->_tmp80_ = sound_device_get_sink_name (_data_->device);
#line 124 "../src/PulseAudioManager.vala"
		_data_->_tmp81_ = _data_->_tmp80_;
#line 124 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:124: set sink: %s > %s", _data_->_tmp79_, _data_->_tmp81_);
#line 125 "../src/PulseAudioManager.vala"
		_data_->_tmp82_ = sound_device_get_sink_name (_data_->device);
#line 125 "../src/PulseAudioManager.vala"
		_data_->_tmp83_ = _data_->_tmp82_;
#line 125 "../src/PulseAudioManager.vala"
		_data_->_state_ = 6;
#line 125 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_sink (_data_->self, _data_->_tmp83_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 125 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1373 "PulseAudioManager.c"
		_state_6:
#line 125 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_sink_finish (_data_->self, _data_->_res_);
#line 1377 "PulseAudioManager.c"
	}
#line 128 "../src/PulseAudioManager.vala"
	_data_->_tmp85_ = sound_device_get_input (_data_->device);
#line 128 "../src/PulseAudioManager.vala"
	_data_->_tmp86_ = _data_->_tmp85_;
#line 128 "../src/PulseAudioManager.vala"
	if (_data_->_tmp86_) {
#line 128 "../src/PulseAudioManager.vala"
		_data_->_tmp87_ = sound_device_get_source_name (_data_->device);
#line 128 "../src/PulseAudioManager.vala"
		_data_->_tmp88_ = _data_->_tmp87_;
#line 128 "../src/PulseAudioManager.vala"
		_data_->_tmp89_ = _data_->self->priv->default_source_name;
#line 128 "../src/PulseAudioManager.vala"
		_data_->_tmp84_ = g_strcmp0 (_data_->_tmp88_, _data_->_tmp89_) != 0;
#line 1393 "PulseAudioManager.c"
	} else {
#line 128 "../src/PulseAudioManager.vala"
		_data_->_tmp84_ = FALSE;
#line 1397 "PulseAudioManager.c"
	}
#line 128 "../src/PulseAudioManager.vala"
	if (_data_->_tmp84_) {
#line 129 "../src/PulseAudioManager.vala"
		_data_->_tmp90_ = _data_->self->priv->default_source_name;
#line 129 "../src/PulseAudioManager.vala"
		_data_->_tmp91_ = sound_device_get_source_name (_data_->device);
#line 129 "../src/PulseAudioManager.vala"
		_data_->_tmp92_ = _data_->_tmp91_;
#line 129 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:129: set source: %s > %s", _data_->_tmp90_, _data_->_tmp92_);
#line 130 "../src/PulseAudioManager.vala"
		_data_->_tmp93_ = sound_device_get_source_name (_data_->device);
#line 130 "../src/PulseAudioManager.vala"
		_data_->_tmp94_ = _data_->_tmp93_;
#line 130 "../src/PulseAudioManager.vala"
		_data_->_state_ = 7;
#line 130 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_source (_data_->self, _data_->_tmp94_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 130 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1419 "PulseAudioManager.c"
		_state_7:
#line 130 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_source_finish (_data_->self, _data_->_res_);
#line 1423 "PulseAudioManager.c"
	}
#line 76 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->profile_name);
#line 76 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->other_device);
#line 76 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 76 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 76 "../src/PulseAudioManager.vala"
		while (!_data_->_task_complete_) {
#line 76 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1437 "PulseAudioManager.c"
		}
	}
#line 76 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 76 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1444 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_card_profile_by_index_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetCardProfileByIndexData, _data_);
#line 1456 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_card_profile_by_index_async_ready_wrapper (GObject *source_object,
                                                                         GAsyncResult *res,
                                                                         void *user_data)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _task_data_;
#line 29 "../src/PulseAudioManager.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "../src/PulseAudioManager.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 1471 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	_task_data_->_task_complete_ = TRUE;
#line 1475 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_card_profile_by_index (SoundPulseAudioManager* self,
                                                     guint32 card_index,
                                                     const gchar* profile_name,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetCardProfileByIndexData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_callback_ = _callback_;
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sound_pulse_audio_manager_set_card_profile_by_index_async_ready_wrapper, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	if (_callback_ == NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_data_->_task_complete_ = TRUE;
#line 1498 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_card_profile_by_index_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_data_->card_index = card_index;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = g_strdup (profile_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->profile_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->profile_name = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_card_profile_by_index_co (_data_);
#line 1516 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_card_profile_by_index_finish (SoundPulseAudioManager* self,
                                                            GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1526 "PulseAudioManager.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 134 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 134 "../src/PulseAudioManager.vala"
	return _data1_;
#line 1536 "PulseAudioManager.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 134 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1546 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 134 "../src/PulseAudioManager.vala"
		self = _data1_->self;
#line 134 "../src/PulseAudioManager.vala"
		_g_free0 (_data1_->profile_name);
#line 134 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 134 "../src/PulseAudioManager.vala"
		g_slice_free (Block1Data, _data1_);
#line 1556 "PulseAudioManager.c"
	}
}

static void
__lambda9_ (Block1Data* _data1_,
            pa_context* c,
            gint success)
{
	SoundPulseAudioManager* self;
#line 135 "../src/PulseAudioManager.vala"
	self = _data1_->self;
#line 135 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 136 "../src/PulseAudioManager.vala"
	if (success == 1) {
#line 137 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_card_profile_by_index_co (_data1_->_async_data_);
#line 1574 "PulseAudioManager.c"
	} else {
#line 139 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:139: setting card %u profile to %s failed", (guint) _data1_->card_index, _data1_->profile_name);
#line 1578 "PulseAudioManager.c"
	}
}

static void
___lambda9__pa_context_success_cb_t (pa_context* c,
                                     gint success,
                                     gpointer self)
{
#line 135 "../src/PulseAudioManager.vala"
	__lambda9_ (self, c, success);
#line 1589 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_card_profile_by_index_co (SoundPulseAudioManagerSetCardProfileByIndexData* _data_)
{
#line 134 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 134 "../src/PulseAudioManager.vala"
		case 0:
#line 1599 "PulseAudioManager.c"
		goto _state_0;
#line 134 "../src/PulseAudioManager.vala"
		case 1:
#line 1603 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 134 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 1608 "PulseAudioManager.c"
	}
	_state_0:
#line 134 "../src/PulseAudioManager.vala"
	_data_->_data1_ = g_slice_new0 (Block1Data);
#line 134 "../src/PulseAudioManager.vala"
	_data_->_data1_->_ref_count_ = 1;
#line 134 "../src/PulseAudioManager.vala"
	_data_->_data1_->self = g_object_ref (_data_->self);
#line 134 "../src/PulseAudioManager.vala"
	_data_->_data1_->card_index = _data_->card_index;
#line 134 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data1_->profile_name);
#line 134 "../src/PulseAudioManager.vala"
	_data_->_data1_->profile_name = _data_->profile_name;
#line 134 "../src/PulseAudioManager.vala"
	_data_->_data1_->_async_data_ = _data_;
#line 135 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->_context;
#line 135 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_card_profile_by_index (_data_->_tmp0_, _data_->_data1_->card_index, _data_->_data1_->profile_name, ___lambda9__pa_context_success_cb_t, _data_->_data1_);
#line 135 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 135 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 143 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 143 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1637 "PulseAudioManager.c"
	_state_1:
	;
#line 134 "../src/PulseAudioManager.vala"
	block1_data_unref (_data_->_data1_);
#line 134 "../src/PulseAudioManager.vala"
	_data_->_data1_ = NULL;
#line 134 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 134 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 134 "../src/PulseAudioManager.vala"
		while (!_data_->_task_complete_) {
#line 134 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1652 "PulseAudioManager.c"
		}
	}
#line 134 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 134 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1659 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_wait_for_update_data_free (gpointer _data)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerWaitForUpdateData, _data_);
#line 1671 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_wait_for_update_async_ready_wrapper (GObject *source_object,
                                                               GAsyncResult *res,
                                                               void *user_data)
{
	SoundPulseAudioManagerWaitForUpdateData* _task_data_;
#line 29 "../src/PulseAudioManager.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "../src/PulseAudioManager.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 1686 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	_task_data_->_task_complete_ = TRUE;
#line 1690 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_wait_for_update (SoundPulseAudioManager* self,
                                           SoundDevice* device,
                                           const gchar* prop_name,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	gchar* _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerWaitForUpdateData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_callback_ = _callback_;
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sound_pulse_audio_manager_wait_for_update_async_ready_wrapper, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	if (_callback_ == NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_data_->_task_complete_ = TRUE;
#line 1714 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_wait_for_update_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = _g_object_ref0 (device);
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->device);
#line 29 "../src/PulseAudioManager.vala"
	_data_->device = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp2_ = g_strdup (prop_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->prop_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->prop_name = _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_wait_for_update_co (_data_);
#line 1736 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_wait_for_update_finish (SoundPulseAudioManager* self,
                                                  GAsyncResult* _res_)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1746 "PulseAudioManager.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 147 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 147 "../src/PulseAudioManager.vala"
	return _data2_;
#line 1756 "PulseAudioManager.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 147 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1766 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 147 "../src/PulseAudioManager.vala"
		self = _data2_->self;
#line 147 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data2_->device);
#line 147 "../src/PulseAudioManager.vala"
		_g_free0 (_data2_->prop_name);
#line 147 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 147 "../src/PulseAudioManager.vala"
		g_slice_free (Block2Data, _data2_);
#line 1778 "PulseAudioManager.c"
	}
}

static void
__lambda10_ (Block2Data* _data2_,
             GObject* s,
             GParamSpec* p)
{
	SoundPulseAudioManager* self;
	gchar* prop_value = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 150 "../src/PulseAudioManager.vala"
	self = _data2_->self;
#line 150 "../src/PulseAudioManager.vala"
	g_return_if_fail (s != NULL);
#line 150 "../src/PulseAudioManager.vala"
	g_return_if_fail (p != NULL);
#line 152 "../src/PulseAudioManager.vala"
	g_object_get ((GObject*) _data2_->device, _data2_->prop_name, &_tmp0_, NULL);
#line 152 "../src/PulseAudioManager.vala"
	_g_free0 (prop_value);
#line 152 "../src/PulseAudioManager.vala"
	prop_value = _tmp0_;
#line 153 "../src/PulseAudioManager.vala"
	_tmp1_ = prop_value;
#line 153 "../src/PulseAudioManager.vala"
	if (_tmp1_ != NULL) {
#line 154 "../src/PulseAudioManager.vala"
		g_signal_handler_disconnect ((GObject*) _data2_->device, _data2_->handler_id);
#line 155 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update_co (_data2_->_async_data_);
#line 1811 "PulseAudioManager.c"
	}
#line 150 "../src/PulseAudioManager.vala"
	_g_free0 (prop_value);
#line 1815 "PulseAudioManager.c"
}

static void
___lambda10__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 150 "../src/PulseAudioManager.vala"
	__lambda10_ (self, _sender, pspec);
#line 1825 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_wait_for_update_co (SoundPulseAudioManagerWaitForUpdateData* _data_)
{
#line 147 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 147 "../src/PulseAudioManager.vala"
		case 0:
#line 1835 "PulseAudioManager.c"
		goto _state_0;
#line 147 "../src/PulseAudioManager.vala"
		case 1:
#line 1839 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 147 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 1844 "PulseAudioManager.c"
	}
	_state_0:
#line 147 "../src/PulseAudioManager.vala"
	_data_->_data2_ = g_slice_new0 (Block2Data);
#line 147 "../src/PulseAudioManager.vala"
	_data_->_data2_->_ref_count_ = 1;
#line 147 "../src/PulseAudioManager.vala"
	_data_->_data2_->self = g_object_ref (_data_->self);
#line 147 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->_data2_->device);
#line 147 "../src/PulseAudioManager.vala"
	_data_->_data2_->device = _data_->device;
#line 147 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data2_->prop_name);
#line 147 "../src/PulseAudioManager.vala"
	_data_->_data2_->prop_name = _data_->prop_name;
#line 147 "../src/PulseAudioManager.vala"
	_data_->_data2_->_async_data_ = _data_;
#line 148 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = sound_device_get_id (_data_->_data2_->device);
#line 148 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 148 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:148: wait_for_update: %s:%s", _data_->_tmp1_, _data_->_data2_->prop_name);
#line 149 "../src/PulseAudioManager.vala"
	_data_->_data2_->handler_id = (gulong) 0;
#line 150 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = g_strconcat ("notify::", _data_->_data2_->prop_name, NULL);
#line 150 "../src/PulseAudioManager.vala"
	_data_->_tmp3_ = g_signal_connect_data ((GObject*) _data_->_data2_->device, _data_->_tmp2_, (GCallback) ___lambda10__g_object_notify, block2_data_ref (_data_->_data2_), (GClosureNotify) block2_data_unref, 0);
#line 150 "../src/PulseAudioManager.vala"
	_data_->_data2_->handler_id = _data_->_tmp3_;
#line 150 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_tmp2_);
#line 159 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 159 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1883 "PulseAudioManager.c"
	_state_1:
	;
#line 147 "../src/PulseAudioManager.vala"
	block2_data_unref (_data_->_data2_);
#line 147 "../src/PulseAudioManager.vala"
	_data_->_data2_ = NULL;
#line 147 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 147 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 147 "../src/PulseAudioManager.vala"
		while (!_data_->_task_complete_) {
#line 147 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1898 "PulseAudioManager.c"
		}
	}
#line 147 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 147 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1905 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_sink_port_by_name_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetSinkPortByNameData, _data_);
#line 1917 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_sink_port_by_name_async_ready_wrapper (GObject *source_object,
                                                                     GAsyncResult *res,
                                                                     void *user_data)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _task_data_;
#line 29 "../src/PulseAudioManager.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "../src/PulseAudioManager.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 1932 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	_task_data_->_task_complete_ = TRUE;
#line 1936 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_sink_port_by_name (SoundPulseAudioManager* self,
                                                 const gchar* sink_name,
                                                 const gchar* port_name,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetSinkPortByNameData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_callback_ = _callback_;
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sound_pulse_audio_manager_set_sink_port_by_name_async_ready_wrapper, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	if (_callback_ == NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_data_->_task_complete_ = TRUE;
#line 1960 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_sink_port_by_name_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = g_strdup (sink_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->sink_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->sink_name = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp2_ = g_strdup (port_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->port_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->port_name = _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_sink_port_by_name_co (_data_);
#line 1982 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_sink_port_by_name_finish (SoundPulseAudioManager* self,
                                                        GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1992 "PulseAudioManager.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 162 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 162 "../src/PulseAudioManager.vala"
	return _data3_;
#line 2002 "PulseAudioManager.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 162 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2012 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 162 "../src/PulseAudioManager.vala"
		self = _data3_->self;
#line 162 "../src/PulseAudioManager.vala"
		_g_free0 (_data3_->sink_name);
#line 162 "../src/PulseAudioManager.vala"
		_g_free0 (_data3_->port_name);
#line 162 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 162 "../src/PulseAudioManager.vala"
		g_slice_free (Block3Data, _data3_);
#line 2024 "PulseAudioManager.c"
	}
}

static void
__lambda11_ (Block3Data* _data3_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 163 "../src/PulseAudioManager.vala"
	self = _data3_->self;
#line 163 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 164 "../src/PulseAudioManager.vala"
	if (success == 1) {
#line 165 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_sink_port_by_name_co (_data3_->_async_data_);
#line 2042 "PulseAudioManager.c"
	} else {
#line 167 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:167: setting sink %s port to %s failed", _data3_->sink_name, _data3_->port_name);
#line 2046 "PulseAudioManager.c"
	}
}

static void
___lambda11__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 163 "../src/PulseAudioManager.vala"
	__lambda11_ (self, c, success);
#line 2057 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_sink_port_by_name_co (SoundPulseAudioManagerSetSinkPortByNameData* _data_)
{
#line 162 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 162 "../src/PulseAudioManager.vala"
		case 0:
#line 2067 "PulseAudioManager.c"
		goto _state_0;
#line 162 "../src/PulseAudioManager.vala"
		case 1:
#line 2071 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 162 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 2076 "PulseAudioManager.c"
	}
	_state_0:
#line 162 "../src/PulseAudioManager.vala"
	_data_->_data3_ = g_slice_new0 (Block3Data);
#line 162 "../src/PulseAudioManager.vala"
	_data_->_data3_->_ref_count_ = 1;
#line 162 "../src/PulseAudioManager.vala"
	_data_->_data3_->self = g_object_ref (_data_->self);
#line 162 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data3_->sink_name);
#line 162 "../src/PulseAudioManager.vala"
	_data_->_data3_->sink_name = _data_->sink_name;
#line 162 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data3_->port_name);
#line 162 "../src/PulseAudioManager.vala"
	_data_->_data3_->port_name = _data_->port_name;
#line 162 "../src/PulseAudioManager.vala"
	_data_->_data3_->_async_data_ = _data_;
#line 163 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->_context;
#line 163 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_sink_port_by_name (_data_->_tmp0_, _data_->_data3_->sink_name, _data_->_data3_->port_name, ___lambda11__pa_context_success_cb_t, _data_->_data3_);
#line 163 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 163 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 171 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 171 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2107 "PulseAudioManager.c"
	_state_1:
	;
#line 162 "../src/PulseAudioManager.vala"
	block3_data_unref (_data_->_data3_);
#line 162 "../src/PulseAudioManager.vala"
	_data_->_data3_ = NULL;
#line 162 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 162 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 162 "../src/PulseAudioManager.vala"
		while (!_data_->_task_complete_) {
#line 162 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2122 "PulseAudioManager.c"
		}
	}
#line 162 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 162 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2129 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_source_port_by_name_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetSourcePortByNameData, _data_);
#line 2141 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_source_port_by_name_async_ready_wrapper (GObject *source_object,
                                                                       GAsyncResult *res,
                                                                       void *user_data)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _task_data_;
#line 29 "../src/PulseAudioManager.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "../src/PulseAudioManager.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2156 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2160 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_source_port_by_name (SoundPulseAudioManager* self,
                                                   const gchar* source_name,
                                                   const gchar* port_name,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetSourcePortByNameData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_callback_ = _callback_;
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sound_pulse_audio_manager_set_source_port_by_name_async_ready_wrapper, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	if (_callback_ == NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_data_->_task_complete_ = TRUE;
#line 2184 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_source_port_by_name_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = g_strdup (source_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->source_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->source_name = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp2_ = g_strdup (port_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->port_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->port_name = _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_source_port_by_name_co (_data_);
#line 2206 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_source_port_by_name_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2216 "PulseAudioManager.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 174 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 174 "../src/PulseAudioManager.vala"
	return _data4_;
#line 2226 "PulseAudioManager.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 174 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 2236 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 174 "../src/PulseAudioManager.vala"
		self = _data4_->self;
#line 174 "../src/PulseAudioManager.vala"
		_g_free0 (_data4_->source_name);
#line 174 "../src/PulseAudioManager.vala"
		_g_free0 (_data4_->port_name);
#line 174 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 174 "../src/PulseAudioManager.vala"
		g_slice_free (Block4Data, _data4_);
#line 2248 "PulseAudioManager.c"
	}
}

static void
__lambda12_ (Block4Data* _data4_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 175 "../src/PulseAudioManager.vala"
	self = _data4_->self;
#line 175 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 176 "../src/PulseAudioManager.vala"
	if (success == 1) {
#line 177 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_source_port_by_name_co (_data4_->_async_data_);
#line 2266 "PulseAudioManager.c"
	} else {
#line 179 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:179: setting source %s port to %s failed", _data4_->source_name, _data4_->port_name);
#line 2270 "PulseAudioManager.c"
	}
}

static void
___lambda12__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 175 "../src/PulseAudioManager.vala"
	__lambda12_ (self, c, success);
#line 2281 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_source_port_by_name_co (SoundPulseAudioManagerSetSourcePortByNameData* _data_)
{
#line 174 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 174 "../src/PulseAudioManager.vala"
		case 0:
#line 2291 "PulseAudioManager.c"
		goto _state_0;
#line 174 "../src/PulseAudioManager.vala"
		case 1:
#line 2295 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 174 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 2300 "PulseAudioManager.c"
	}
	_state_0:
#line 174 "../src/PulseAudioManager.vala"
	_data_->_data4_ = g_slice_new0 (Block4Data);
#line 174 "../src/PulseAudioManager.vala"
	_data_->_data4_->_ref_count_ = 1;
#line 174 "../src/PulseAudioManager.vala"
	_data_->_data4_->self = g_object_ref (_data_->self);
#line 174 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data4_->source_name);
#line 174 "../src/PulseAudioManager.vala"
	_data_->_data4_->source_name = _data_->source_name;
#line 174 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data4_->port_name);
#line 174 "../src/PulseAudioManager.vala"
	_data_->_data4_->port_name = _data_->port_name;
#line 174 "../src/PulseAudioManager.vala"
	_data_->_data4_->_async_data_ = _data_;
#line 175 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->_context;
#line 175 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_source_port_by_name (_data_->_tmp0_, _data_->_data4_->source_name, _data_->_data4_->port_name, ___lambda12__pa_context_success_cb_t, _data_->_data4_);
#line 175 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 175 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 183 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 183 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2331 "PulseAudioManager.c"
	_state_1:
	;
#line 174 "../src/PulseAudioManager.vala"
	block4_data_unref (_data_->_data4_);
#line 174 "../src/PulseAudioManager.vala"
	_data_->_data4_ = NULL;
#line 174 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 174 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 174 "../src/PulseAudioManager.vala"
		while (!_data_->_task_complete_) {
#line 174 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2346 "PulseAudioManager.c"
		}
	}
#line 174 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 174 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2353 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_sink_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetDefaultSinkData, _data_);
#line 2365 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_sink_async_ready_wrapper (GObject *source_object,
                                                                GAsyncResult *res,
                                                                void *user_data)
{
	SoundPulseAudioManagerSetDefaultSinkData* _task_data_;
#line 29 "../src/PulseAudioManager.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "../src/PulseAudioManager.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2380 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2384 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_sink (SoundPulseAudioManager* self,
                                            const gchar* sink_name,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultSinkData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_callback_ = _callback_;
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sound_pulse_audio_manager_set_default_sink_async_ready_wrapper, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	if (_callback_ == NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_data_->_task_complete_ = TRUE;
#line 2406 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_sink_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = g_strdup (sink_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->sink_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->sink_name = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_sink_co (_data_);
#line 2422 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_sink_finish (SoundPulseAudioManager* self,
                                                   GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2432 "PulseAudioManager.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 186 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 186 "../src/PulseAudioManager.vala"
	return _data5_;
#line 2442 "PulseAudioManager.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 186 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 2452 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 186 "../src/PulseAudioManager.vala"
		self = _data5_->self;
#line 186 "../src/PulseAudioManager.vala"
		_g_free0 (_data5_->sink_name);
#line 186 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 186 "../src/PulseAudioManager.vala"
		g_slice_free (Block5Data, _data5_);
#line 2462 "PulseAudioManager.c"
	}
}

static void
__lambda13_ (Block5Data* _data5_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 187 "../src/PulseAudioManager.vala"
	self = _data5_->self;
#line 187 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 188 "../src/PulseAudioManager.vala"
	if (success == 1) {
#line 189 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_sink_co (_data5_->_async_data_);
#line 2480 "PulseAudioManager.c"
	} else {
#line 191 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:191: setting default sink to %s failed", _data5_->sink_name);
#line 2484 "PulseAudioManager.c"
	}
}

static void
___lambda13__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 187 "../src/PulseAudioManager.vala"
	__lambda13_ (self, c, success);
#line 2495 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_default_sink_co (SoundPulseAudioManagerSetDefaultSinkData* _data_)
{
#line 186 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 186 "../src/PulseAudioManager.vala"
		case 0:
#line 2505 "PulseAudioManager.c"
		goto _state_0;
#line 186 "../src/PulseAudioManager.vala"
		case 1:
#line 2509 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 186 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 2514 "PulseAudioManager.c"
	}
	_state_0:
#line 186 "../src/PulseAudioManager.vala"
	_data_->_data5_ = g_slice_new0 (Block5Data);
#line 186 "../src/PulseAudioManager.vala"
	_data_->_data5_->_ref_count_ = 1;
#line 186 "../src/PulseAudioManager.vala"
	_data_->_data5_->self = g_object_ref (_data_->self);
#line 186 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data5_->sink_name);
#line 186 "../src/PulseAudioManager.vala"
	_data_->_data5_->sink_name = _data_->sink_name;
#line 186 "../src/PulseAudioManager.vala"
	_data_->_data5_->_async_data_ = _data_;
#line 187 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->_context;
#line 187 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_default_sink (_data_->_tmp0_, _data_->_data5_->sink_name, ___lambda13__pa_context_success_cb_t, _data_->_data5_);
#line 187 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 187 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 195 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 195 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2541 "PulseAudioManager.c"
	_state_1:
	;
#line 186 "../src/PulseAudioManager.vala"
	block5_data_unref (_data_->_data5_);
#line 186 "../src/PulseAudioManager.vala"
	_data_->_data5_ = NULL;
#line 186 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 186 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 186 "../src/PulseAudioManager.vala"
		while (!_data_->_task_complete_) {
#line 186 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2556 "PulseAudioManager.c"
		}
	}
#line 186 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 186 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2563 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_source_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetDefaultSourceData, _data_);
#line 2575 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_source_async_ready_wrapper (GObject *source_object,
                                                                  GAsyncResult *res,
                                                                  void *user_data)
{
	SoundPulseAudioManagerSetDefaultSourceData* _task_data_;
#line 29 "../src/PulseAudioManager.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "../src/PulseAudioManager.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 2590 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	_task_data_->_task_complete_ = TRUE;
#line 2594 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_source (SoundPulseAudioManager* self,
                                              const gchar* source_name,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultSourceData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_callback_ = _callback_;
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sound_pulse_audio_manager_set_default_source_async_ready_wrapper, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	if (_callback_ == NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_data_->_task_complete_ = TRUE;
#line 2616 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_source_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = g_strdup (source_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->source_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->source_name = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_source_co (_data_);
#line 2632 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_source_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2642 "PulseAudioManager.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 198 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 198 "../src/PulseAudioManager.vala"
	return _data6_;
#line 2652 "PulseAudioManager.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 198 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2662 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 198 "../src/PulseAudioManager.vala"
		self = _data6_->self;
#line 198 "../src/PulseAudioManager.vala"
		_g_free0 (_data6_->source_name);
#line 198 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 198 "../src/PulseAudioManager.vala"
		g_slice_free (Block6Data, _data6_);
#line 2672 "PulseAudioManager.c"
	}
}

static void
__lambda14_ (Block6Data* _data6_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 199 "../src/PulseAudioManager.vala"
	self = _data6_->self;
#line 199 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 200 "../src/PulseAudioManager.vala"
	if (success == 1) {
#line 201 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_source_co (_data6_->_async_data_);
#line 2690 "PulseAudioManager.c"
	} else {
#line 203 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:203: setting default source to %s failed", _data6_->source_name);
#line 2694 "PulseAudioManager.c"
	}
}

static void
___lambda14__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 199 "../src/PulseAudioManager.vala"
	__lambda14_ (self, c, success);
#line 2705 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_default_source_co (SoundPulseAudioManagerSetDefaultSourceData* _data_)
{
#line 198 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 198 "../src/PulseAudioManager.vala"
		case 0:
#line 2715 "PulseAudioManager.c"
		goto _state_0;
#line 198 "../src/PulseAudioManager.vala"
		case 1:
#line 2719 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 198 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 2724 "PulseAudioManager.c"
	}
	_state_0:
#line 198 "../src/PulseAudioManager.vala"
	_data_->_data6_ = g_slice_new0 (Block6Data);
#line 198 "../src/PulseAudioManager.vala"
	_data_->_data6_->_ref_count_ = 1;
#line 198 "../src/PulseAudioManager.vala"
	_data_->_data6_->self = g_object_ref (_data_->self);
#line 198 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data6_->source_name);
#line 198 "../src/PulseAudioManager.vala"
	_data_->_data6_->source_name = _data_->source_name;
#line 198 "../src/PulseAudioManager.vala"
	_data_->_data6_->_async_data_ = _data_;
#line 199 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->_context;
#line 199 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_default_source (_data_->_tmp0_, _data_->_data6_->source_name, ___lambda14__pa_context_success_cb_t, _data_->_data6_);
#line 199 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 199 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 207 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 207 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2751 "PulseAudioManager.c"
	_state_1:
	;
#line 198 "../src/PulseAudioManager.vala"
	block6_data_unref (_data_->_data6_);
#line 198 "../src/PulseAudioManager.vala"
	_data_->_data6_ = NULL;
#line 198 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 198 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 198 "../src/PulseAudioManager.vala"
		while (!_data_->_task_complete_) {
#line 198 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2766 "PulseAudioManager.c"
		}
	}
#line 198 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 198 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2773 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_change_device_mute (SoundPulseAudioManager* self,
                                              SoundDevice* device,
                                              gboolean mute)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 210 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 210 "../src/PulseAudioManager.vala"
	g_return_if_fail (device != NULL);
#line 211 "../src/PulseAudioManager.vala"
	_tmp0_ = sound_device_get_input (device);
#line 211 "../src/PulseAudioManager.vala"
	_tmp1_ = _tmp0_;
#line 211 "../src/PulseAudioManager.vala"
	if (_tmp1_) {
#line 2793 "PulseAudioManager.c"
		pa_context* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		pa_operation* _tmp5_;
		pa_operation* _tmp6_;
#line 212 "../src/PulseAudioManager.vala"
		_tmp2_ = self->priv->_context;
#line 212 "../src/PulseAudioManager.vala"
		_tmp3_ = sound_device_get_source_name (device);
#line 212 "../src/PulseAudioManager.vala"
		_tmp4_ = _tmp3_;
#line 212 "../src/PulseAudioManager.vala"
		_tmp5_ = pa_context_set_source_mute_by_name (_tmp2_, _tmp4_, mute, NULL, NULL);
#line 212 "../src/PulseAudioManager.vala"
		_tmp6_ = _tmp5_;
#line 212 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp6_);
#line 2811 "PulseAudioManager.c"
	} else {
		pa_context* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		pa_operation* _tmp10_;
		pa_operation* _tmp11_;
#line 214 "../src/PulseAudioManager.vala"
		_tmp7_ = self->priv->_context;
#line 214 "../src/PulseAudioManager.vala"
		_tmp8_ = sound_device_get_sink_name (device);
#line 214 "../src/PulseAudioManager.vala"
		_tmp9_ = _tmp8_;
#line 214 "../src/PulseAudioManager.vala"
		_tmp10_ = pa_context_set_sink_mute_by_name (_tmp7_, _tmp9_, mute, NULL, NULL);
#line 214 "../src/PulseAudioManager.vala"
		_tmp11_ = _tmp10_;
#line 214 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp11_);
#line 2830 "PulseAudioManager.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 218 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 218 "../src/PulseAudioManager.vala"
	return _data7_;
#line 2841 "PulseAudioManager.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 218 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 2851 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 218 "../src/PulseAudioManager.vala"
		self = _data7_->self;
#line 218 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data7_->device);
#line 218 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 218 "../src/PulseAudioManager.vala"
		g_slice_free (Block7Data, _data7_);
#line 2861 "PulseAudioManager.c"
	}
}

static gboolean
__lambda15_ (Block7Data* _data7_,
             pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
	GeeLinkedList* _tmp0_;
#line 219 "../src/PulseAudioManager.vala"
	self = _data7_->self;
#line 219 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (operation != NULL, FALSE);
#line 220 "../src/PulseAudioManager.vala"
	if (pa_operation_get_state (operation) == PA_OPERATION_RUNNING) {
#line 221 "../src/PulseAudioManager.vala"
		pa_operation_cancel (operation);
#line 2880 "PulseAudioManager.c"
	}
#line 224 "../src/PulseAudioManager.vala"
	_tmp0_ = _data7_->device->volume_operations;
#line 224 "../src/PulseAudioManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, operation);
#line 225 "../src/PulseAudioManager.vala"
	result = G_SOURCE_CONTINUE;
#line 225 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 225 "../src/PulseAudioManager.vala"
	return result;
#line 2892 "PulseAudioManager.c"
}

static gboolean
___lambda15__gee_forall_func (gpointer g,
                              gpointer self)
{
	gboolean result;
	result = __lambda15_ (self, (pa_operation*) g);
#line 219 "../src/PulseAudioManager.vala"
	return result;
#line 2903 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_change_device_volume (SoundPulseAudioManager* self,
                                                SoundDevice* device,
                                                gdouble volume)
{
	Block7Data* _data7_;
	SoundDevice* _tmp0_;
	GeeLinkedList* _tmp1_;
	pa_cvolume cvol = {0};
	pa_cvolume _tmp2_ = {0};
	pa_cvolume _tmp3_;
	pa_operation* operation = NULL;
	gboolean _tmp4_;
	gboolean _tmp5_;
	pa_operation* _tmp16_;
#line 218 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/PulseAudioManager.vala"
	g_return_if_fail (device != NULL);
#line 218 "../src/PulseAudioManager.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 218 "../src/PulseAudioManager.vala"
	_data7_->_ref_count_ = 1;
#line 218 "../src/PulseAudioManager.vala"
	_data7_->self = g_object_ref (self);
#line 218 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (device);
#line 218 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data7_->device);
#line 218 "../src/PulseAudioManager.vala"
	_data7_->device = _tmp0_;
#line 219 "../src/PulseAudioManager.vala"
	_tmp1_ = _data7_->device->volume_operations;
#line 219 "../src/PulseAudioManager.vala"
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp1_, ___lambda15__gee_forall_func, _data7_);
#line 228 "../src/PulseAudioManager.vala"
	sound_device_get_cvolume (_data7_->device, &_tmp2_);
#line 228 "../src/PulseAudioManager.vala"
	_tmp3_ = _tmp2_;
#line 228 "../src/PulseAudioManager.vala"
	cvol = _tmp3_;
#line 229 "../src/PulseAudioManager.vala"
	pa_cvolume_scale (&cvol, sound_pulse_audio_manager_double_to_volume (volume));
#line 230 "../src/PulseAudioManager.vala"
	operation = NULL;
#line 231 "../src/PulseAudioManager.vala"
	_tmp4_ = sound_device_get_input (_data7_->device);
#line 231 "../src/PulseAudioManager.vala"
	_tmp5_ = _tmp4_;
#line 231 "../src/PulseAudioManager.vala"
	if (_tmp5_) {
#line 2957 "PulseAudioManager.c"
		pa_context* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		pa_cvolume _tmp9_;
		pa_operation* _tmp10_;
#line 232 "../src/PulseAudioManager.vala"
		_tmp6_ = self->priv->_context;
#line 232 "../src/PulseAudioManager.vala"
		_tmp7_ = sound_device_get_source_name (_data7_->device);
#line 232 "../src/PulseAudioManager.vala"
		_tmp8_ = _tmp7_;
#line 232 "../src/PulseAudioManager.vala"
		_tmp9_ = cvol;
#line 232 "../src/PulseAudioManager.vala"
		_tmp10_ = pa_context_set_source_volume_by_name (_tmp6_, _tmp8_, &_tmp9_, NULL, NULL);
#line 232 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 232 "../src/PulseAudioManager.vala"
		operation = _tmp10_;
#line 2977 "PulseAudioManager.c"
	} else {
		pa_context* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		pa_cvolume _tmp14_;
		pa_operation* _tmp15_;
#line 234 "../src/PulseAudioManager.vala"
		_tmp11_ = self->priv->_context;
#line 234 "../src/PulseAudioManager.vala"
		_tmp12_ = sound_device_get_sink_name (_data7_->device);
#line 234 "../src/PulseAudioManager.vala"
		_tmp13_ = _tmp12_;
#line 234 "../src/PulseAudioManager.vala"
		_tmp14_ = cvol;
#line 234 "../src/PulseAudioManager.vala"
		_tmp15_ = pa_context_set_sink_volume_by_name (_tmp11_, _tmp13_, &_tmp14_, NULL, NULL);
#line 234 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 234 "../src/PulseAudioManager.vala"
		operation = _tmp15_;
#line 2998 "PulseAudioManager.c"
	}
#line 237 "../src/PulseAudioManager.vala"
	_tmp16_ = operation;
#line 237 "../src/PulseAudioManager.vala"
	if (_tmp16_ != NULL) {
#line 3004 "PulseAudioManager.c"
		GeeLinkedList* _tmp17_;
		pa_operation* _tmp18_;
#line 238 "../src/PulseAudioManager.vala"
		_tmp17_ = _data7_->device->volume_operations;
#line 238 "../src/PulseAudioManager.vala"
		_tmp18_ = operation;
#line 238 "../src/PulseAudioManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
#line 3013 "PulseAudioManager.c"
	}
#line 218 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 218 "../src/PulseAudioManager.vala"
	block7_data_unref (_data7_);
#line 218 "../src/PulseAudioManager.vala"
	_data7_ = NULL;
#line 3021 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_change_device_balance (SoundPulseAudioManager* self,
                                                 SoundDevice* device,
                                                 gfloat balance)
{
	pa_cvolume cvol = {0};
	pa_cvolume _tmp0_ = {0};
	pa_cvolume _tmp1_;
	pa_channel_map _tmp2_ = {0};
	pa_channel_map _tmp3_;
	pa_operation* operation = NULL;
	gboolean _tmp4_;
	gboolean _tmp5_;
	pa_operation* _tmp16_;
#line 242 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/PulseAudioManager.vala"
	g_return_if_fail (device != NULL);
#line 243 "../src/PulseAudioManager.vala"
	sound_device_get_cvolume (device, &_tmp0_);
#line 243 "../src/PulseAudioManager.vala"
	_tmp1_ = _tmp0_;
#line 243 "../src/PulseAudioManager.vala"
	cvol = _tmp1_;
#line 244 "../src/PulseAudioManager.vala"
	sound_device_get_channel_map (device, &_tmp2_);
#line 244 "../src/PulseAudioManager.vala"
	_tmp3_ = _tmp2_;
#line 244 "../src/PulseAudioManager.vala"
	cvol = *pa_cvolume_set_balance (&cvol, &_tmp3_, balance);
#line 245 "../src/PulseAudioManager.vala"
	operation = NULL;
#line 246 "../src/PulseAudioManager.vala"
	_tmp4_ = sound_device_get_input (device);
#line 246 "../src/PulseAudioManager.vala"
	_tmp5_ = _tmp4_;
#line 246 "../src/PulseAudioManager.vala"
	if (_tmp5_) {
#line 3062 "PulseAudioManager.c"
		pa_context* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		pa_cvolume _tmp9_;
		pa_operation* _tmp10_;
#line 247 "../src/PulseAudioManager.vala"
		_tmp6_ = self->priv->_context;
#line 247 "../src/PulseAudioManager.vala"
		_tmp7_ = sound_device_get_source_name (device);
#line 247 "../src/PulseAudioManager.vala"
		_tmp8_ = _tmp7_;
#line 247 "../src/PulseAudioManager.vala"
		_tmp9_ = cvol;
#line 247 "../src/PulseAudioManager.vala"
		_tmp10_ = pa_context_set_source_volume_by_name (_tmp6_, _tmp8_, &_tmp9_, NULL, NULL);
#line 247 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 247 "../src/PulseAudioManager.vala"
		operation = _tmp10_;
#line 3082 "PulseAudioManager.c"
	} else {
		pa_context* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		pa_cvolume _tmp14_;
		pa_operation* _tmp15_;
#line 249 "../src/PulseAudioManager.vala"
		_tmp11_ = self->priv->_context;
#line 249 "../src/PulseAudioManager.vala"
		_tmp12_ = sound_device_get_sink_name (device);
#line 249 "../src/PulseAudioManager.vala"
		_tmp13_ = _tmp12_;
#line 249 "../src/PulseAudioManager.vala"
		_tmp14_ = cvol;
#line 249 "../src/PulseAudioManager.vala"
		_tmp15_ = pa_context_set_sink_volume_by_name (_tmp11_, _tmp13_, &_tmp14_, NULL, NULL);
#line 249 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 249 "../src/PulseAudioManager.vala"
		operation = _tmp15_;
#line 3103 "PulseAudioManager.c"
	}
#line 252 "../src/PulseAudioManager.vala"
	_tmp16_ = operation;
#line 252 "../src/PulseAudioManager.vala"
	if (_tmp16_ != NULL) {
#line 3109 "PulseAudioManager.c"
		GeeLinkedList* _tmp17_;
		pa_operation* _tmp18_;
#line 253 "../src/PulseAudioManager.vala"
		_tmp17_ = device->volume_operations;
#line 253 "../src/PulseAudioManager.vala"
		_tmp18_ = operation;
#line 253 "../src/PulseAudioManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp17_, _tmp18_);
#line 3118 "PulseAudioManager.c"
	}
#line 242 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 3122 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self)
{
	gboolean result = FALSE;
#line 261 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 262 "../src/PulseAudioManager.vala"
	self->priv->reconnect_timer_id = 0U;
#line 263 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
#line 264 "../src/PulseAudioManager.vala"
	result = FALSE;
#line 264 "../src/PulseAudioManager.vala"
	return result;
#line 3139 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerReconnectToPulseData, _data_);
#line 3151 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper (GObject *source_object,
                                                                  GAsyncResult *res,
                                                                  void *user_data)
{
	SoundPulseAudioManagerReconnectToPulseData* _task_data_;
#line 29 "../src/PulseAudioManager.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "../src/PulseAudioManager.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 3166 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	_task_data_->_task_complete_ = TRUE;
#line 3170 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	SoundPulseAudioManager* _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerReconnectToPulseData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_callback_ = _callback_;
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, sound_pulse_audio_manager_reconnect_to_pulse_async_ready_wrapper, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	if (_callback_ == NULL) {
#line 29 "../src/PulseAudioManager.vala"
		_data_->_task_complete_ = TRUE;
#line 3190 "PulseAudioManager.c"
	}
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_reconnect_to_pulse_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse_co (_data_);
#line 3200 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3210 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                          gpointer self)
{
#line 277 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_context_state_callback ((SoundPulseAudioManager*) self, c);
#line 3219 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_)
{
#line 267 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 267 "../src/PulseAudioManager.vala"
		case 0:
#line 3229 "PulseAudioManager.c"
		goto _state_0;
		default:
#line 267 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 3234 "PulseAudioManager.c"
	}
	_state_0:
#line 268 "../src/PulseAudioManager.vala"
	if (_data_->self->priv->is_ready) {
#line 269 "../src/PulseAudioManager.vala"
		_data_->_tmp0_ = _data_->self->priv->_context;
#line 269 "../src/PulseAudioManager.vala"
		pa_context_disconnect (_data_->_tmp0_);
#line 270 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_context (_data_->self, NULL);
#line 271 "../src/PulseAudioManager.vala"
		_data_->self->priv->is_ready = FALSE;
#line 3247 "PulseAudioManager.c"
	}
#line 274 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_proplist_new ();
#line 274 "../src/PulseAudioManager.vala"
	_data_->props = _data_->_tmp1_;
#line 275 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->props;
#line 275 "../src/PulseAudioManager.vala"
	pa_proplist_sets (_data_->_tmp2_, PA_PROP_APPLICATION_ID, "org.pantheon.switchboard.plug.sound");
#line 276 "../src/PulseAudioManager.vala"
	_data_->_tmp3_ = _data_->self->priv->loop;
#line 276 "../src/PulseAudioManager.vala"
	_data_->_tmp4_ = pa_glib_mainloop_get_api (_data_->_tmp3_);
#line 276 "../src/PulseAudioManager.vala"
	_data_->_tmp5_ = _data_->props;
#line 276 "../src/PulseAudioManager.vala"
	_data_->_tmp6_ = pa_context_new_with_proplist (_data_->_tmp4_, NULL, _data_->_tmp5_);
#line 276 "../src/PulseAudioManager.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 276 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_context (_data_->self, _data_->_tmp7_);
#line 276 "../src/PulseAudioManager.vala"
	_pa_context_unref0 (_data_->_tmp7_);
#line 277 "../src/PulseAudioManager.vala"
	_data_->_tmp8_ = _data_->self->priv->_context;
#line 277 "../src/PulseAudioManager.vala"
	pa_context_set_state_callback (_data_->_tmp8_, _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t, _data_->self);
#line 279 "../src/PulseAudioManager.vala"
	_data_->_tmp9_ = _data_->self->priv->_context;
#line 279 "../src/PulseAudioManager.vala"
	if (pa_context_connect (_data_->_tmp9_, NULL, PA_CONTEXT_NOFAIL, NULL) < 0) {
#line 280 "../src/PulseAudioManager.vala"
		_data_->_tmp10_ = _data_->self->priv->_context;
#line 280 "../src/PulseAudioManager.vala"
		_data_->_tmp11_ = pa_strerror (pa_context_errno (_data_->_tmp10_));
#line 280 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:280: pa_context_connect () failed: %s\n", _data_->_tmp11_);
#line 3285 "PulseAudioManager.c"
	}
#line 267 "../src/PulseAudioManager.vala"
	_pa_proplist_free0 (_data_->props);
#line 267 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 267 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 267 "../src/PulseAudioManager.vala"
		while (!_data_->_task_complete_) {
#line 267 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3297 "PulseAudioManager.c"
		}
	}
#line 267 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 267 "../src/PulseAudioManager.vala"
	return FALSE;
#line 3304 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                         pa_subscription_event_type_t t,
                                                                         guint32 idx,
                                                                         gpointer self)
{
#line 287 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_subscribe_callback ((SoundPulseAudioManager*) self, c, t, idx);
#line 3315 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                     pa_server_info* i,
                                                                     gpointer self)
{
#line 294 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_server_info_callback ((SoundPulseAudioManager*) self, c, i);
#line 3325 "PulseAudioManager.c"
}

static gboolean
_sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = sound_pulse_audio_manager_reconnect_timeout ((SoundPulseAudioManager*) self);
#line 301 "../src/PulseAudioManager.vala"
	return result;
#line 3335 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                  pa_context* c)
{
#line 284 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 284 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 285 "../src/PulseAudioManager.vala"
	switch (pa_context_get_state (c)) {
#line 285 "../src/PulseAudioManager.vala"
		case PA_CONTEXT_READY:
#line 3350 "PulseAudioManager.c"
		{
			pa_operation* _tmp0_;
			pa_operation* _tmp1_;
			pa_context* _tmp2_;
			pa_operation* _tmp3_;
			pa_operation* _tmp4_;
#line 287 "../src/PulseAudioManager.vala"
			pa_context_set_subscribe_callback (c, _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t, self);
#line 288 "../src/PulseAudioManager.vala"
			_tmp0_ = pa_context_subscribe (c, ((((PA_SUBSCRIPTION_MASK_SERVER | PA_SUBSCRIPTION_MASK_SINK) | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SINK_INPUT) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT) | PA_SUBSCRIPTION_MASK_CARD, NULL, NULL);
#line 288 "../src/PulseAudioManager.vala"
			_tmp1_ = _tmp0_;
#line 288 "../src/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp1_);
#line 294 "../src/PulseAudioManager.vala"
			_tmp2_ = self->priv->_context;
#line 294 "../src/PulseAudioManager.vala"
			_tmp3_ = pa_context_get_server_info (_tmp2_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
#line 294 "../src/PulseAudioManager.vala"
			_tmp4_ = _tmp3_;
#line 294 "../src/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp4_);
#line 295 "../src/PulseAudioManager.vala"
			self->priv->is_ready = TRUE;
#line 296 "../src/PulseAudioManager.vala"
			break;
#line 3377 "PulseAudioManager.c"
		}
#line 285 "../src/PulseAudioManager.vala"
		case PA_CONTEXT_FAILED:
#line 285 "../src/PulseAudioManager.vala"
		case PA_CONTEXT_TERMINATED:
#line 3383 "PulseAudioManager.c"
		{
#line 300 "../src/PulseAudioManager.vala"
			if (self->priv->reconnect_timer_id == 0U) {
#line 301 "../src/PulseAudioManager.vala"
				self->priv->reconnect_timer_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _sound_pulse_audio_manager_reconnect_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 3389 "PulseAudioManager.c"
			}
#line 304 "../src/PulseAudioManager.vala"
			break;
#line 3393 "PulseAudioManager.c"
		}
		default:
		{
#line 307 "../src/PulseAudioManager.vala"
			self->priv->is_ready = FALSE;
#line 308 "../src/PulseAudioManager.vala"
			break;
#line 3401 "PulseAudioManager.c"
		}
	}
}

static void
_sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                 pa_sink_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
#line 324 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_sink_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
#line 3414 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t (pa_context* c,
                                                                 pa_card_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
#line 364 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_card_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
#line 3425 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                     pa_source_info* i,
                                                                     gint eol,
                                                                     gpointer self)
{
#line 384 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_source_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
#line 3436 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_subscription_event_type_t t,
                                              guint32 index)
{
	pa_subscription_event_type_t source_type = 0;
	pa_subscription_event_type_t _tmp0_;
#line 316 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 316 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 317 "../src/PulseAudioManager.vala"
	source_type = t & PA_SUBSCRIPTION_EVENT_FACILITY_MASK;
#line 318 "../src/PulseAudioManager.vala"
	_tmp0_ = source_type;
#line 318 "../src/PulseAudioManager.vala"
	switch (_tmp0_) {
#line 318 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SINK:
#line 318 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SINK_INPUT:
#line 3461 "PulseAudioManager.c"
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp1_;
#line 321 "../src/PulseAudioManager.vala"
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
#line 322 "../src/PulseAudioManager.vala"
			_tmp1_ = event_type;
#line 322 "../src/PulseAudioManager.vala"
			switch (_tmp1_) {
#line 322 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 3473 "PulseAudioManager.c"
				{
					pa_operation* _tmp2_;
					pa_operation* _tmp3_;
#line 324 "../src/PulseAudioManager.vala"
					_tmp2_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 324 "../src/PulseAudioManager.vala"
					_tmp3_ = _tmp2_;
#line 324 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp3_);
#line 325 "../src/PulseAudioManager.vala"
					break;
#line 3485 "PulseAudioManager.c"
				}
#line 322 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 3489 "PulseAudioManager.c"
				{
					pa_operation* _tmp4_;
					pa_operation* _tmp5_;
#line 328 "../src/PulseAudioManager.vala"
					_tmp4_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 328 "../src/PulseAudioManager.vala"
					_tmp5_ = _tmp4_;
#line 328 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp5_);
#line 329 "../src/PulseAudioManager.vala"
					break;
#line 3501 "PulseAudioManager.c"
				}
#line 322 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 3505 "PulseAudioManager.c"
				{
#line 332 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:332: subscribe_callback:SINK:REMOVE");
#line 3509 "PulseAudioManager.c"
					{
						GeeIterator* _device_it = NULL;
						GeeHashMap* _tmp6_;
						GeeCollection* _tmp7_;
						GeeCollection* _tmp8_;
						GeeCollection* _tmp9_;
						GeeIterator* _tmp10_;
						GeeIterator* _tmp11_;
#line 333 "../src/PulseAudioManager.vala"
						_tmp6_ = self->priv->output_devices;
#line 333 "../src/PulseAudioManager.vala"
						_tmp7_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp6_);
#line 333 "../src/PulseAudioManager.vala"
						_tmp8_ = _tmp7_;
#line 333 "../src/PulseAudioManager.vala"
						_tmp9_ = _tmp8_;
#line 333 "../src/PulseAudioManager.vala"
						_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 333 "../src/PulseAudioManager.vala"
						_tmp11_ = _tmp10_;
#line 333 "../src/PulseAudioManager.vala"
						_g_object_unref0 (_tmp9_);
#line 333 "../src/PulseAudioManager.vala"
						_device_it = _tmp11_;
#line 333 "../src/PulseAudioManager.vala"
						while (TRUE) {
#line 3536 "PulseAudioManager.c"
							GeeIterator* _tmp12_;
							SoundDevice* device = NULL;
							GeeIterator* _tmp13_;
							gpointer _tmp14_;
							SoundDevice* _tmp15_;
							gint _tmp16_;
							gint _tmp17_;
							SoundDevice* _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
#line 333 "../src/PulseAudioManager.vala"
							_tmp12_ = _device_it;
#line 333 "../src/PulseAudioManager.vala"
							if (!gee_iterator_next (_tmp12_)) {
#line 333 "../src/PulseAudioManager.vala"
								break;
#line 3553 "PulseAudioManager.c"
							}
#line 333 "../src/PulseAudioManager.vala"
							_tmp13_ = _device_it;
#line 333 "../src/PulseAudioManager.vala"
							_tmp14_ = gee_iterator_get (_tmp13_);
#line 333 "../src/PulseAudioManager.vala"
							device = (SoundDevice*) _tmp14_;
#line 334 "../src/PulseAudioManager.vala"
							_tmp15_ = device;
#line 334 "../src/PulseAudioManager.vala"
							_tmp16_ = sound_device_get_sink_index (_tmp15_);
#line 334 "../src/PulseAudioManager.vala"
							_tmp17_ = _tmp16_;
#line 334 "../src/PulseAudioManager.vala"
							if (((guint32) _tmp17_) == index) {
#line 3569 "PulseAudioManager.c"
								SoundDevice* _tmp18_;
								const gchar* _tmp19_;
								const gchar* _tmp20_;
								SoundDevice* _tmp21_;
								SoundDevice* _tmp22_;
								SoundDevice* _tmp23_;
								SoundDevice* _tmp24_;
								const gchar* _tmp25_;
								const gchar* _tmp26_;
#line 335 "../src/PulseAudioManager.vala"
								_tmp18_ = device;
#line 335 "../src/PulseAudioManager.vala"
								_tmp19_ = sound_device_get_id (_tmp18_);
#line 335 "../src/PulseAudioManager.vala"
								_tmp20_ = _tmp19_;
#line 335 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:335: \tupdating device: %s", _tmp20_);
#line 336 "../src/PulseAudioManager.vala"
								_tmp21_ = device;
#line 336 "../src/PulseAudioManager.vala"
								sound_device_set_sink_name (_tmp21_, NULL);
#line 337 "../src/PulseAudioManager.vala"
								_tmp22_ = device;
#line 337 "../src/PulseAudioManager.vala"
								sound_device_set_sink_index (_tmp22_, -1);
#line 338 "../src/PulseAudioManager.vala"
								_tmp23_ = device;
#line 338 "../src/PulseAudioManager.vala"
								sound_device_set_is_default (_tmp23_, FALSE);
#line 339 "../src/PulseAudioManager.vala"
								_tmp24_ = device;
#line 339 "../src/PulseAudioManager.vala"
								_tmp25_ = sound_device_get_sink_name (_tmp24_);
#line 339 "../src/PulseAudioManager.vala"
								_tmp26_ = _tmp25_;
#line 339 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:339: \t\tdevice.sink_name: %s", _tmp26_);
#line 3607 "PulseAudioManager.c"
							}
#line 342 "../src/PulseAudioManager.vala"
							_tmp27_ = device;
#line 342 "../src/PulseAudioManager.vala"
							_tmp28_ = sound_device_get_card_sink_index (_tmp27_);
#line 342 "../src/PulseAudioManager.vala"
							_tmp29_ = _tmp28_;
#line 342 "../src/PulseAudioManager.vala"
							if (((guint32) _tmp29_) == index) {
#line 3617 "PulseAudioManager.c"
								SoundDevice* _tmp30_;
								const gchar* _tmp31_;
								const gchar* _tmp32_;
								SoundDevice* _tmp33_;
								SoundDevice* _tmp34_;
								SoundDevice* _tmp35_;
								SoundDevice* _tmp36_;
								const gchar* _tmp37_;
								const gchar* _tmp38_;
#line 343 "../src/PulseAudioManager.vala"
								_tmp30_ = device;
#line 343 "../src/PulseAudioManager.vala"
								_tmp31_ = sound_device_get_id (_tmp30_);
#line 343 "../src/PulseAudioManager.vala"
								_tmp32_ = _tmp31_;
#line 343 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:343: \tupdating device: %s", _tmp32_);
#line 344 "../src/PulseAudioManager.vala"
								_tmp33_ = device;
#line 344 "../src/PulseAudioManager.vala"
								sound_device_set_card_sink_name (_tmp33_, NULL);
#line 345 "../src/PulseAudioManager.vala"
								_tmp34_ = device;
#line 345 "../src/PulseAudioManager.vala"
								sound_device_set_card_sink_index (_tmp34_, -1);
#line 346 "../src/PulseAudioManager.vala"
								_tmp35_ = device;
#line 346 "../src/PulseAudioManager.vala"
								sound_device_set_card_sink_port_name (_tmp35_, NULL);
#line 347 "../src/PulseAudioManager.vala"
								_tmp36_ = device;
#line 347 "../src/PulseAudioManager.vala"
								_tmp37_ = sound_device_get_card_sink_name (_tmp36_);
#line 347 "../src/PulseAudioManager.vala"
								_tmp38_ = _tmp37_;
#line 347 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:347: \t\tdevice.card_sink_name: %s", _tmp38_);
#line 3655 "PulseAudioManager.c"
							}
#line 333 "../src/PulseAudioManager.vala"
							_g_object_unref0 (device);
#line 3659 "PulseAudioManager.c"
						}
#line 333 "../src/PulseAudioManager.vala"
						_g_object_unref0 (_device_it);
#line 3663 "PulseAudioManager.c"
					}
#line 351 "../src/PulseAudioManager.vala"
					break;
#line 3667 "PulseAudioManager.c"
				}
				default:
#line 322 "../src/PulseAudioManager.vala"
				break;
#line 3672 "PulseAudioManager.c"
			}
#line 354 "../src/PulseAudioManager.vala"
			break;
#line 3676 "PulseAudioManager.c"
		}
#line 318 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SERVER:
#line 3680 "PulseAudioManager.c"
		{
			pa_context* _tmp39_;
			pa_operation* _tmp40_;
			pa_operation* _tmp41_;
#line 357 "../src/PulseAudioManager.vala"
			_tmp39_ = self->priv->_context;
#line 357 "../src/PulseAudioManager.vala"
			_tmp40_ = pa_context_get_server_info (_tmp39_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
#line 357 "../src/PulseAudioManager.vala"
			_tmp41_ = _tmp40_;
#line 357 "../src/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp41_);
#line 358 "../src/PulseAudioManager.vala"
			break;
#line 3695 "PulseAudioManager.c"
		}
#line 318 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_CARD:
#line 3699 "PulseAudioManager.c"
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp42_;
#line 361 "../src/PulseAudioManager.vala"
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
#line 362 "../src/PulseAudioManager.vala"
			_tmp42_ = event_type;
#line 362 "../src/PulseAudioManager.vala"
			switch (_tmp42_) {
#line 362 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 3711 "PulseAudioManager.c"
				{
					pa_operation* _tmp43_;
					pa_operation* _tmp44_;
#line 364 "../src/PulseAudioManager.vala"
					_tmp43_ = pa_context_get_card_info_by_index (c, index, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
#line 364 "../src/PulseAudioManager.vala"
					_tmp44_ = _tmp43_;
#line 364 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp44_);
#line 365 "../src/PulseAudioManager.vala"
					break;
#line 3723 "PulseAudioManager.c"
				}
#line 362 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 3727 "PulseAudioManager.c"
				{
					pa_operation* _tmp45_;
					pa_operation* _tmp46_;
#line 368 "../src/PulseAudioManager.vala"
					_tmp45_ = pa_context_get_card_info_by_index (c, index, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
#line 368 "../src/PulseAudioManager.vala"
					_tmp46_ = _tmp45_;
#line 368 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp46_);
#line 369 "../src/PulseAudioManager.vala"
					break;
#line 3739 "PulseAudioManager.c"
				}
#line 362 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 3743 "PulseAudioManager.c"
				{
					GeeHashMap* _tmp47_;
					GeeHashMap* _tmp48_;
#line 372 "../src/PulseAudioManager.vala"
					_tmp47_ = self->priv->output_devices;
#line 372 "../src/PulseAudioManager.vala"
					sound_pulse_audio_manager_remove_devices_by_card (self, _tmp47_, index);
#line 373 "../src/PulseAudioManager.vala"
					_tmp48_ = self->priv->input_devices;
#line 373 "../src/PulseAudioManager.vala"
					sound_pulse_audio_manager_remove_devices_by_card (self, _tmp48_, index);
#line 374 "../src/PulseAudioManager.vala"
					break;
#line 3757 "PulseAudioManager.c"
				}
				default:
#line 362 "../src/PulseAudioManager.vala"
				break;
#line 3762 "PulseAudioManager.c"
			}
#line 377 "../src/PulseAudioManager.vala"
			break;
#line 3766 "PulseAudioManager.c"
		}
#line 318 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SOURCE:
#line 318 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SOURCE_OUTPUT:
#line 3772 "PulseAudioManager.c"
		{
			pa_subscription_event_type_t event_type = 0;
			pa_subscription_event_type_t _tmp49_;
#line 381 "../src/PulseAudioManager.vala"
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
#line 382 "../src/PulseAudioManager.vala"
			_tmp49_ = event_type;
#line 382 "../src/PulseAudioManager.vala"
			switch (_tmp49_) {
#line 382 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 3784 "PulseAudioManager.c"
				{
					pa_operation* _tmp50_;
					pa_operation* _tmp51_;
#line 384 "../src/PulseAudioManager.vala"
					_tmp50_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 384 "../src/PulseAudioManager.vala"
					_tmp51_ = _tmp50_;
#line 384 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp51_);
#line 385 "../src/PulseAudioManager.vala"
					break;
#line 3796 "PulseAudioManager.c"
				}
#line 382 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 3800 "PulseAudioManager.c"
				{
					pa_operation* _tmp52_;
					pa_operation* _tmp53_;
#line 388 "../src/PulseAudioManager.vala"
					_tmp52_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 388 "../src/PulseAudioManager.vala"
					_tmp53_ = _tmp52_;
#line 388 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp53_);
#line 389 "../src/PulseAudioManager.vala"
					break;
#line 3812 "PulseAudioManager.c"
				}
#line 382 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 3816 "PulseAudioManager.c"
				{
#line 392 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:392: subscribe_callback:SOURCE:REMOVE");
#line 3820 "PulseAudioManager.c"
					{
						GeeIterator* _device_it = NULL;
						GeeHashMap* _tmp54_;
						GeeCollection* _tmp55_;
						GeeCollection* _tmp56_;
						GeeCollection* _tmp57_;
						GeeIterator* _tmp58_;
						GeeIterator* _tmp59_;
#line 393 "../src/PulseAudioManager.vala"
						_tmp54_ = self->priv->input_devices;
#line 393 "../src/PulseAudioManager.vala"
						_tmp55_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp54_);
#line 393 "../src/PulseAudioManager.vala"
						_tmp56_ = _tmp55_;
#line 393 "../src/PulseAudioManager.vala"
						_tmp57_ = _tmp56_;
#line 393 "../src/PulseAudioManager.vala"
						_tmp58_ = gee_iterable_iterator ((GeeIterable*) _tmp57_);
#line 393 "../src/PulseAudioManager.vala"
						_tmp59_ = _tmp58_;
#line 393 "../src/PulseAudioManager.vala"
						_g_object_unref0 (_tmp57_);
#line 393 "../src/PulseAudioManager.vala"
						_device_it = _tmp59_;
#line 393 "../src/PulseAudioManager.vala"
						while (TRUE) {
#line 3847 "PulseAudioManager.c"
							GeeIterator* _tmp60_;
							SoundDevice* device = NULL;
							GeeIterator* _tmp61_;
							gpointer _tmp62_;
							SoundDevice* _tmp63_;
							gint _tmp64_;
							gint _tmp65_;
							SoundDevice* _tmp75_;
							gint _tmp76_;
							gint _tmp77_;
#line 393 "../src/PulseAudioManager.vala"
							_tmp60_ = _device_it;
#line 393 "../src/PulseAudioManager.vala"
							if (!gee_iterator_next (_tmp60_)) {
#line 393 "../src/PulseAudioManager.vala"
								break;
#line 3864 "PulseAudioManager.c"
							}
#line 393 "../src/PulseAudioManager.vala"
							_tmp61_ = _device_it;
#line 393 "../src/PulseAudioManager.vala"
							_tmp62_ = gee_iterator_get (_tmp61_);
#line 393 "../src/PulseAudioManager.vala"
							device = (SoundDevice*) _tmp62_;
#line 394 "../src/PulseAudioManager.vala"
							_tmp63_ = device;
#line 394 "../src/PulseAudioManager.vala"
							_tmp64_ = sound_device_get_source_index (_tmp63_);
#line 394 "../src/PulseAudioManager.vala"
							_tmp65_ = _tmp64_;
#line 394 "../src/PulseAudioManager.vala"
							if (((guint32) _tmp65_) == index) {
#line 3880 "PulseAudioManager.c"
								SoundDevice* _tmp66_;
								const gchar* _tmp67_;
								const gchar* _tmp68_;
								SoundDevice* _tmp69_;
								SoundDevice* _tmp70_;
								SoundDevice* _tmp71_;
								SoundDevice* _tmp72_;
								const gchar* _tmp73_;
								const gchar* _tmp74_;
#line 395 "../src/PulseAudioManager.vala"
								_tmp66_ = device;
#line 395 "../src/PulseAudioManager.vala"
								_tmp67_ = sound_device_get_id (_tmp66_);
#line 395 "../src/PulseAudioManager.vala"
								_tmp68_ = _tmp67_;
#line 395 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:395: \tupdating device: %s", _tmp68_);
#line 396 "../src/PulseAudioManager.vala"
								_tmp69_ = device;
#line 396 "../src/PulseAudioManager.vala"
								sound_device_set_source_name (_tmp69_, NULL);
#line 397 "../src/PulseAudioManager.vala"
								_tmp70_ = device;
#line 397 "../src/PulseAudioManager.vala"
								sound_device_set_source_index (_tmp70_, -1);
#line 398 "../src/PulseAudioManager.vala"
								_tmp71_ = device;
#line 398 "../src/PulseAudioManager.vala"
								sound_device_set_is_default (_tmp71_, FALSE);
#line 399 "../src/PulseAudioManager.vala"
								_tmp72_ = device;
#line 399 "../src/PulseAudioManager.vala"
								_tmp73_ = sound_device_get_source_name (_tmp72_);
#line 399 "../src/PulseAudioManager.vala"
								_tmp74_ = _tmp73_;
#line 399 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:399: \t\tdevice.source_name: %s", _tmp74_);
#line 3918 "PulseAudioManager.c"
							}
#line 402 "../src/PulseAudioManager.vala"
							_tmp75_ = device;
#line 402 "../src/PulseAudioManager.vala"
							_tmp76_ = sound_device_get_card_source_index (_tmp75_);
#line 402 "../src/PulseAudioManager.vala"
							_tmp77_ = _tmp76_;
#line 402 "../src/PulseAudioManager.vala"
							if (((guint32) _tmp77_) == index) {
#line 3928 "PulseAudioManager.c"
								SoundDevice* _tmp78_;
								const gchar* _tmp79_;
								const gchar* _tmp80_;
								SoundDevice* _tmp81_;
								SoundDevice* _tmp82_;
								SoundDevice* _tmp83_;
								SoundDevice* _tmp84_;
								const gchar* _tmp85_;
								const gchar* _tmp86_;
#line 403 "../src/PulseAudioManager.vala"
								_tmp78_ = device;
#line 403 "../src/PulseAudioManager.vala"
								_tmp79_ = sound_device_get_id (_tmp78_);
#line 403 "../src/PulseAudioManager.vala"
								_tmp80_ = _tmp79_;
#line 403 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:403: \tupdating device: %s", _tmp80_);
#line 404 "../src/PulseAudioManager.vala"
								_tmp81_ = device;
#line 404 "../src/PulseAudioManager.vala"
								sound_device_set_card_source_name (_tmp81_, NULL);
#line 405 "../src/PulseAudioManager.vala"
								_tmp82_ = device;
#line 405 "../src/PulseAudioManager.vala"
								sound_device_set_card_source_index (_tmp82_, -1);
#line 406 "../src/PulseAudioManager.vala"
								_tmp83_ = device;
#line 406 "../src/PulseAudioManager.vala"
								sound_device_set_card_source_port_name (_tmp83_, NULL);
#line 407 "../src/PulseAudioManager.vala"
								_tmp84_ = device;
#line 407 "../src/PulseAudioManager.vala"
								_tmp85_ = sound_device_get_card_source_name (_tmp84_);
#line 407 "../src/PulseAudioManager.vala"
								_tmp86_ = _tmp85_;
#line 407 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:407: \t\tdevice.card_source_name: %s", _tmp86_);
#line 3966 "PulseAudioManager.c"
							}
#line 393 "../src/PulseAudioManager.vala"
							_g_object_unref0 (device);
#line 3970 "PulseAudioManager.c"
						}
#line 393 "../src/PulseAudioManager.vala"
						_g_object_unref0 (_device_it);
#line 3974 "PulseAudioManager.c"
					}
#line 411 "../src/PulseAudioManager.vala"
					break;
#line 3978 "PulseAudioManager.c"
				}
				default:
#line 382 "../src/PulseAudioManager.vala"
				break;
#line 3983 "PulseAudioManager.c"
			}
#line 414 "../src/PulseAudioManager.vala"
			break;
#line 3987 "PulseAudioManager.c"
		}
		default:
#line 318 "../src/PulseAudioManager.vala"
		break;
#line 3992 "PulseAudioManager.c"
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 450 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 450 "../src/PulseAudioManager.vala"
	return _data8_;
#line 4003 "PulseAudioManager.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 450 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 4013 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 450 "../src/PulseAudioManager.vala"
		self = _data8_->self;
#line 450 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data8_->device);
#line 450 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 450 "../src/PulseAudioManager.vala"
		g_slice_free (Block8Data, _data8_);
#line 4023 "PulseAudioManager.c"
	}
}

static gboolean
______lambda8_ (Block8Data* _data8_,
                pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
#line 468 "../src/PulseAudioManager.vala"
	self = _data8_->self;
#line 468 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (operation != NULL, FALSE);
#line 469 "../src/PulseAudioManager.vala"
	if (pa_operation_get_state (operation) != PA_OPERATION_RUNNING) {
#line 4039 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
		GeeLinkedList* _tmp1_;
#line 470 "../src/PulseAudioManager.vala"
		_tmp0_ = _data8_->device;
#line 470 "../src/PulseAudioManager.vala"
		_tmp1_ = _tmp0_->volume_operations;
#line 470 "../src/PulseAudioManager.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, operation);
#line 4048 "PulseAudioManager.c"
	}
#line 473 "../src/PulseAudioManager.vala"
	result = G_SOURCE_CONTINUE;
#line 473 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 473 "../src/PulseAudioManager.vala"
	return result;
#line 4056 "PulseAudioManager.c"
}

static gboolean
_______lambda8__gee_forall_func (gpointer g,
                                 gpointer self)
{
	gboolean result;
	result = ______lambda8_ (self, (pa_operation*) g);
#line 468 "../src/PulseAudioManager.vala"
	return result;
#line 4067 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                pa_context* c,
                                                pa_source_info* source,
                                                gint eol)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_source_port_info* _tmp8_;
#line 422 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 422 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 423 "../src/PulseAudioManager.vala"
	if (source == NULL) {
#line 424 "../src/PulseAudioManager.vala"
		return;
#line 4088 "PulseAudioManager.c"
	}
#line 428 "../src/PulseAudioManager.vala"
	if ((*source).monitor_of_sink != PA_INVALID_INDEX) {
#line 429 "../src/PulseAudioManager.vala"
		return;
#line 4094 "PulseAudioManager.c"
	}
#line 432 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:432: source info update");
#line 433 "../src/PulseAudioManager.vala"
	_tmp0_ = (*source).description;
#line 433 "../src/PulseAudioManager.vala"
	_tmp1_ = (*source).name;
#line 433 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:433: \tsource: %s (%s)", _tmp0_, _tmp1_);
#line 434 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:434: \t\tcard: %u", (guint) (*source).card);
#line 436 "../src/PulseAudioManager.vala"
	_tmp2_ = (*source).name;
#line 436 "../src/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp2_, "auto_null") == 0) {
#line 437 "../src/PulseAudioManager.vala"
		return;
#line 4112 "PulseAudioManager.c"
	}
#line 440 "../src/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_DEBUG_ENABLED) {
#line 4116 "PulseAudioManager.c"
		pa_source_port_info** _tmp3_;
		gint _tmp3__length1;
#line 441 "../src/PulseAudioManager.vala"
		_tmp3_ = (*source).ports;
#line 441 "../src/PulseAudioManager.vala"
		_tmp3__length1 = (*source).n_ports;
#line 4123 "PulseAudioManager.c"
		{
			pa_source_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
#line 441 "../src/PulseAudioManager.vala"
			port_collection = _tmp3_;
#line 441 "../src/PulseAudioManager.vala"
			port_collection_length1 = _tmp3__length1;
#line 441 "../src/PulseAudioManager.vala"
			for (port_it = 0; port_it < _tmp3__length1; port_it = port_it + 1) {
#line 4135 "PulseAudioManager.c"
				pa_source_port_info* port = NULL;
#line 441 "../src/PulseAudioManager.vala"
				port = port_collection[port_it];
#line 4139 "PulseAudioManager.c"
				{
					pa_source_port_info* _tmp4_;
					const gchar* _tmp5_;
					pa_source_port_info* _tmp6_;
					const gchar* _tmp7_;
#line 442 "../src/PulseAudioManager.vala"
					_tmp4_ = port;
#line 442 "../src/PulseAudioManager.vala"
					_tmp5_ = (*_tmp4_).description;
#line 442 "../src/PulseAudioManager.vala"
					_tmp6_ = port;
#line 442 "../src/PulseAudioManager.vala"
					_tmp7_ = (*_tmp6_).name;
#line 442 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:442: \t\tport: %s (%s)", _tmp5_, _tmp7_);
#line 4155 "PulseAudioManager.c"
				}
			}
		}
	}
#line 446 "../src/PulseAudioManager.vala"
	_tmp8_ = (*source).active_port;
#line 446 "../src/PulseAudioManager.vala"
	if (_tmp8_ != NULL) {
#line 4164 "PulseAudioManager.c"
		pa_source_port_info* _tmp9_;
		const gchar* _tmp10_;
		pa_source_port_info* _tmp11_;
		const gchar* _tmp12_;
#line 447 "../src/PulseAudioManager.vala"
		_tmp9_ = (*source).active_port;
#line 447 "../src/PulseAudioManager.vala"
		_tmp10_ = (*_tmp9_).description;
#line 447 "../src/PulseAudioManager.vala"
		_tmp11_ = (*source).active_port;
#line 447 "../src/PulseAudioManager.vala"
		_tmp12_ = (*_tmp11_).name;
#line 447 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:447: \t\tactive port: %s (%s)", _tmp10_, _tmp12_);
#line 4179 "PulseAudioManager.c"
	}
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeIterator* _tmp17_;
		GeeIterator* _tmp18_;
#line 450 "../src/PulseAudioManager.vala"
		_tmp13_ = self->priv->input_devices;
#line 450 "../src/PulseAudioManager.vala"
		_tmp14_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp13_);
#line 450 "../src/PulseAudioManager.vala"
		_tmp15_ = _tmp14_;
#line 450 "../src/PulseAudioManager.vala"
		_tmp16_ = _tmp15_;
#line 450 "../src/PulseAudioManager.vala"
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 450 "../src/PulseAudioManager.vala"
		_tmp18_ = _tmp17_;
#line 450 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_tmp16_);
#line 450 "../src/PulseAudioManager.vala"
		_device_it = _tmp18_;
#line 450 "../src/PulseAudioManager.vala"
		while (TRUE) {
#line 4207 "PulseAudioManager.c"
			Block8Data* _data8_;
			GeeIterator* _tmp19_;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			SoundDevice* _tmp22_;
			guint32 _tmp23_;
			guint32 _tmp24_;
#line 450 "../src/PulseAudioManager.vala"
			_data8_ = g_slice_new0 (Block8Data);
#line 450 "../src/PulseAudioManager.vala"
			_data8_->_ref_count_ = 1;
#line 450 "../src/PulseAudioManager.vala"
			_data8_->self = g_object_ref (self);
#line 450 "../src/PulseAudioManager.vala"
			_tmp19_ = _device_it;
#line 450 "../src/PulseAudioManager.vala"
			if (!gee_iterator_next (_tmp19_)) {
#line 450 "../src/PulseAudioManager.vala"
				block8_data_unref (_data8_);
#line 450 "../src/PulseAudioManager.vala"
				_data8_ = NULL;
#line 450 "../src/PulseAudioManager.vala"
				break;
#line 4231 "PulseAudioManager.c"
			}
#line 450 "../src/PulseAudioManager.vala"
			_tmp20_ = _device_it;
#line 450 "../src/PulseAudioManager.vala"
			_tmp21_ = gee_iterator_get (_tmp20_);
#line 450 "../src/PulseAudioManager.vala"
			_data8_->device = (SoundDevice*) _tmp21_;
#line 451 "../src/PulseAudioManager.vala"
			_tmp22_ = _data8_->device;
#line 451 "../src/PulseAudioManager.vala"
			_tmp23_ = sound_device_get_card_index (_tmp22_);
#line 451 "../src/PulseAudioManager.vala"
			_tmp24_ = _tmp23_;
#line 451 "../src/PulseAudioManager.vala"
			if (_tmp24_ == (*source).card) {
#line 4247 "PulseAudioManager.c"
				SoundDevice* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				SoundDevice* _tmp28_;
				SoundDevice* _tmp29_;
				const gchar* _tmp30_;
				SoundDevice* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				SoundDevice* _tmp34_;
				pa_source_port_info* _tmp35_;
				const gchar* _tmp36_;
				SoundDevice* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				pa_source_port_info* _tmp40_;
				const gchar* _tmp41_;
#line 452 "../src/PulseAudioManager.vala"
				_tmp25_ = _data8_->device;
#line 452 "../src/PulseAudioManager.vala"
				_tmp26_ = sound_device_get_id (_tmp25_);
#line 452 "../src/PulseAudioManager.vala"
				_tmp27_ = _tmp26_;
#line 452 "../src/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:452: \t\tupdating device: %s", _tmp27_);
#line 453 "../src/PulseAudioManager.vala"
				_tmp28_ = _data8_->device;
#line 453 "../src/PulseAudioManager.vala"
				sound_device_set_card_source_index (_tmp28_, (gint) (*source).index);
#line 454 "../src/PulseAudioManager.vala"
				_tmp29_ = _data8_->device;
#line 454 "../src/PulseAudioManager.vala"
				_tmp30_ = (*source).name;
#line 454 "../src/PulseAudioManager.vala"
				sound_device_set_card_source_name (_tmp29_, _tmp30_);
#line 455 "../src/PulseAudioManager.vala"
				_tmp31_ = _data8_->device;
#line 455 "../src/PulseAudioManager.vala"
				_tmp32_ = sound_device_get_card_source_name (_tmp31_);
#line 455 "../src/PulseAudioManager.vala"
				_tmp33_ = _tmp32_;
#line 455 "../src/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:455: \t\t\tdevice.card_source_name: %s", _tmp33_);
#line 456 "../src/PulseAudioManager.vala"
				_tmp34_ = _data8_->device;
#line 456 "../src/PulseAudioManager.vala"
				_tmp35_ = (*source).active_port;
#line 456 "../src/PulseAudioManager.vala"
				_tmp36_ = (*_tmp35_).name;
#line 456 "../src/PulseAudioManager.vala"
				sound_device_set_card_source_port_name (_tmp34_, _tmp36_);
#line 457 "../src/PulseAudioManager.vala"
				_tmp37_ = _data8_->device;
#line 457 "../src/PulseAudioManager.vala"
				_tmp38_ = sound_device_get_port_name (_tmp37_);
#line 457 "../src/PulseAudioManager.vala"
				_tmp39_ = _tmp38_;
#line 457 "../src/PulseAudioManager.vala"
				_tmp40_ = (*source).active_port;
#line 457 "../src/PulseAudioManager.vala"
				_tmp41_ = (*_tmp40_).name;
#line 457 "../src/PulseAudioManager.vala"
				if (g_strcmp0 (_tmp39_, _tmp41_) == 0) {
#line 4311 "PulseAudioManager.c"
					SoundDevice* _tmp42_;
					const gchar* _tmp43_;
					SoundDevice* _tmp44_;
					const gchar* _tmp45_;
					const gchar* _tmp46_;
					SoundDevice* _tmp47_;
					SoundDevice* _tmp48_;
					const gchar* _tmp49_;
					const gchar* _tmp50_;
					const gchar* _tmp51_ = NULL;
					SoundDevice* _tmp52_;
					gboolean _tmp53_;
					gboolean _tmp54_;
					SoundDevice* _tmp55_;
					SoundDevice* _tmp56_;
					pa_cvolume _tmp57_;
					SoundDevice* _tmp58_;
					pa_channel_map _tmp59_;
					SoundDevice* _tmp60_;
					pa_channel_map _tmp61_;
					SoundDevice* _tmp62_;
					GeeLinkedList* _tmp63_;
					SoundDevice* _tmp64_;
					GeeLinkedList* _tmp65_;
					gboolean _tmp66_;
					gboolean _tmp67_;
					SoundDevice* _tmp69_;
					gboolean _tmp70_;
					gboolean _tmp71_;
#line 458 "../src/PulseAudioManager.vala"
					_tmp42_ = _data8_->device;
#line 458 "../src/PulseAudioManager.vala"
					_tmp43_ = (*source).name;
#line 458 "../src/PulseAudioManager.vala"
					sound_device_set_source_name (_tmp42_, _tmp43_);
#line 459 "../src/PulseAudioManager.vala"
					_tmp44_ = _data8_->device;
#line 459 "../src/PulseAudioManager.vala"
					_tmp45_ = sound_device_get_card_source_name (_tmp44_);
#line 459 "../src/PulseAudioManager.vala"
					_tmp46_ = _tmp45_;
#line 459 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:459: \t\t\tdevice.source_name: %s", _tmp46_);
#line 460 "../src/PulseAudioManager.vala"
					_tmp47_ = _data8_->device;
#line 460 "../src/PulseAudioManager.vala"
					sound_device_set_source_index (_tmp47_, (gint) (*source).index);
#line 461 "../src/PulseAudioManager.vala"
					_tmp48_ = _data8_->device;
#line 461 "../src/PulseAudioManager.vala"
					_tmp49_ = (*source).name;
#line 461 "../src/PulseAudioManager.vala"
					_tmp50_ = self->priv->default_source_name;
#line 461 "../src/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp48_, g_strcmp0 (_tmp49_, _tmp50_) == 0);
#line 462 "../src/PulseAudioManager.vala"
					_tmp52_ = _data8_->device;
#line 462 "../src/PulseAudioManager.vala"
					_tmp53_ = sound_device_get_is_default (_tmp52_);
#line 462 "../src/PulseAudioManager.vala"
					_tmp54_ = _tmp53_;
#line 462 "../src/PulseAudioManager.vala"
					if (_tmp54_) {
#line 462 "../src/PulseAudioManager.vala"
						_tmp51_ = "true";
#line 4377 "PulseAudioManager.c"
					} else {
#line 462 "../src/PulseAudioManager.vala"
						_tmp51_ = "false";
#line 4381 "PulseAudioManager.c"
					}
#line 462 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:462: \t\t\tis_default: %s", _tmp51_);
#line 464 "../src/PulseAudioManager.vala"
					_tmp55_ = _data8_->device;
#line 464 "../src/PulseAudioManager.vala"
					sound_device_set_is_muted (_tmp55_, (*source).mute != 0);
#line 465 "../src/PulseAudioManager.vala"
					_tmp56_ = _data8_->device;
#line 465 "../src/PulseAudioManager.vala"
					_tmp57_ = (*source).volume;
#line 465 "../src/PulseAudioManager.vala"
					sound_device_set_cvolume (_tmp56_, &_tmp57_);
#line 466 "../src/PulseAudioManager.vala"
					_tmp58_ = _data8_->device;
#line 466 "../src/PulseAudioManager.vala"
					_tmp59_ = (*source).channel_map;
#line 466 "../src/PulseAudioManager.vala"
					sound_device_set_channel_map (_tmp58_, &_tmp59_);
#line 467 "../src/PulseAudioManager.vala"
					_tmp60_ = _data8_->device;
#line 467 "../src/PulseAudioManager.vala"
					_tmp61_ = (*source).channel_map;
#line 467 "../src/PulseAudioManager.vala"
					sound_device_set_balance (_tmp60_, pa_cvolume_get_balance (&(*source).volume, &_tmp61_));
#line 468 "../src/PulseAudioManager.vala"
					_tmp62_ = _data8_->device;
#line 468 "../src/PulseAudioManager.vala"
					_tmp63_ = _tmp62_->volume_operations;
#line 468 "../src/PulseAudioManager.vala"
					gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp63_, _______lambda8__gee_forall_func, _data8_);
#line 476 "../src/PulseAudioManager.vala"
					_tmp64_ = _data8_->device;
#line 476 "../src/PulseAudioManager.vala"
					_tmp65_ = _tmp64_->volume_operations;
#line 476 "../src/PulseAudioManager.vala"
					_tmp66_ = gee_collection_get_is_empty ((GeeCollection*) _tmp65_);
#line 476 "../src/PulseAudioManager.vala"
					_tmp67_ = _tmp66_;
#line 476 "../src/PulseAudioManager.vala"
					if (_tmp67_) {
#line 4423 "PulseAudioManager.c"
						SoundDevice* _tmp68_;
#line 477 "../src/PulseAudioManager.vala"
						_tmp68_ = _data8_->device;
#line 477 "../src/PulseAudioManager.vala"
						sound_device_set_volume (_tmp68_, sound_pulse_audio_manager_volume_to_double (pa_cvolume_max (&(*source).volume)));
#line 4429 "PulseAudioManager.c"
					}
#line 480 "../src/PulseAudioManager.vala"
					_tmp69_ = _data8_->device;
#line 480 "../src/PulseAudioManager.vala"
					_tmp70_ = sound_device_get_is_default (_tmp69_);
#line 480 "../src/PulseAudioManager.vala"
					_tmp71_ = _tmp70_;
#line 480 "../src/PulseAudioManager.vala"
					if (_tmp71_) {
#line 4439 "PulseAudioManager.c"
						SoundDevice* _tmp72_;
#line 481 "../src/PulseAudioManager.vala"
						_tmp72_ = _data8_->device;
#line 481 "../src/PulseAudioManager.vala"
						sound_pulse_audio_manager_set_default_input (self, _tmp72_);
#line 4445 "PulseAudioManager.c"
					}
				} else {
					SoundDevice* _tmp73_;
					SoundDevice* _tmp74_;
					SoundDevice* _tmp75_;
#line 485 "../src/PulseAudioManager.vala"
					_tmp73_ = _data8_->device;
#line 485 "../src/PulseAudioManager.vala"
					sound_device_set_source_name (_tmp73_, NULL);
#line 486 "../src/PulseAudioManager.vala"
					_tmp74_ = _data8_->device;
#line 486 "../src/PulseAudioManager.vala"
					sound_device_set_source_index (_tmp74_, -1);
#line 487 "../src/PulseAudioManager.vala"
					_tmp75_ = _data8_->device;
#line 487 "../src/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp75_, FALSE);
#line 4463 "PulseAudioManager.c"
				}
			}
#line 450 "../src/PulseAudioManager.vala"
			block8_data_unref (_data8_);
#line 450 "../src/PulseAudioManager.vala"
			_data8_ = NULL;
#line 4470 "PulseAudioManager.c"
		}
#line 450 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_device_it);
#line 4474 "PulseAudioManager.c"
	}
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 514 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 514 "../src/PulseAudioManager.vala"
	return _data9_;
#line 4485 "PulseAudioManager.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 514 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 4495 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 514 "../src/PulseAudioManager.vala"
		self = _data9_->self;
#line 514 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data9_->device);
#line 514 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 514 "../src/PulseAudioManager.vala"
		g_slice_free (Block9Data, _data9_);
#line 4505 "PulseAudioManager.c"
	}
}

static gboolean
______lambda5_ (Block9Data* _data9_,
                pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result = FALSE;
#line 531 "../src/PulseAudioManager.vala"
	self = _data9_->self;
#line 531 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (operation != NULL, FALSE);
#line 532 "../src/PulseAudioManager.vala"
	if (pa_operation_get_state (operation) != PA_OPERATION_RUNNING) {
#line 4521 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
		GeeLinkedList* _tmp1_;
#line 533 "../src/PulseAudioManager.vala"
		_tmp0_ = _data9_->device;
#line 533 "../src/PulseAudioManager.vala"
		_tmp1_ = _tmp0_->volume_operations;
#line 533 "../src/PulseAudioManager.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, operation);
#line 4530 "PulseAudioManager.c"
	}
#line 536 "../src/PulseAudioManager.vala"
	result = G_SOURCE_CONTINUE;
#line 536 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 536 "../src/PulseAudioManager.vala"
	return result;
#line 4538 "PulseAudioManager.c"
}

static gboolean
_______lambda5__gee_forall_func (gpointer g,
                                 gpointer self)
{
	gboolean result;
	result = ______lambda5_ (self, (pa_operation*) g);
#line 531 "../src/PulseAudioManager.vala"
	return result;
#line 4549 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_sink_info* sink,
                                              gint eol)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_sink_port_info* _tmp8_;
	const gchar* _tmp9_;
	pa_sink_port_info* _tmp10_;
	const gchar* _tmp11_;
#line 493 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 493 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 494 "../src/PulseAudioManager.vala"
	if (sink == NULL) {
#line 495 "../src/PulseAudioManager.vala"
		return;
#line 4573 "PulseAudioManager.c"
	}
#line 498 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:498: sink info update");
#line 499 "../src/PulseAudioManager.vala"
	_tmp0_ = (*sink).description;
#line 499 "../src/PulseAudioManager.vala"
	_tmp1_ = (*sink).name;
#line 499 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:499: \tsink: %s (%s)", _tmp0_, _tmp1_);
#line 501 "../src/PulseAudioManager.vala"
	_tmp2_ = (*sink).name;
#line 501 "../src/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp2_, "auto_null") == 0) {
#line 502 "../src/PulseAudioManager.vala"
		return;
#line 4589 "PulseAudioManager.c"
	}
#line 505 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:505: \t\tcard: %u", (guint) (*sink).card);
#line 506 "../src/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_DEBUG_ENABLED) {
#line 4595 "PulseAudioManager.c"
		pa_sink_port_info** _tmp3_;
		gint _tmp3__length1;
#line 507 "../src/PulseAudioManager.vala"
		_tmp3_ = (*sink).ports;
#line 507 "../src/PulseAudioManager.vala"
		_tmp3__length1 = (*sink).n_ports;
#line 4602 "PulseAudioManager.c"
		{
			pa_sink_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
#line 507 "../src/PulseAudioManager.vala"
			port_collection = _tmp3_;
#line 507 "../src/PulseAudioManager.vala"
			port_collection_length1 = _tmp3__length1;
#line 507 "../src/PulseAudioManager.vala"
			for (port_it = 0; port_it < _tmp3__length1; port_it = port_it + 1) {
#line 4614 "PulseAudioManager.c"
				pa_sink_port_info* port = NULL;
#line 507 "../src/PulseAudioManager.vala"
				port = port_collection[port_it];
#line 4618 "PulseAudioManager.c"
				{
					pa_sink_port_info* _tmp4_;
					const gchar* _tmp5_;
					pa_sink_port_info* _tmp6_;
					const gchar* _tmp7_;
#line 508 "../src/PulseAudioManager.vala"
					_tmp4_ = port;
#line 508 "../src/PulseAudioManager.vala"
					_tmp5_ = (*_tmp4_).description;
#line 508 "../src/PulseAudioManager.vala"
					_tmp6_ = port;
#line 508 "../src/PulseAudioManager.vala"
					_tmp7_ = (*_tmp6_).name;
#line 508 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:508: \t\tport: %s (%s)", _tmp5_, _tmp7_);
#line 4634 "PulseAudioManager.c"
				}
			}
		}
	}
#line 512 "../src/PulseAudioManager.vala"
	_tmp8_ = (*sink).active_port;
#line 512 "../src/PulseAudioManager.vala"
	_tmp9_ = (*_tmp8_).description;
#line 512 "../src/PulseAudioManager.vala"
	_tmp10_ = (*sink).active_port;
#line 512 "../src/PulseAudioManager.vala"
	_tmp11_ = (*_tmp10_).name;
#line 512 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:512: \t\tactive port: %s (%s)", _tmp9_, _tmp11_);
#line 4649 "PulseAudioManager.c"
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp12_;
		GeeCollection* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeIterator* _tmp16_;
		GeeIterator* _tmp17_;
#line 514 "../src/PulseAudioManager.vala"
		_tmp12_ = self->priv->output_devices;
#line 514 "../src/PulseAudioManager.vala"
		_tmp13_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp12_);
#line 514 "../src/PulseAudioManager.vala"
		_tmp14_ = _tmp13_;
#line 514 "../src/PulseAudioManager.vala"
		_tmp15_ = _tmp14_;
#line 514 "../src/PulseAudioManager.vala"
		_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 514 "../src/PulseAudioManager.vala"
		_tmp17_ = _tmp16_;
#line 514 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_tmp15_);
#line 514 "../src/PulseAudioManager.vala"
		_device_it = _tmp17_;
#line 514 "../src/PulseAudioManager.vala"
		while (TRUE) {
#line 4676 "PulseAudioManager.c"
			Block9Data* _data9_;
			GeeIterator* _tmp18_;
			GeeIterator* _tmp19_;
			gpointer _tmp20_;
			SoundDevice* _tmp21_;
			guint32 _tmp22_;
			guint32 _tmp23_;
#line 514 "../src/PulseAudioManager.vala"
			_data9_ = g_slice_new0 (Block9Data);
#line 514 "../src/PulseAudioManager.vala"
			_data9_->_ref_count_ = 1;
#line 514 "../src/PulseAudioManager.vala"
			_data9_->self = g_object_ref (self);
#line 514 "../src/PulseAudioManager.vala"
			_tmp18_ = _device_it;
#line 514 "../src/PulseAudioManager.vala"
			if (!gee_iterator_next (_tmp18_)) {
#line 514 "../src/PulseAudioManager.vala"
				block9_data_unref (_data9_);
#line 514 "../src/PulseAudioManager.vala"
				_data9_ = NULL;
#line 514 "../src/PulseAudioManager.vala"
				break;
#line 4700 "PulseAudioManager.c"
			}
#line 514 "../src/PulseAudioManager.vala"
			_tmp19_ = _device_it;
#line 514 "../src/PulseAudioManager.vala"
			_tmp20_ = gee_iterator_get (_tmp19_);
#line 514 "../src/PulseAudioManager.vala"
			_data9_->device = (SoundDevice*) _tmp20_;
#line 515 "../src/PulseAudioManager.vala"
			_tmp21_ = _data9_->device;
#line 515 "../src/PulseAudioManager.vala"
			_tmp22_ = sound_device_get_card_index (_tmp21_);
#line 515 "../src/PulseAudioManager.vala"
			_tmp23_ = _tmp22_;
#line 515 "../src/PulseAudioManager.vala"
			if (_tmp23_ == (*sink).card) {
#line 4716 "PulseAudioManager.c"
				SoundDevice* _tmp24_;
				const gchar* _tmp25_;
				const gchar* _tmp26_;
				SoundDevice* _tmp27_;
				SoundDevice* _tmp28_;
				const gchar* _tmp29_;
				SoundDevice* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				SoundDevice* _tmp33_;
				pa_sink_port_info* _tmp34_;
				const gchar* _tmp35_;
				SoundDevice* _tmp36_;
				const gchar* _tmp37_;
				const gchar* _tmp38_;
				pa_sink_port_info* _tmp39_;
				const gchar* _tmp40_;
#line 516 "../src/PulseAudioManager.vala"
				_tmp24_ = _data9_->device;
#line 516 "../src/PulseAudioManager.vala"
				_tmp25_ = sound_device_get_id (_tmp24_);
#line 516 "../src/PulseAudioManager.vala"
				_tmp26_ = _tmp25_;
#line 516 "../src/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:516: \t\tupdating device: %s", _tmp26_);
#line 517 "../src/PulseAudioManager.vala"
				_tmp27_ = _data9_->device;
#line 517 "../src/PulseAudioManager.vala"
				sound_device_set_card_sink_index (_tmp27_, (gint) (*sink).index);
#line 518 "../src/PulseAudioManager.vala"
				_tmp28_ = _data9_->device;
#line 518 "../src/PulseAudioManager.vala"
				_tmp29_ = (*sink).name;
#line 518 "../src/PulseAudioManager.vala"
				sound_device_set_card_sink_name (_tmp28_, _tmp29_);
#line 519 "../src/PulseAudioManager.vala"
				_tmp30_ = _data9_->device;
#line 519 "../src/PulseAudioManager.vala"
				_tmp31_ = sound_device_get_card_sink_name (_tmp30_);
#line 519 "../src/PulseAudioManager.vala"
				_tmp32_ = _tmp31_;
#line 519 "../src/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:519: \t\t\tdevice.card_sink_name: %s", _tmp32_);
#line 520 "../src/PulseAudioManager.vala"
				_tmp33_ = _data9_->device;
#line 520 "../src/PulseAudioManager.vala"
				_tmp34_ = (*sink).active_port;
#line 520 "../src/PulseAudioManager.vala"
				_tmp35_ = (*_tmp34_).name;
#line 520 "../src/PulseAudioManager.vala"
				sound_device_set_card_sink_port_name (_tmp33_, _tmp35_);
#line 521 "../src/PulseAudioManager.vala"
				_tmp36_ = _data9_->device;
#line 521 "../src/PulseAudioManager.vala"
				_tmp37_ = sound_device_get_port_name (_tmp36_);
#line 521 "../src/PulseAudioManager.vala"
				_tmp38_ = _tmp37_;
#line 521 "../src/PulseAudioManager.vala"
				_tmp39_ = (*sink).active_port;
#line 521 "../src/PulseAudioManager.vala"
				_tmp40_ = (*_tmp39_).name;
#line 521 "../src/PulseAudioManager.vala"
				if (g_strcmp0 (_tmp38_, _tmp40_) == 0) {
#line 4780 "PulseAudioManager.c"
					SoundDevice* _tmp41_;
					const gchar* _tmp42_;
					SoundDevice* _tmp43_;
					const gchar* _tmp44_;
					const gchar* _tmp45_;
					SoundDevice* _tmp46_;
					SoundDevice* _tmp47_;
					const gchar* _tmp48_;
					const gchar* _tmp49_;
					const gchar* _tmp50_ = NULL;
					SoundDevice* _tmp51_;
					gboolean _tmp52_;
					gboolean _tmp53_;
					SoundDevice* _tmp54_;
					SoundDevice* _tmp55_;
					pa_cvolume _tmp56_;
					SoundDevice* _tmp57_;
					pa_channel_map _tmp58_;
					SoundDevice* _tmp59_;
					pa_channel_map _tmp60_;
					SoundDevice* _tmp61_;
					GeeLinkedList* _tmp62_;
					SoundDevice* _tmp63_;
					GeeLinkedList* _tmp64_;
					gboolean _tmp65_;
					gboolean _tmp66_;
					SoundDevice* _tmp68_;
					gboolean _tmp69_;
					gboolean _tmp70_;
#line 522 "../src/PulseAudioManager.vala"
					_tmp41_ = _data9_->device;
#line 522 "../src/PulseAudioManager.vala"
					_tmp42_ = (*sink).name;
#line 522 "../src/PulseAudioManager.vala"
					sound_device_set_sink_name (_tmp41_, _tmp42_);
#line 523 "../src/PulseAudioManager.vala"
					_tmp43_ = _data9_->device;
#line 523 "../src/PulseAudioManager.vala"
					_tmp44_ = sound_device_get_card_sink_name (_tmp43_);
#line 523 "../src/PulseAudioManager.vala"
					_tmp45_ = _tmp44_;
#line 523 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:523: \t\t\tdevice.sink_name: %s", _tmp45_);
#line 524 "../src/PulseAudioManager.vala"
					_tmp46_ = _data9_->device;
#line 524 "../src/PulseAudioManager.vala"
					sound_device_set_sink_index (_tmp46_, (gint) (*sink).index);
#line 525 "../src/PulseAudioManager.vala"
					_tmp47_ = _data9_->device;
#line 525 "../src/PulseAudioManager.vala"
					_tmp48_ = (*sink).name;
#line 525 "../src/PulseAudioManager.vala"
					_tmp49_ = self->priv->default_sink_name;
#line 525 "../src/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp47_, g_strcmp0 (_tmp48_, _tmp49_) == 0);
#line 526 "../src/PulseAudioManager.vala"
					_tmp51_ = _data9_->device;
#line 526 "../src/PulseAudioManager.vala"
					_tmp52_ = sound_device_get_is_default (_tmp51_);
#line 526 "../src/PulseAudioManager.vala"
					_tmp53_ = _tmp52_;
#line 526 "../src/PulseAudioManager.vala"
					if (_tmp53_) {
#line 526 "../src/PulseAudioManager.vala"
						_tmp50_ = "true";
#line 4846 "PulseAudioManager.c"
					} else {
#line 526 "../src/PulseAudioManager.vala"
						_tmp50_ = "false";
#line 4850 "PulseAudioManager.c"
					}
#line 526 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:526: \t\t\tis_default: %s", _tmp50_);
#line 527 "../src/PulseAudioManager.vala"
					_tmp54_ = _data9_->device;
#line 527 "../src/PulseAudioManager.vala"
					sound_device_set_is_muted (_tmp54_, (*sink).mute != 0);
#line 528 "../src/PulseAudioManager.vala"
					_tmp55_ = _data9_->device;
#line 528 "../src/PulseAudioManager.vala"
					_tmp56_ = (*sink).volume;
#line 528 "../src/PulseAudioManager.vala"
					sound_device_set_cvolume (_tmp55_, &_tmp56_);
#line 529 "../src/PulseAudioManager.vala"
					_tmp57_ = _data9_->device;
#line 529 "../src/PulseAudioManager.vala"
					_tmp58_ = (*sink).channel_map;
#line 529 "../src/PulseAudioManager.vala"
					sound_device_set_channel_map (_tmp57_, &_tmp58_);
#line 530 "../src/PulseAudioManager.vala"
					_tmp59_ = _data9_->device;
#line 530 "../src/PulseAudioManager.vala"
					_tmp60_ = (*sink).channel_map;
#line 530 "../src/PulseAudioManager.vala"
					sound_device_set_balance (_tmp59_, pa_cvolume_get_balance (&(*sink).volume, &_tmp60_));
#line 531 "../src/PulseAudioManager.vala"
					_tmp61_ = _data9_->device;
#line 531 "../src/PulseAudioManager.vala"
					_tmp62_ = _tmp61_->volume_operations;
#line 531 "../src/PulseAudioManager.vala"
					gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp62_, _______lambda5__gee_forall_func, _data9_);
#line 539 "../src/PulseAudioManager.vala"
					_tmp63_ = _data9_->device;
#line 539 "../src/PulseAudioManager.vala"
					_tmp64_ = _tmp63_->volume_operations;
#line 539 "../src/PulseAudioManager.vala"
					_tmp65_ = gee_collection_get_is_empty ((GeeCollection*) _tmp64_);
#line 539 "../src/PulseAudioManager.vala"
					_tmp66_ = _tmp65_;
#line 539 "../src/PulseAudioManager.vala"
					if (_tmp66_) {
#line 4892 "PulseAudioManager.c"
						SoundDevice* _tmp67_;
#line 540 "../src/PulseAudioManager.vala"
						_tmp67_ = _data9_->device;
#line 540 "../src/PulseAudioManager.vala"
						sound_device_set_volume (_tmp67_, sound_pulse_audio_manager_volume_to_double (pa_cvolume_max (&(*sink).volume)));
#line 4898 "PulseAudioManager.c"
					}
#line 543 "../src/PulseAudioManager.vala"
					_tmp68_ = _data9_->device;
#line 543 "../src/PulseAudioManager.vala"
					_tmp69_ = sound_device_get_is_default (_tmp68_);
#line 543 "../src/PulseAudioManager.vala"
					_tmp70_ = _tmp69_;
#line 543 "../src/PulseAudioManager.vala"
					if (_tmp70_) {
#line 4908 "PulseAudioManager.c"
						SoundDevice* _tmp71_;
#line 544 "../src/PulseAudioManager.vala"
						_tmp71_ = _data9_->device;
#line 544 "../src/PulseAudioManager.vala"
						sound_pulse_audio_manager_set_default_output (self, _tmp71_);
#line 4914 "PulseAudioManager.c"
					}
				} else {
					SoundDevice* _tmp72_;
					SoundDevice* _tmp73_;
					SoundDevice* _tmp74_;
#line 548 "../src/PulseAudioManager.vala"
					_tmp72_ = _data9_->device;
#line 548 "../src/PulseAudioManager.vala"
					sound_device_set_sink_name (_tmp72_, NULL);
#line 549 "../src/PulseAudioManager.vala"
					_tmp73_ = _data9_->device;
#line 549 "../src/PulseAudioManager.vala"
					sound_device_set_sink_index (_tmp73_, -1);
#line 550 "../src/PulseAudioManager.vala"
					_tmp74_ = _data9_->device;
#line 550 "../src/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp74_, FALSE);
#line 4932 "PulseAudioManager.c"
				}
			}
#line 514 "../src/PulseAudioManager.vala"
			block9_data_unref (_data9_);
#line 514 "../src/PulseAudioManager.vala"
			_data9_ = NULL;
#line 4939 "PulseAudioManager.c"
		}
#line 514 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_device_it);
#line 4943 "PulseAudioManager.c"
	}
}

static void
_vala_array_add1 (pa_card_port_info** * array,
                  int* length,
                  int* size,
                  pa_card_port_info* value)
{
#line 577 "../src/PulseAudioManager.vala"
	if ((*length) == (*size)) {
#line 577 "../src/PulseAudioManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 577 "../src/PulseAudioManager.vala"
		*array = g_renew (pa_card_port_info*, *array, *size);
#line 4959 "PulseAudioManager.c"
	}
#line 577 "../src/PulseAudioManager.vala"
	(*array)[(*length)++] = value;
#line 4963 "PulseAudioManager.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1516 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1517 "glib-2.0.vapi"
	result = self;
#line 1517 "glib-2.0.vapi"
	return result;
#line 4976 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_card_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_card_info* card,
                                              gint eol)
{
	pa_proplist* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_card_profile_info2* _tmp3_;
	const gchar* _tmp4_;
	pa_proplist* _tmp5_;
	const gchar* _tmp6_;
	pa_proplist* _tmp7_;
	const gchar* _tmp8_;
	gchar* card_active_profile_name = NULL;
	pa_card_profile_info2* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	pa_card_port_info** relevant_ports = NULL;
	pa_card_port_info** _tmp12_;
	gint relevant_ports_length1;
	gint _relevant_ports_size_;
	pa_card_port_info** _tmp13_;
	gint _tmp13__length1;
	pa_card_port_info** _tmp18_;
	gint _tmp18__length1;
	GeeHashMap* _tmp85_;
	pa_card_port_info** _tmp86_;
	gint _tmp86__length1;
	pa_card_info _tmp87_;
	GeeHashMap* _tmp88_;
	pa_card_port_info** _tmp89_;
	gint _tmp89__length1;
	pa_card_info _tmp90_;
#line 556 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 556 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 557 "../src/PulseAudioManager.vala"
	if (card == NULL) {
#line 558 "../src/PulseAudioManager.vala"
		return;
#line 5022 "PulseAudioManager.c"
	}
#line 561 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:561: card info update");
#line 562 "../src/PulseAudioManager.vala"
	_tmp0_ = (*card).proplist;
#line 562 "../src/PulseAudioManager.vala"
	_tmp1_ = pa_proplist_gets (_tmp0_, PA_PROP_DEVICE_DESCRIPTION);
#line 562 "../src/PulseAudioManager.vala"
	_tmp2_ = (*card).name;
#line 562 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:562: \tcard: %u %s (%s)", (guint) (*card).index, _tmp1_, _tmp2_);
#line 563 "../src/PulseAudioManager.vala"
	_tmp3_ = (*card).active_profile2;
#line 563 "../src/PulseAudioManager.vala"
	_tmp4_ = (*_tmp3_).name;
#line 563 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:563: \t\tactive profile: %s", _tmp4_);
#line 565 "../src/PulseAudioManager.vala"
	_tmp5_ = (*card).proplist;
#line 565 "../src/PulseAudioManager.vala"
	_tmp6_ = pa_proplist_gets (_tmp5_, PA_PROP_DEVICE_FORM_FACTOR);
#line 565 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:565: \t\tcard form factor: %s", _tmp6_);
#line 566 "../src/PulseAudioManager.vala"
	_tmp7_ = (*card).proplist;
#line 566 "../src/PulseAudioManager.vala"
	_tmp8_ = pa_proplist_gets (_tmp7_, PA_PROP_MEDIA_ICON_NAME);
#line 566 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:566: \t\tcard icon name: %s", _tmp8_);
#line 568 "../src/PulseAudioManager.vala"
	_tmp9_ = (*card).active_profile2;
#line 568 "../src/PulseAudioManager.vala"
	_tmp10_ = (*_tmp9_).name;
#line 568 "../src/PulseAudioManager.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 568 "../src/PulseAudioManager.vala"
	card_active_profile_name = _tmp11_;
#line 571 "../src/PulseAudioManager.vala"
	_tmp12_ = g_new0 (pa_card_port_info*, 0);
#line 571 "../src/PulseAudioManager.vala"
	relevant_ports = _tmp12_;
#line 571 "../src/PulseAudioManager.vala"
	relevant_ports_length1 = 0;
#line 571 "../src/PulseAudioManager.vala"
	_relevant_ports_size_ = relevant_ports_length1;
#line 572 "../src/PulseAudioManager.vala"
	_tmp13_ = (*card).ports;
#line 572 "../src/PulseAudioManager.vala"
	_tmp13__length1 = (*card).n_ports;
#line 5072 "PulseAudioManager.c"
	{
		pa_card_port_info** port_collection = NULL;
		gint port_collection_length1 = 0;
		gint _port_collection_size_ = 0;
		gint port_it = 0;
#line 572 "../src/PulseAudioManager.vala"
		port_collection = _tmp13_;
#line 572 "../src/PulseAudioManager.vala"
		port_collection_length1 = _tmp13__length1;
#line 572 "../src/PulseAudioManager.vala"
		for (port_it = 0; port_it < _tmp13__length1; port_it = port_it + 1) {
#line 5084 "PulseAudioManager.c"
			pa_card_port_info* port = NULL;
#line 572 "../src/PulseAudioManager.vala"
			port = port_collection[port_it];
#line 5088 "PulseAudioManager.c"
			{
				pa_card_port_info* _tmp14_;
				pa_port_available_t _tmp15_;
				pa_card_port_info** _tmp16_;
				gint _tmp16__length1;
				pa_card_port_info* _tmp17_;
#line 573 "../src/PulseAudioManager.vala"
				_tmp14_ = port;
#line 573 "../src/PulseAudioManager.vala"
				_tmp15_ = (*_tmp14_).available;
#line 573 "../src/PulseAudioManager.vala"
				if (_tmp15_ == PA_PORT_AVAILABLE_NO) {
#line 574 "../src/PulseAudioManager.vala"
					continue;
#line 5103 "PulseAudioManager.c"
				}
#line 577 "../src/PulseAudioManager.vala"
				_tmp16_ = relevant_ports;
#line 577 "../src/PulseAudioManager.vala"
				_tmp16__length1 = relevant_ports_length1;
#line 577 "../src/PulseAudioManager.vala"
				_tmp17_ = port;
#line 577 "../src/PulseAudioManager.vala"
				_vala_array_add1 (&relevant_ports, &relevant_ports_length1, &_relevant_ports_size_, _tmp17_);
#line 5113 "PulseAudioManager.c"
			}
		}
	}
#line 581 "../src/PulseAudioManager.vala"
	_tmp18_ = relevant_ports;
#line 581 "../src/PulseAudioManager.vala"
	_tmp18__length1 = relevant_ports_length1;
#line 5121 "PulseAudioManager.c"
	{
		pa_card_port_info** port_collection = NULL;
		gint port_collection_length1 = 0;
		gint _port_collection_size_ = 0;
		gint port_it = 0;
#line 581 "../src/PulseAudioManager.vala"
		port_collection = _tmp18_;
#line 581 "../src/PulseAudioManager.vala"
		port_collection_length1 = _tmp18__length1;
#line 581 "../src/PulseAudioManager.vala"
		for (port_it = 0; port_it < _tmp18__length1; port_it = port_it + 1) {
#line 5133 "PulseAudioManager.c"
			pa_card_port_info* port = NULL;
#line 581 "../src/PulseAudioManager.vala"
			port = port_collection[port_it];
#line 5137 "PulseAudioManager.c"
			{
				gboolean is_input = FALSE;
				pa_card_port_info* _tmp19_;
				pa_direction_t _tmp20_;
				const gchar* _tmp21_ = NULL;
				pa_card_port_info* _tmp22_;
				const gchar* _tmp23_;
				pa_card_port_info* _tmp24_;
				const gchar* _tmp25_;
				GeeHashMap* _tmp26_ = NULL;
				GeeHashMap* devices = NULL;
				GeeHashMap* _tmp29_;
				SoundDevice* device = NULL;
				gchar* id = NULL;
				pa_card_port_info* _tmp30_;
				pa_card_info _tmp31_;
				gchar* _tmp32_;
				gboolean is_new = FALSE;
				GeeHashMap* _tmp33_;
				const gchar* _tmp34_;
				SoundDevice* _tmp44_;
				const gchar* _tmp45_;
				SoundDevice* _tmp46_;
				SoundDevice* _tmp47_;
				const gchar* _tmp48_;
				gchar* card_description = NULL;
				pa_proplist* _tmp49_;
				const gchar* _tmp50_;
				gchar* _tmp51_;
				SoundDevice* _tmp52_;
				pa_card_port_info* _tmp53_;
				const gchar* _tmp54_;
				const gchar* _tmp55_;
				const gchar* _tmp56_;
				const gchar* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				SoundDevice* _tmp60_;
				pa_card_port_info* _tmp61_;
				pa_proplist* _tmp62_;
				const gchar* _tmp63_;
				pa_card_port_info* _tmp64_;
				pa_proplist* _tmp65_;
				const gchar* _tmp66_;
				SoundDevice* _tmp67_;
				pa_card_port_info* _tmp68_;
				GeeArrayList* _tmp69_;
				GeeArrayList* _tmp70_;
#line 582 "../src/PulseAudioManager.vala"
				_tmp19_ = port;
#line 582 "../src/PulseAudioManager.vala"
				_tmp20_ = (*_tmp19_).direction;
#line 582 "../src/PulseAudioManager.vala"
				is_input = (_tmp20_ & PA_DIRECTION_INPUT) == PA_DIRECTION_INPUT;
#line 583 "../src/PulseAudioManager.vala"
				if (is_input) {
#line 583 "../src/PulseAudioManager.vala"
					_tmp21_ = "input";
#line 5196 "PulseAudioManager.c"
				} else {
#line 583 "../src/PulseAudioManager.vala"
					_tmp21_ = "output";
#line 5200 "PulseAudioManager.c"
				}
#line 583 "../src/PulseAudioManager.vala"
				_tmp22_ = port;
#line 583 "../src/PulseAudioManager.vala"
				_tmp23_ = (*_tmp22_).description;
#line 583 "../src/PulseAudioManager.vala"
				_tmp24_ = port;
#line 583 "../src/PulseAudioManager.vala"
				_tmp25_ = (*_tmp24_).name;
#line 583 "../src/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:583: \t\t%s port: %s (%s)", _tmp21_, _tmp23_, _tmp25_);
#line 584 "../src/PulseAudioManager.vala"
				if (is_input) {
#line 5214 "PulseAudioManager.c"
					GeeHashMap* _tmp27_;
#line 584 "../src/PulseAudioManager.vala"
					_tmp27_ = self->priv->input_devices;
#line 584 "../src/PulseAudioManager.vala"
					_tmp26_ = _tmp27_;
#line 5220 "PulseAudioManager.c"
				} else {
					GeeHashMap* _tmp28_;
#line 584 "../src/PulseAudioManager.vala"
					_tmp28_ = self->priv->output_devices;
#line 584 "../src/PulseAudioManager.vala"
					_tmp26_ = _tmp28_;
#line 5227 "PulseAudioManager.c"
				}
#line 584 "../src/PulseAudioManager.vala"
				_tmp29_ = _g_object_ref0 (_tmp26_);
#line 584 "../src/PulseAudioManager.vala"
				devices = _tmp29_;
#line 585 "../src/PulseAudioManager.vala"
				device = NULL;
#line 586 "../src/PulseAudioManager.vala"
				_tmp30_ = port;
#line 586 "../src/PulseAudioManager.vala"
				_tmp31_ = *card;
#line 586 "../src/PulseAudioManager.vala"
				_tmp32_ = sound_pulse_audio_manager_get_device_id (&_tmp31_, _tmp30_);
#line 586 "../src/PulseAudioManager.vala"
				id = _tmp32_;
#line 587 "../src/PulseAudioManager.vala"
				_tmp33_ = devices;
#line 587 "../src/PulseAudioManager.vala"
				_tmp34_ = id;
#line 587 "../src/PulseAudioManager.vala"
				is_new = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp33_, _tmp34_);
#line 588 "../src/PulseAudioManager.vala"
				if (is_new) {
#line 5251 "PulseAudioManager.c"
					const gchar* _tmp35_;
					const gchar* _tmp36_;
					pa_card_port_info* _tmp37_;
					const gchar* _tmp38_;
					SoundDevice* _tmp39_;
#line 589 "../src/PulseAudioManager.vala"
					_tmp35_ = id;
#line 589 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:589: \t\t\tnew device: %s", _tmp35_);
#line 590 "../src/PulseAudioManager.vala"
					_tmp36_ = id;
#line 590 "../src/PulseAudioManager.vala"
					_tmp37_ = port;
#line 590 "../src/PulseAudioManager.vala"
					_tmp38_ = (*_tmp37_).name;
#line 590 "../src/PulseAudioManager.vala"
					_tmp39_ = sound_device_new (_tmp36_, (*card).index, _tmp38_);
#line 590 "../src/PulseAudioManager.vala"
					_g_object_unref0 (device);
#line 590 "../src/PulseAudioManager.vala"
					device = _tmp39_;
#line 5273 "PulseAudioManager.c"
				} else {
					const gchar* _tmp40_;
					GeeHashMap* _tmp41_;
					const gchar* _tmp42_;
					gpointer _tmp43_;
#line 592 "../src/PulseAudioManager.vala"
					_tmp40_ = id;
#line 592 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:592: \t\t\tupdating device: %s", _tmp40_);
#line 593 "../src/PulseAudioManager.vala"
					_tmp41_ = devices;
#line 593 "../src/PulseAudioManager.vala"
					_tmp42_ = id;
#line 593 "../src/PulseAudioManager.vala"
					_tmp43_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp41_, _tmp42_);
#line 593 "../src/PulseAudioManager.vala"
					_g_object_unref0 (device);
#line 593 "../src/PulseAudioManager.vala"
					device = (SoundDevice*) _tmp43_;
#line 5293 "PulseAudioManager.c"
				}
#line 596 "../src/PulseAudioManager.vala"
				_tmp44_ = device;
#line 596 "../src/PulseAudioManager.vala"
				_tmp45_ = card_active_profile_name;
#line 596 "../src/PulseAudioManager.vala"
				sound_device_set_card_active_profile_name (_tmp44_, _tmp45_);
#line 597 "../src/PulseAudioManager.vala"
				_tmp46_ = device;
#line 597 "../src/PulseAudioManager.vala"
				sound_device_set_input (_tmp46_, is_input);
#line 598 "../src/PulseAudioManager.vala"
				_tmp47_ = device;
#line 598 "../src/PulseAudioManager.vala"
				_tmp48_ = (*card).name;
#line 598 "../src/PulseAudioManager.vala"
				sound_device_set_card_name (_tmp47_, _tmp48_);
#line 599 "../src/PulseAudioManager.vala"
				_tmp49_ = (*card).proplist;
#line 599 "../src/PulseAudioManager.vala"
				_tmp50_ = pa_proplist_gets (_tmp49_, PA_PROP_DEVICE_DESCRIPTION);
#line 599 "../src/PulseAudioManager.vala"
				_tmp51_ = g_strdup (_tmp50_);
#line 599 "../src/PulseAudioManager.vala"
				card_description = _tmp51_;
#line 600 "../src/PulseAudioManager.vala"
				_tmp52_ = device;
#line 600 "../src/PulseAudioManager.vala"
				_tmp53_ = port;
#line 600 "../src/PulseAudioManager.vala"
				_tmp54_ = (*_tmp53_).description;
#line 600 "../src/PulseAudioManager.vala"
				_tmp55_ = string_to_string (_tmp54_);
#line 600 "../src/PulseAudioManager.vala"
				_tmp56_ = card_description;
#line 600 "../src/PulseAudioManager.vala"
				_tmp57_ = string_to_string (_tmp56_);
#line 600 "../src/PulseAudioManager.vala"
				_tmp58_ = g_strconcat (_tmp55_, " - ", _tmp57_, NULL);
#line 600 "../src/PulseAudioManager.vala"
				_tmp59_ = _tmp58_;
#line 600 "../src/PulseAudioManager.vala"
				sound_device_set_display_name (_tmp52_, _tmp59_);
#line 600 "../src/PulseAudioManager.vala"
				_g_free0 (_tmp59_);
#line 601 "../src/PulseAudioManager.vala"
				_tmp60_ = device;
#line 601 "../src/PulseAudioManager.vala"
				_tmp61_ = port;
#line 601 "../src/PulseAudioManager.vala"
				_tmp62_ = (*_tmp61_).proplist;
#line 601 "../src/PulseAudioManager.vala"
				_tmp63_ = pa_proplist_gets (_tmp62_, PA_PROP_DEVICE_FORM_FACTOR);
#line 601 "../src/PulseAudioManager.vala"
				sound_device_set_form_factor (_tmp60_, _tmp63_);
#line 602 "../src/PulseAudioManager.vala"
				_tmp64_ = port;
#line 602 "../src/PulseAudioManager.vala"
				_tmp65_ = (*_tmp64_).proplist;
#line 602 "../src/PulseAudioManager.vala"
				_tmp66_ = pa_proplist_gets (_tmp65_, PA_PROP_MEDIA_ICON_NAME);
#line 602 "../src/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:602: \t\t\tport icon name: %s", _tmp66_);
#line 603 "../src/PulseAudioManager.vala"
				_tmp67_ = device;
#line 603 "../src/PulseAudioManager.vala"
				_tmp68_ = port;
#line 603 "../src/PulseAudioManager.vala"
				_tmp69_ = sound_pulse_audio_manager_get_relevant_card_port_profiles (self, _tmp68_);
#line 603 "../src/PulseAudioManager.vala"
				_tmp70_ = _tmp69_;
#line 603 "../src/PulseAudioManager.vala"
				sound_device_set_profiles (_tmp67_, _tmp70_);
#line 603 "../src/PulseAudioManager.vala"
				_g_object_unref0 (_tmp70_);
#line 604 "../src/PulseAudioManager.vala"
				if (sound_pulse_audio_manager_DEBUG_ENABLED) {
#line 5371 "PulseAudioManager.c"
					{
						GeeArrayList* _profile_list = NULL;
						SoundDevice* _tmp71_;
						GeeArrayList* _tmp72_;
						GeeArrayList* _tmp73_;
						GeeArrayList* _tmp74_;
						gint _profile_size = 0;
						GeeArrayList* _tmp75_;
						gint _tmp76_;
						gint _tmp77_;
						gint _profile_index = 0;
#line 605 "../src/PulseAudioManager.vala"
						_tmp71_ = device;
#line 605 "../src/PulseAudioManager.vala"
						_tmp72_ = sound_device_get_profiles (_tmp71_);
#line 605 "../src/PulseAudioManager.vala"
						_tmp73_ = _tmp72_;
#line 605 "../src/PulseAudioManager.vala"
						_tmp74_ = _g_object_ref0 (_tmp73_);
#line 605 "../src/PulseAudioManager.vala"
						_profile_list = _tmp74_;
#line 605 "../src/PulseAudioManager.vala"
						_tmp75_ = _profile_list;
#line 605 "../src/PulseAudioManager.vala"
						_tmp76_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp75_);
#line 605 "../src/PulseAudioManager.vala"
						_tmp77_ = _tmp76_;
#line 605 "../src/PulseAudioManager.vala"
						_profile_size = _tmp77_;
#line 605 "../src/PulseAudioManager.vala"
						_profile_index = -1;
#line 605 "../src/PulseAudioManager.vala"
						while (TRUE) {
#line 5405 "PulseAudioManager.c"
							gchar* profile = NULL;
							GeeArrayList* _tmp78_;
							gpointer _tmp79_;
							const gchar* _tmp80_;
#line 605 "../src/PulseAudioManager.vala"
							_profile_index = _profile_index + 1;
#line 605 "../src/PulseAudioManager.vala"
							if (!(_profile_index < _profile_size)) {
#line 605 "../src/PulseAudioManager.vala"
								break;
#line 5416 "PulseAudioManager.c"
							}
#line 605 "../src/PulseAudioManager.vala"
							_tmp78_ = _profile_list;
#line 605 "../src/PulseAudioManager.vala"
							_tmp79_ = gee_abstract_list_get ((GeeAbstractList*) _tmp78_, _profile_index);
#line 605 "../src/PulseAudioManager.vala"
							profile = (gchar*) _tmp79_;
#line 606 "../src/PulseAudioManager.vala"
							_tmp80_ = profile;
#line 606 "../src/PulseAudioManager.vala"
							g_debug ("PulseAudioManager.vala:606: \t\t\tprofile: %s", _tmp80_);
#line 605 "../src/PulseAudioManager.vala"
							_g_free0 (profile);
#line 5430 "PulseAudioManager.c"
						}
#line 605 "../src/PulseAudioManager.vala"
						_g_object_unref0 (_profile_list);
#line 5434 "PulseAudioManager.c"
					}
				}
#line 610 "../src/PulseAudioManager.vala"
				if (is_new) {
#line 5439 "PulseAudioManager.c"
					GeeHashMap* _tmp81_;
					const gchar* _tmp82_;
					SoundDevice* _tmp83_;
					SoundDevice* _tmp84_;
#line 611 "../src/PulseAudioManager.vala"
					_tmp81_ = devices;
#line 611 "../src/PulseAudioManager.vala"
					_tmp82_ = id;
#line 611 "../src/PulseAudioManager.vala"
					_tmp83_ = device;
#line 611 "../src/PulseAudioManager.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp81_, _tmp82_, _tmp83_);
#line 612 "../src/PulseAudioManager.vala"
					_tmp84_ = device;
#line 612 "../src/PulseAudioManager.vala"
					g_signal_emit (self, sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL], 0, _tmp84_);
#line 5456 "PulseAudioManager.c"
				}
#line 581 "../src/PulseAudioManager.vala"
				_g_free0 (card_description);
#line 581 "../src/PulseAudioManager.vala"
				_g_free0 (id);
#line 581 "../src/PulseAudioManager.vala"
				_g_object_unref0 (device);
#line 581 "../src/PulseAudioManager.vala"
				_g_object_unref0 (devices);
#line 5466 "PulseAudioManager.c"
			}
		}
	}
#line 616 "../src/PulseAudioManager.vala"
	_tmp85_ = self->priv->output_devices;
#line 616 "../src/PulseAudioManager.vala"
	_tmp86_ = relevant_ports;
#line 616 "../src/PulseAudioManager.vala"
	_tmp86__length1 = relevant_ports_length1;
#line 616 "../src/PulseAudioManager.vala"
	_tmp87_ = *card;
#line 616 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_cleanup_devices (self, _tmp85_, &_tmp87_, _tmp86_, (gint) _tmp86__length1);
#line 617 "../src/PulseAudioManager.vala"
	_tmp88_ = self->priv->input_devices;
#line 617 "../src/PulseAudioManager.vala"
	_tmp89_ = relevant_ports;
#line 617 "../src/PulseAudioManager.vala"
	_tmp89__length1 = relevant_ports_length1;
#line 617 "../src/PulseAudioManager.vala"
	_tmp90_ = *card;
#line 617 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_cleanup_devices (self, _tmp88_, &_tmp90_, _tmp89_, (gint) _tmp89__length1);
#line 556 "../src/PulseAudioManager.vala"
	relevant_ports = (g_free (relevant_ports), NULL);
#line 556 "../src/PulseAudioManager.vala"
	_g_free0 (card_active_profile_name);
#line 5494 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_cleanup_devices (SoundPulseAudioManager* self,
                                           GeeHashMap* devices,
                                           pa_card_info* card,
                                           pa_card_port_info** relevant_ports,
                                           gint relevant_ports_length1)
{
	GeeMapIterator* iter = NULL;
	GeeMapIterator* _tmp0_;
#line 621 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 621 "../src/PulseAudioManager.vala"
	g_return_if_fail (devices != NULL);
#line 621 "../src/PulseAudioManager.vala"
	g_return_if_fail (card != NULL);
#line 622 "../src/PulseAudioManager.vala"
	_tmp0_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) devices);
#line 622 "../src/PulseAudioManager.vala"
	iter = _tmp0_;
#line 623 "../src/PulseAudioManager.vala"
	while (TRUE) {
#line 5518 "PulseAudioManager.c"
		GeeMapIterator* _tmp1_;
		SoundDevice* device = NULL;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		SoundDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
		pa_card_info _tmp7_;
		gboolean found = FALSE;
#line 623 "../src/PulseAudioManager.vala"
		_tmp1_ = iter;
#line 623 "../src/PulseAudioManager.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 623 "../src/PulseAudioManager.vala"
			break;
#line 5534 "PulseAudioManager.c"
		}
#line 624 "../src/PulseAudioManager.vala"
		_tmp2_ = iter;
#line 624 "../src/PulseAudioManager.vala"
		_tmp3_ = gee_map_iterator_get_value (_tmp2_);
#line 624 "../src/PulseAudioManager.vala"
		device = (SoundDevice*) _tmp3_;
#line 625 "../src/PulseAudioManager.vala"
		_tmp4_ = device;
#line 625 "../src/PulseAudioManager.vala"
		_tmp5_ = sound_device_get_card_index (_tmp4_);
#line 625 "../src/PulseAudioManager.vala"
		_tmp6_ = _tmp5_;
#line 625 "../src/PulseAudioManager.vala"
		_tmp7_ = *card;
#line 625 "../src/PulseAudioManager.vala"
		if (_tmp6_ != _tmp7_.index) {
#line 626 "../src/PulseAudioManager.vala"
			_g_object_unref0 (device);
#line 626 "../src/PulseAudioManager.vala"
			continue;
#line 5556 "PulseAudioManager.c"
		}
#line 630 "../src/PulseAudioManager.vala"
		found = FALSE;
#line 5560 "PulseAudioManager.c"
		{
			pa_card_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
#line 631 "../src/PulseAudioManager.vala"
			port_collection = relevant_ports;
#line 631 "../src/PulseAudioManager.vala"
			port_collection_length1 = relevant_ports_length1;
#line 631 "../src/PulseAudioManager.vala"
			for (port_it = 0; port_it < relevant_ports_length1; port_it = port_it + 1) {
#line 5572 "PulseAudioManager.c"
				pa_card_port_info* port = NULL;
#line 631 "../src/PulseAudioManager.vala"
				port = port_collection[port_it];
#line 5576 "PulseAudioManager.c"
				{
					SoundDevice* _tmp8_;
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					pa_card_info _tmp11_;
					pa_card_port_info* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gboolean _tmp15_;
#line 632 "../src/PulseAudioManager.vala"
					_tmp8_ = device;
#line 632 "../src/PulseAudioManager.vala"
					_tmp9_ = sound_device_get_id (_tmp8_);
#line 632 "../src/PulseAudioManager.vala"
					_tmp10_ = _tmp9_;
#line 632 "../src/PulseAudioManager.vala"
					_tmp11_ = *card;
#line 632 "../src/PulseAudioManager.vala"
					_tmp12_ = port;
#line 632 "../src/PulseAudioManager.vala"
					_tmp13_ = sound_pulse_audio_manager_get_device_id (&_tmp11_, _tmp12_);
#line 632 "../src/PulseAudioManager.vala"
					_tmp14_ = _tmp13_;
#line 632 "../src/PulseAudioManager.vala"
					_tmp15_ = g_strcmp0 (_tmp10_, _tmp14_) == 0;
#line 632 "../src/PulseAudioManager.vala"
					_g_free0 (_tmp14_);
#line 632 "../src/PulseAudioManager.vala"
					if (_tmp15_) {
#line 633 "../src/PulseAudioManager.vala"
						found = TRUE;
#line 634 "../src/PulseAudioManager.vala"
						break;
#line 5610 "PulseAudioManager.c"
					}
				}
			}
		}
#line 638 "../src/PulseAudioManager.vala"
		if (!found) {
#line 5617 "PulseAudioManager.c"
			SoundDevice* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			SoundDevice* _tmp19_;
			GeeMapIterator* _tmp20_;
#line 639 "../src/PulseAudioManager.vala"
			_tmp16_ = device;
#line 639 "../src/PulseAudioManager.vala"
			_tmp17_ = sound_device_get_id (_tmp16_);
#line 639 "../src/PulseAudioManager.vala"
			_tmp18_ = _tmp17_;
#line 639 "../src/PulseAudioManager.vala"
			g_debug ("PulseAudioManager.vala:639: \t\tremoving device: %s", _tmp18_);
#line 640 "../src/PulseAudioManager.vala"
			_tmp19_ = device;
#line 640 "../src/PulseAudioManager.vala"
			g_signal_emit_by_name (_tmp19_, "removed");
#line 641 "../src/PulseAudioManager.vala"
			_tmp20_ = iter;
#line 641 "../src/PulseAudioManager.vala"
			gee_map_iterator_unset (_tmp20_);
#line 5639 "PulseAudioManager.c"
		}
#line 623 "../src/PulseAudioManager.vala"
		_g_object_unref0 (device);
#line 5643 "PulseAudioManager.c"
	}
#line 621 "../src/PulseAudioManager.vala"
	_g_object_unref0 (iter);
#line 5647 "PulseAudioManager.c"
}

static gchar*
sound_pulse_audio_manager_get_device_id (pa_card_info* card,
                                         pa_card_port_info* port)
{
	gchar* result = NULL;
	pa_card_info _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
#line 646 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (card != NULL, NULL);
#line 647 "../src/PulseAudioManager.vala"
	_tmp0_ = *card;
#line 647 "../src/PulseAudioManager.vala"
	_tmp1_ = _tmp0_.name;
#line 647 "../src/PulseAudioManager.vala"
	_tmp2_ = string_to_string (_tmp1_);
#line 647 "../src/PulseAudioManager.vala"
	_tmp3_ = (*port).name;
#line 647 "../src/PulseAudioManager.vala"
	_tmp4_ = string_to_string (_tmp3_);
#line 647 "../src/PulseAudioManager.vala"
	_tmp5_ = g_strconcat (_tmp2_, ":", _tmp4_, NULL);
#line 647 "../src/PulseAudioManager.vala"
	result = _tmp5_;
#line 647 "../src/PulseAudioManager.vala"
	return result;
#line 5679 "PulseAudioManager.c"
}

static pa_card_profile_info2**
_vala_array_dup1 (pa_card_profile_info2** self,
                  int length)
{
#line 651 "../src/PulseAudioManager.vala"
	return g_memdup (self, length * sizeof (pa_card_profile_info2*));
#line 5688 "PulseAudioManager.c"
}

static gint
__lambda7_ (SoundPulseAudioManager* self,
            pa_card_profile_info2* a,
            pa_card_profile_info2* b)
{
	gint result = 0;
#line 655 "../src/PulseAudioManager.vala"
	if ((*a).priority > (*b).priority) {
#line 656 "../src/PulseAudioManager.vala"
		result = -1;
#line 656 "../src/PulseAudioManager.vala"
		return result;
#line 5703 "PulseAudioManager.c"
	}
#line 659 "../src/PulseAudioManager.vala"
	if ((*a).priority < (*b).priority) {
#line 660 "../src/PulseAudioManager.vala"
		result = 1;
#line 660 "../src/PulseAudioManager.vala"
		return result;
#line 5711 "PulseAudioManager.c"
	}
#line 663 "../src/PulseAudioManager.vala"
	result = 0;
#line 663 "../src/PulseAudioManager.vala"
	return result;
#line 5717 "PulseAudioManager.c"
}

static gint
___lambda7__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda7_ ((SoundPulseAudioManager*) self, a, b);
#line 654 "../src/PulseAudioManager.vala"
	return result;
#line 5729 "PulseAudioManager.c"
}

static GeeArrayList*
sound_pulse_audio_manager_get_relevant_card_port_profiles (SoundPulseAudioManager* self,
                                                           pa_card_port_info* port)
{
	GeeArrayList* result = NULL;
	GeeArrayList* profiles_list = NULL;
	pa_card_profile_info2** _tmp0_;
	gint _tmp0__length1;
	pa_card_profile_info2** _tmp1_;
	gint _tmp1__length1;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* profiles = NULL;
	GeeArrayList* _tmp4_;
#line 650 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 651 "../src/PulseAudioManager.vala"
	_tmp0_ = (*port).profiles2;
#line 651 "../src/PulseAudioManager.vala"
	_tmp0__length1 = (*port).n_profiles;
#line 651 "../src/PulseAudioManager.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
#line 651 "../src/PulseAudioManager.vala"
	_tmp1__length1 = _tmp0__length1;
#line 651 "../src/PulseAudioManager.vala"
	_tmp2_ = gee_array_list_new_wrap (G_TYPE_POINTER, NULL, NULL, _tmp1_, _tmp1__length1, NULL, NULL, NULL);
#line 651 "../src/PulseAudioManager.vala"
	profiles_list = _tmp2_;
#line 654 "../src/PulseAudioManager.vala"
	_tmp3_ = profiles_list;
#line 654 "../src/PulseAudioManager.vala"
	gee_list_sort ((GeeList*) _tmp3_, ___lambda7__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 667 "../src/PulseAudioManager.vala"
	_tmp4_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 667 "../src/PulseAudioManager.vala"
	profiles = _tmp4_;
#line 5768 "PulseAudioManager.c"
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		gint _item_size = 0;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _item_index = 0;
#line 668 "../src/PulseAudioManager.vala"
		_tmp5_ = profiles_list;
#line 668 "../src/PulseAudioManager.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 668 "../src/PulseAudioManager.vala"
		_item_list = _tmp6_;
#line 668 "../src/PulseAudioManager.vala"
		_tmp7_ = _item_list;
#line 668 "../src/PulseAudioManager.vala"
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 668 "../src/PulseAudioManager.vala"
		_tmp9_ = _tmp8_;
#line 668 "../src/PulseAudioManager.vala"
		_item_size = _tmp9_;
#line 668 "../src/PulseAudioManager.vala"
		_item_index = -1;
#line 668 "../src/PulseAudioManager.vala"
		while (TRUE) {
#line 5796 "PulseAudioManager.c"
			pa_card_profile_info2* item = NULL;
			GeeArrayList* _tmp10_;
			gpointer _tmp11_;
			GeeArrayList* _tmp12_;
			pa_card_profile_info2* _tmp13_;
			const gchar* _tmp14_;
#line 668 "../src/PulseAudioManager.vala"
			_item_index = _item_index + 1;
#line 668 "../src/PulseAudioManager.vala"
			if (!(_item_index < _item_size)) {
#line 668 "../src/PulseAudioManager.vala"
				break;
#line 5809 "PulseAudioManager.c"
			}
#line 668 "../src/PulseAudioManager.vala"
			_tmp10_ = _item_list;
#line 668 "../src/PulseAudioManager.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _item_index);
#line 668 "../src/PulseAudioManager.vala"
			item = _tmp11_;
#line 669 "../src/PulseAudioManager.vala"
			_tmp12_ = profiles;
#line 669 "../src/PulseAudioManager.vala"
			_tmp13_ = item;
#line 669 "../src/PulseAudioManager.vala"
			_tmp14_ = (*_tmp13_).name;
#line 669 "../src/PulseAudioManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp14_);
#line 5825 "PulseAudioManager.c"
		}
#line 668 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_item_list);
#line 5829 "PulseAudioManager.c"
	}
#line 672 "../src/PulseAudioManager.vala"
	result = profiles;
#line 672 "../src/PulseAudioManager.vala"
	_g_object_unref0 (profiles_list);
#line 672 "../src/PulseAudioManager.vala"
	return result;
#line 5837 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_remove_devices_by_card (SoundPulseAudioManager* self,
                                                  GeeHashMap* devices,
                                                  guint32 card_index)
{
	GeeMapIterator* iter = NULL;
	GeeMapIterator* _tmp0_;
#line 675 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 675 "../src/PulseAudioManager.vala"
	g_return_if_fail (devices != NULL);
#line 676 "../src/PulseAudioManager.vala"
	_tmp0_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) devices);
#line 676 "../src/PulseAudioManager.vala"
	iter = _tmp0_;
#line 677 "../src/PulseAudioManager.vala"
	while (TRUE) {
#line 5857 "PulseAudioManager.c"
		GeeMapIterator* _tmp1_;
		SoundDevice* device = NULL;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		SoundDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
#line 677 "../src/PulseAudioManager.vala"
		_tmp1_ = iter;
#line 677 "../src/PulseAudioManager.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 677 "../src/PulseAudioManager.vala"
			break;
#line 5871 "PulseAudioManager.c"
		}
#line 678 "../src/PulseAudioManager.vala"
		_tmp2_ = iter;
#line 678 "../src/PulseAudioManager.vala"
		_tmp3_ = gee_map_iterator_get_value (_tmp2_);
#line 678 "../src/PulseAudioManager.vala"
		device = (SoundDevice*) _tmp3_;
#line 679 "../src/PulseAudioManager.vala"
		_tmp4_ = device;
#line 679 "../src/PulseAudioManager.vala"
		_tmp5_ = sound_device_get_card_index (_tmp4_);
#line 679 "../src/PulseAudioManager.vala"
		_tmp6_ = _tmp5_;
#line 679 "../src/PulseAudioManager.vala"
		if (_tmp6_ == card_index) {
#line 5887 "PulseAudioManager.c"
			SoundDevice* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			SoundDevice* _tmp10_;
			GeeMapIterator* _tmp11_;
#line 680 "../src/PulseAudioManager.vala"
			_tmp7_ = device;
#line 680 "../src/PulseAudioManager.vala"
			_tmp8_ = sound_device_get_id (_tmp7_);
#line 680 "../src/PulseAudioManager.vala"
			_tmp9_ = _tmp8_;
#line 680 "../src/PulseAudioManager.vala"
			g_debug ("PulseAudioManager.vala:680: removing device: %s", _tmp9_);
#line 681 "../src/PulseAudioManager.vala"
			_tmp10_ = device;
#line 681 "../src/PulseAudioManager.vala"
			g_signal_emit_by_name (_tmp10_, "removed");
#line 682 "../src/PulseAudioManager.vala"
			_tmp11_ = iter;
#line 682 "../src/PulseAudioManager.vala"
			gee_map_iterator_unset (_tmp11_);
#line 5909 "PulseAudioManager.c"
		}
#line 677 "../src/PulseAudioManager.vala"
		_g_object_unref0 (device);
#line 5913 "PulseAudioManager.c"
	}
#line 675 "../src/PulseAudioManager.vala"
	_g_object_unref0 (iter);
#line 5917 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                         pa_ext_stream_restore_info* info,
                                                                                                         gint eol,
                                                                                                         gpointer self)
{
#line 701 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_ext_stream_restore_read_sink_callback ((SoundPulseAudioManager*) self, c, info, eol);
#line 5928 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                           pa_ext_stream_restore_info* info,
                                                                                                           gint eol,
                                                                                                           gpointer self)
{
#line 712 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_ext_stream_restore_read_source_callback ((SoundPulseAudioManager*) self, c, info, eol);
#line 5939 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                pa_context* context,
                                                pa_server_info* server)
{
	const gchar* _tmp0_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp12_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	pa_operation* _tmp24_;
	pa_operation* _tmp25_;
	pa_operation* _tmp26_;
	pa_operation* _tmp27_;
	pa_operation* _tmp28_;
	pa_operation* _tmp29_;
#line 687 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 687 "../src/PulseAudioManager.vala"
	g_return_if_fail (context != NULL);
#line 688 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:688: server info update");
#line 689 "../src/PulseAudioManager.vala"
	if (server == NULL) {
#line 690 "../src/PulseAudioManager.vala"
		return;
#line 5969 "PulseAudioManager.c"
	}
#line 693 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->default_sink_name;
#line 693 "../src/PulseAudioManager.vala"
	if (_tmp0_ == NULL) {
#line 5975 "PulseAudioManager.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
#line 694 "../src/PulseAudioManager.vala"
		_tmp1_ = (*server).default_sink_name;
#line 694 "../src/PulseAudioManager.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 694 "../src/PulseAudioManager.vala"
		_g_free0 (self->priv->default_sink_name);
#line 694 "../src/PulseAudioManager.vala"
		self->priv->default_sink_name = _tmp2_;
#line 695 "../src/PulseAudioManager.vala"
		_tmp3_ = self->priv->default_sink_name;
#line 695 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:695: \tdefault_sink_name: %s", _tmp3_);
#line 5991 "PulseAudioManager.c"
	}
#line 698 "../src/PulseAudioManager.vala"
	_tmp4_ = self->priv->default_sink_name;
#line 698 "../src/PulseAudioManager.vala"
	_tmp5_ = (*server).default_sink_name;
#line 698 "../src/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp4_, _tmp5_) != 0) {
#line 5999 "PulseAudioManager.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		pa_operation* _tmp10_;
		pa_operation* _tmp11_;
#line 699 "../src/PulseAudioManager.vala"
		_tmp6_ = self->priv->default_sink_name;
#line 699 "../src/PulseAudioManager.vala"
		_tmp7_ = (*server).default_sink_name;
#line 699 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:699: \tdefault_sink_name: %s > %s", _tmp6_, _tmp7_);
#line 700 "../src/PulseAudioManager.vala"
		_tmp8_ = (*server).default_sink_name;
#line 700 "../src/PulseAudioManager.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 700 "../src/PulseAudioManager.vala"
		_g_free0 (self->priv->default_sink_name);
#line 700 "../src/PulseAudioManager.vala"
		self->priv->default_sink_name = _tmp9_;
#line 701 "../src/PulseAudioManager.vala"
		_tmp10_ = pa_ext_stream_restore_read (context, _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb, self);
#line 701 "../src/PulseAudioManager.vala"
		_tmp11_ = _tmp10_;
#line 701 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp11_);
#line 6026 "PulseAudioManager.c"
	}
#line 704 "../src/PulseAudioManager.vala"
	_tmp12_ = self->priv->default_source_name;
#line 704 "../src/PulseAudioManager.vala"
	if (_tmp12_ == NULL) {
#line 6032 "PulseAudioManager.c"
		const gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
#line 705 "../src/PulseAudioManager.vala"
		_tmp13_ = (*server).default_source_name;
#line 705 "../src/PulseAudioManager.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 705 "../src/PulseAudioManager.vala"
		_g_free0 (self->priv->default_source_name);
#line 705 "../src/PulseAudioManager.vala"
		self->priv->default_source_name = _tmp14_;
#line 706 "../src/PulseAudioManager.vala"
		_tmp15_ = self->priv->default_source_name;
#line 706 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:706: \tdefault_source_name: %s", _tmp15_);
#line 6048 "PulseAudioManager.c"
	}
#line 709 "../src/PulseAudioManager.vala"
	_tmp16_ = self->priv->default_source_name;
#line 709 "../src/PulseAudioManager.vala"
	_tmp17_ = (*server).default_source_name;
#line 709 "../src/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp16_, _tmp17_) != 0) {
#line 6056 "PulseAudioManager.c"
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		pa_operation* _tmp22_;
		pa_operation* _tmp23_;
#line 710 "../src/PulseAudioManager.vala"
		_tmp18_ = self->priv->default_source_name;
#line 710 "../src/PulseAudioManager.vala"
		_tmp19_ = (*server).default_source_name;
#line 710 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:710: \tdefault_source_name: %s > %s", _tmp18_, _tmp19_);
#line 711 "../src/PulseAudioManager.vala"
		_tmp20_ = (*server).default_source_name;
#line 711 "../src/PulseAudioManager.vala"
		_tmp21_ = g_strdup (_tmp20_);
#line 711 "../src/PulseAudioManager.vala"
		_g_free0 (self->priv->default_source_name);
#line 711 "../src/PulseAudioManager.vala"
		self->priv->default_source_name = _tmp21_;
#line 712 "../src/PulseAudioManager.vala"
		_tmp22_ = pa_ext_stream_restore_read (context, _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb, self);
#line 712 "../src/PulseAudioManager.vala"
		_tmp23_ = _tmp22_;
#line 712 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp23_);
#line 6083 "PulseAudioManager.c"
	}
#line 717 "../src/PulseAudioManager.vala"
	_tmp24_ = pa_context_get_card_info_list (context, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
#line 717 "../src/PulseAudioManager.vala"
	_tmp25_ = _tmp24_;
#line 717 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp25_);
#line 718 "../src/PulseAudioManager.vala"
	_tmp26_ = pa_context_get_source_info_list (context, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 718 "../src/PulseAudioManager.vala"
	_tmp27_ = _tmp26_;
#line 718 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp27_);
#line 719 "../src/PulseAudioManager.vala"
	_tmp28_ = pa_context_get_sink_info_list (context, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 719 "../src/PulseAudioManager.vala"
	_tmp29_ = _tmp28_;
#line 719 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp29_);
#line 6103 "PulseAudioManager.c"
}

static void
__lambda6_ (SoundPulseAudioManager* self,
            pa_context* c,
            gint success)
{
#line 738 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 739 "../src/PulseAudioManager.vala"
	if (success != 1) {
#line 740 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:740: Updating source failed");
#line 6117 "PulseAudioManager.c"
	}
}

static void
___lambda6__pa_context_success_cb_t (pa_context* c,
                                     gint success,
                                     gpointer self)
{
#line 738 "../src/PulseAudioManager.vala"
	__lambda6_ ((SoundPulseAudioManager*) self, c, success);
#line 6128 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                 pa_context* c,
                                                                 pa_ext_stream_restore_info* info,
                                                                 gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	pa_channel_map _tmp3_;
	pa_cvolume _tmp4_;
	const gchar* _tmp5_;
	pa_ext_stream_restore_info _tmp6_;
	pa_ext_stream_restore_info* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	gint _tmp8__length1;
	pa_operation* _tmp9_;
	pa_operation* _tmp10_;
#line 726 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 726 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 727 "../src/PulseAudioManager.vala"
	if (eol != 0) {
#line 727 "../src/PulseAudioManager.vala"
		_tmp0_ = TRUE;
#line 6157 "PulseAudioManager.c"
	} else {
		const gchar* _tmp1_;
#line 727 "../src/PulseAudioManager.vala"
		_tmp1_ = (*info).name;
#line 727 "../src/PulseAudioManager.vala"
		_tmp0_ = !g_str_has_prefix (_tmp1_, "sink-input-by");
#line 6164 "PulseAudioManager.c"
	}
#line 727 "../src/PulseAudioManager.vala"
	if (_tmp0_) {
#line 728 "../src/PulseAudioManager.vala"
		return;
#line 6170 "PulseAudioManager.c"
	}
#line 732 "../src/PulseAudioManager.vala"
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
#line 733 "../src/PulseAudioManager.vala"
	_tmp2_ = (*info).name;
#line 733 "../src/PulseAudioManager.vala"
	new_info.name = _tmp2_;
#line 734 "../src/PulseAudioManager.vala"
	_tmp3_ = (*info).channel_map;
#line 734 "../src/PulseAudioManager.vala"
	new_info.channel_map = _tmp3_;
#line 735 "../src/PulseAudioManager.vala"
	_tmp4_ = (*info).volume;
#line 735 "../src/PulseAudioManager.vala"
	new_info.volume = _tmp4_;
#line 736 "../src/PulseAudioManager.vala"
	new_info.mute = (*info).mute;
#line 737 "../src/PulseAudioManager.vala"
	_tmp5_ = self->priv->default_sink_name;
#line 737 "../src/PulseAudioManager.vala"
	new_info.device = _tmp5_;
#line 738 "../src/PulseAudioManager.vala"
	_tmp6_ = new_info;
#line 738 "../src/PulseAudioManager.vala"
	_tmp7_ = g_new0 (pa_ext_stream_restore_info, 1);
#line 738 "../src/PulseAudioManager.vala"
	_tmp7_[0] = _tmp6_;
#line 738 "../src/PulseAudioManager.vala"
	_tmp8_ = _tmp7_;
#line 738 "../src/PulseAudioManager.vala"
	_tmp8__length1 = 1;
#line 738 "../src/PulseAudioManager.vala"
	_tmp9_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp8_, (gint) 1, 1, ___lambda6__pa_context_success_cb_t, self);
#line 738 "../src/PulseAudioManager.vala"
	_tmp10_ = _tmp9_;
#line 738 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp10_);
#line 738 "../src/PulseAudioManager.vala"
	_tmp8_ = (g_free (_tmp8_), NULL);
#line 6210 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                   pa_context* c,
                                                                   pa_ext_stream_restore_info* info,
                                                                   gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	pa_channel_map _tmp3_;
	pa_cvolume _tmp4_;
	const gchar* _tmp5_;
	pa_ext_stream_restore_info _tmp6_;
	pa_ext_stream_restore_info* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	gint _tmp8__length1;
	pa_operation* _tmp9_;
	pa_operation* _tmp10_;
#line 745 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 745 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 746 "../src/PulseAudioManager.vala"
	if (eol != 0) {
#line 746 "../src/PulseAudioManager.vala"
		_tmp0_ = TRUE;
#line 6239 "PulseAudioManager.c"
	} else {
		const gchar* _tmp1_;
#line 746 "../src/PulseAudioManager.vala"
		_tmp1_ = (*info).name;
#line 746 "../src/PulseAudioManager.vala"
		_tmp0_ = !g_str_has_prefix (_tmp1_, "source-output-by");
#line 6246 "PulseAudioManager.c"
	}
#line 746 "../src/PulseAudioManager.vala"
	if (_tmp0_) {
#line 747 "../src/PulseAudioManager.vala"
		return;
#line 6252 "PulseAudioManager.c"
	}
#line 751 "../src/PulseAudioManager.vala"
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
#line 752 "../src/PulseAudioManager.vala"
	_tmp2_ = (*info).name;
#line 752 "../src/PulseAudioManager.vala"
	new_info.name = _tmp2_;
#line 753 "../src/PulseAudioManager.vala"
	_tmp3_ = (*info).channel_map;
#line 753 "../src/PulseAudioManager.vala"
	new_info.channel_map = _tmp3_;
#line 754 "../src/PulseAudioManager.vala"
	_tmp4_ = (*info).volume;
#line 754 "../src/PulseAudioManager.vala"
	new_info.volume = _tmp4_;
#line 755 "../src/PulseAudioManager.vala"
	new_info.mute = (*info).mute;
#line 756 "../src/PulseAudioManager.vala"
	_tmp5_ = self->priv->default_source_name;
#line 756 "../src/PulseAudioManager.vala"
	new_info.device = _tmp5_;
#line 757 "../src/PulseAudioManager.vala"
	_tmp6_ = new_info;
#line 757 "../src/PulseAudioManager.vala"
	_tmp7_ = g_new0 (pa_ext_stream_restore_info, 1);
#line 757 "../src/PulseAudioManager.vala"
	_tmp7_[0] = _tmp6_;
#line 757 "../src/PulseAudioManager.vala"
	_tmp8_ = _tmp7_;
#line 757 "../src/PulseAudioManager.vala"
	_tmp8__length1 = 1;
#line 757 "../src/PulseAudioManager.vala"
	_tmp9_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp8_, (gint) 1, 1, NULL, NULL);
#line 757 "../src/PulseAudioManager.vala"
	_tmp10_ = _tmp9_;
#line 757 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp10_);
#line 757 "../src/PulseAudioManager.vala"
	_tmp8_ = (g_free (_tmp8_), NULL);
#line 6292 "PulseAudioManager.c"
}

static gdouble
sound_pulse_audio_manager_volume_to_double (pa_volume_t vol)
{
	gdouble result = 0.0;
	gdouble tmp = 0.0;
#line 765 "../src/PulseAudioManager.vala"
	tmp = (gdouble) (vol - PA_VOLUME_MUTED);
#line 766 "../src/PulseAudioManager.vala"
	result = (100 * tmp) / ((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED));
#line 766 "../src/PulseAudioManager.vala"
	return result;
#line 6306 "PulseAudioManager.c"
}

static pa_volume_t
sound_pulse_audio_manager_double_to_volume (gdouble vol)
{
	pa_volume_t result = 0U;
	gdouble tmp = 0.0;
#line 770 "../src/PulseAudioManager.vala"
	tmp = (((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED)) * vol) / 100;
#line 771 "../src/PulseAudioManager.vala"
	result = ((pa_volume_t) tmp) + PA_VOLUME_MUTED;
#line 771 "../src/PulseAudioManager.vala"
	return result;
#line 6320 "PulseAudioManager.c"
}

pa_context*
sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self)
{
	pa_context* result;
	pa_context* _tmp0_;
#line 43 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->_context;
#line 43 "../src/PulseAudioManager.vala"
	result = _tmp0_;
#line 43 "../src/PulseAudioManager.vala"
	return result;
#line 6336 "PulseAudioManager.c"
}

static gpointer
_pa_context_ref0 (gpointer self)
{
#line 43 "../src/PulseAudioManager.vala"
	return self ? pa_context_ref (self) : NULL;
#line 6344 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self,
                                       pa_context* value)
{
#line 43 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_get_context (self) != value) {
#line 6355 "PulseAudioManager.c"
		pa_context* _tmp0_;
#line 43 "../src/PulseAudioManager.vala"
		_tmp0_ = _pa_context_ref0 (value);
#line 43 "../src/PulseAudioManager.vala"
		_pa_context_unref0 (self->priv->_context);
#line 43 "../src/PulseAudioManager.vala"
		self->priv->_context = _tmp0_;
#line 43 "../src/PulseAudioManager.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY]);
#line 6365 "PulseAudioManager.c"
	}
}

SoundDevice*
sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
#line 49 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->_default_output;
#line 49 "../src/PulseAudioManager.vala"
	result = _tmp0_;
#line 49 "../src/PulseAudioManager.vala"
	return result;
#line 6382 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                              SoundDevice* value)
{
#line 49 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_get_default_output (self) != value) {
#line 6393 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
#line 49 "../src/PulseAudioManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 49 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self->priv->_default_output);
#line 49 "../src/PulseAudioManager.vala"
		self->priv->_default_output = _tmp0_;
#line 49 "../src/PulseAudioManager.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY]);
#line 6403 "PulseAudioManager.c"
	}
}

SoundDevice*
sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
#line 50 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->_default_input;
#line 50 "../src/PulseAudioManager.vala"
	result = _tmp0_;
#line 50 "../src/PulseAudioManager.vala"
	return result;
#line 6420 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                             SoundDevice* value)
{
#line 50 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_get_default_input (self) != value) {
#line 6431 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
#line 50 "../src/PulseAudioManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 50 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self->priv->_default_input);
#line 50 "../src/PulseAudioManager.vala"
		self->priv->_default_input = _tmp0_;
#line 50 "../src/PulseAudioManager.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY]);
#line 6441 "PulseAudioManager.c"
	}
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             int stack_length,
                             const gchar* needle)
{
	int i;
#line 68 "../src/PulseAudioManager.vala"
	for (i = 0; i < stack_length; i++) {
#line 68 "../src/PulseAudioManager.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 68 "../src/PulseAudioManager.vala"
			return TRUE;
#line 6457 "PulseAudioManager.c"
		}
	}
#line 68 "../src/PulseAudioManager.vala"
	return FALSE;
#line 6462 "PulseAudioManager.c"
}

static GObject *
sound_pulse_audio_manager_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundPulseAudioManager * self;
	pa_glib_mainloop* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	gchar* messagesDebugRaw = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
#line 59 "../src/PulseAudioManager.vala"
	parent_class = G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class);
#line 59 "../src/PulseAudioManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../src/PulseAudioManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 60 "../src/PulseAudioManager.vala"
	_tmp0_ = pa_glib_mainloop_new (NULL);
#line 60 "../src/PulseAudioManager.vala"
	_pa_glib_mainloop_free0 (self->priv->loop);
#line 60 "../src/PulseAudioManager.vala"
	self->priv->loop = _tmp0_;
#line 61 "../src/PulseAudioManager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 61 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->input_devices);
#line 61 "../src/PulseAudioManager.vala"
	self->priv->input_devices = _tmp1_;
#line 62 "../src/PulseAudioManager.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 62 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->output_devices);
#line 62 "../src/PulseAudioManager.vala"
	self->priv->output_devices = _tmp2_;
#line 63 "../src/PulseAudioManager.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_POINTER, (GBoxedCopyFunc) pa_operation_ref, (GDestroyNotify) pa_operation_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 63 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->volume_operations);
#line 63 "../src/PulseAudioManager.vala"
	self->priv->volume_operations = _tmp3_;
#line 65 "../src/PulseAudioManager.vala"
	_tmp4_ = g_getenv ("G_MESSAGES_DEBUG");
#line 65 "../src/PulseAudioManager.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 65 "../src/PulseAudioManager.vala"
	messagesDebugRaw = _tmp5_;
#line 66 "../src/PulseAudioManager.vala"
	_tmp6_ = messagesDebugRaw;
#line 66 "../src/PulseAudioManager.vala"
	if (_tmp6_ != NULL) {
#line 6521 "PulseAudioManager.c"
		gchar** messagesDebug = NULL;
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint messagesDebug_length1;
		gint _messagesDebug_size_;
		gboolean _tmp10_ = FALSE;
		gchar** _tmp11_;
		gint _tmp11__length1;
#line 67 "../src/PulseAudioManager.vala"
		_tmp7_ = messagesDebugRaw;
#line 67 "../src/PulseAudioManager.vala"
		_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, " ", 0);
#line 67 "../src/PulseAudioManager.vala"
		messagesDebug = _tmp9_;
#line 67 "../src/PulseAudioManager.vala"
		messagesDebug_length1 = _vala_array_length (_tmp8_);
#line 67 "../src/PulseAudioManager.vala"
		_messagesDebug_size_ = messagesDebug_length1;
#line 68 "../src/PulseAudioManager.vala"
		_tmp11_ = messagesDebug;
#line 68 "../src/PulseAudioManager.vala"
		_tmp11__length1 = messagesDebug_length1;
#line 68 "../src/PulseAudioManager.vala"
		if (_vala_string_array_contains (_tmp11_, _tmp11__length1, "all")) {
#line 68 "../src/PulseAudioManager.vala"
			_tmp10_ = TRUE;
#line 6549 "PulseAudioManager.c"
		} else {
			gchar** _tmp12_;
			gint _tmp12__length1;
#line 68 "../src/PulseAudioManager.vala"
			_tmp12_ = messagesDebug;
#line 68 "../src/PulseAudioManager.vala"
			_tmp12__length1 = messagesDebug_length1;
#line 68 "../src/PulseAudioManager.vala"
			_tmp10_ = _vala_string_array_contains (_tmp12_, _tmp12__length1, "debug");
#line 6559 "PulseAudioManager.c"
		}
#line 68 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_DEBUG_ENABLED = _tmp10_;
#line 66 "../src/PulseAudioManager.vala"
		messagesDebug = (_vala_array_free (messagesDebug, messagesDebug_length1, (GDestroyNotify) g_free), NULL);
#line 6565 "PulseAudioManager.c"
	}
#line 59 "../src/PulseAudioManager.vala"
	_g_free0 (messagesDebugRaw);
#line 59 "../src/PulseAudioManager.vala"
	return obj;
#line 6571 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_class_init (SoundPulseAudioManagerClass * klass,
                                      gpointer klass_data)
{
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/PulseAudioManager.vala"
	g_type_class_adjust_private_offset (klass, &SoundPulseAudioManager_private_offset);
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_pulse_audio_manager_get_property;
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_pulse_audio_manager_set_property;
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_pulse_audio_manager_constructor;
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_pulse_audio_manager_finalize;
#line 29 "../src/PulseAudioManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY] = g_param_spec_pointer ("context", "context", "context", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/PulseAudioManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY] = g_param_spec_object ("default-output", "default-output", "default-output", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/PulseAudioManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY] = g_param_spec_object ("default-input", "default-input", "default-input", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL] = g_signal_new ("new-device", SOUND_TYPE_PULSE_AUDIO_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SOUND_TYPE_DEVICE);
#line 6598 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_instance_init (SoundPulseAudioManager * self,
                                         gpointer klass)
{
#line 29 "../src/PulseAudioManager.vala"
	self->priv = sound_pulse_audio_manager_get_instance_private (self);
#line 45 "../src/PulseAudioManager.vala"
	self->priv->is_ready = FALSE;
#line 46 "../src/PulseAudioManager.vala"
	self->priv->reconnect_timer_id = 0U;
#line 6611 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_finalize (GObject * obj)
{
	SoundPulseAudioManager * self;
#line 29 "../src/PulseAudioManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 43 "../src/PulseAudioManager.vala"
	_pa_context_unref0 (self->priv->_context);
#line 44 "../src/PulseAudioManager.vala"
	_pa_glib_mainloop_free0 (self->priv->loop);
#line 47 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->input_devices);
#line 48 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->output_devices);
#line 49 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->_default_output);
#line 50 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->_default_input);
#line 51 "../src/PulseAudioManager.vala"
	_g_free0 (self->priv->default_source_name);
#line 52 "../src/PulseAudioManager.vala"
	_g_free0 (self->priv->default_sink_name);
#line 53 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->volume_operations);
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class)->finalize (obj);
#line 6640 "PulseAudioManager.c"
}

GType
sound_pulse_audio_manager_get_type (void)
{
	static volatile gsize sound_pulse_audio_manager_type_id__volatile = 0;
	if (g_once_init_enter (&sound_pulse_audio_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SoundPulseAudioManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_pulse_audio_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPulseAudioManager), 0, (GInstanceInitFunc) sound_pulse_audio_manager_instance_init, NULL };
		GType sound_pulse_audio_manager_type_id;
		sound_pulse_audio_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundPulseAudioManager", &g_define_type_info, 0);
		SoundPulseAudioManager_private_offset = g_type_add_instance_private (sound_pulse_audio_manager_type_id, sizeof (SoundPulseAudioManagerPrivate));
		g_once_init_leave (&sound_pulse_audio_manager_type_id__volatile, sound_pulse_audio_manager_type_id);
	}
	return sound_pulse_audio_manager_type_id__volatile;
}

static void
_vala_sound_pulse_audio_manager_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 29 "../src/PulseAudioManager.vala"
	switch (property_id) {
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		g_value_set_pointer (value, sound_pulse_audio_manager_get_context (self));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		g_value_set_object (value, sound_pulse_audio_manager_get_default_output (self));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		g_value_set_object (value, sound_pulse_audio_manager_get_default_input (self));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 6685 "PulseAudioManager.c"
		default:
#line 29 "../src/PulseAudioManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 6691 "PulseAudioManager.c"
	}
}

static void
_vala_sound_pulse_audio_manager_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 29 "../src/PulseAudioManager.vala"
	switch (property_id) {
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_context (self, g_value_get_pointer (value));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_output (self, g_value_get_object (value));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_input (self, g_value_get_object (value));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 6723 "PulseAudioManager.c"
		default:
#line 29 "../src/PulseAudioManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 6729 "PulseAudioManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

